package com.nordicpeak.flowengine.queries.alternativelistcheckboxquery;

import java.io.Serializable;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.interfaces.ImmutableAlternative;

@Table(name = "alternative_list_checkbox_query_instance_alternatives")
@XMLElement(name = "Alternative")
public class AlternativeListCheckboxAlternative extends GeneratedElementable implements ImmutableAlternative, Serializable {
	
	
	private static final long serialVersionUID = 5698552791580194144L;
	
	@DAOManaged(columnName = "queryInstanceID")
	@Key
	@ManyToOne
	private AlternativeListCheckboxQueryInstance queryInstance;
	
	@DAOManaged
	@Key
	@XMLElement
	private Integer alternativeID;
	
	@DAOManaged
	@XMLElement
	private String name;
	
	@DAOManaged
	@XMLElement
	private String alternativeXMLValue;
	
	@DAOManaged
	@XMLElement
	private String alternativeAttributeValue;
	
	public AlternativeListCheckboxAlternative() {}
	
	public AlternativeListCheckboxAlternative(ImmutableAlternative alternative) {
		super();
		this.alternativeID = alternative.getAlternativeID();
		this.name = alternative.getName();
		this.alternativeXMLValue = alternative.getExportXMLValue();
		this.alternativeAttributeValue = alternative.getAttributeValue();
	}
	
	@Override
	public Integer getAlternativeID() {
		
		return alternativeID;
	}
	
	public AlternativeListCheckboxQueryInstance getQueryInstance() {
		
		return queryInstance;
	}
	
	@Override
	public String getName() {
		
		return name;
	}
	
	@Override
	public String toString() {
		
		return name + " (alternativeID: " + alternativeID + ")";
	}
	
	@Override
	public int hashCode() {
		
		final int prime = 31;
		int result = 1;
		result = prime * result + ((alternativeID == null) ? 0 : alternativeID.hashCode());
		return result;
	}
	
	@Override
	public boolean equals(Object obj) {
		
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		AlternativeListCheckboxAlternative other = (AlternativeListCheckboxAlternative) obj;
		if (alternativeID == null) {
			if (other.alternativeID != null) {
				return false;
			}
		} else if (!alternativeID.equals(other.alternativeID)) {
			return false;
		}
		return true;
	}
	
	public void setQueryInstance(AlternativeListCheckboxQueryInstance queryInstance) {
		this.queryInstance = queryInstance;
	}
	
	public void setAlternativeID(Integer alternativeID) {
		this.alternativeID = alternativeID;
	}
	
	public void setName(String name) {
		this.name = name;
	}
	
	@Override
	public String getExportXMLValue() {
		return alternativeXMLValue;
	}

	@Override
	public String getAttributeValue() {
		return alternativeAttributeValue;
	}
}
