<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1"/>

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
		/jquery/jquery-migrate.js?v=1
		/jquery/jquery-ui.js?v=1
		/ckeditor/ckeditor.js
		/ckeditor/adapters/jquery.js
		/ckeditor/init.js
	</xsl:variable>

	<xsl:variable name="scripts">
		/common/js/queryadmin.js
		/js/alternativelistdropdownqueryadmin.js
	</xsl:variable>

	<xsl:template match="Document">	
		
		<div id="AlternativeListDropDownQueryProvider" class="contentitem">
		
			<xsl:apply-templates select="validationError"/>
			<xsl:apply-templates select="UpdateAlternativeListDropDownQuery"/>
		
		</div>
		
	</xsl:template>
		
	<xsl:template match="UpdateAlternativeListDropDownQuery">
	
		<h1><xsl:value-of select="$i18n.UpdateQuery" /><xsl:text>:&#160;</xsl:text><xsl:value-of select="AlternativeListDropDownQuery/QueryDescriptor/name" /></h1>
		
		<xsl:apply-templates select="validationException/validationError" />
		
		<form id="updateAlternativeListDropDownQueryForm" name="queryAdminForm" method="post" action="{/Document/requestinfo/uri}">
					
			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="AlternativeListDropDownQuery" />
			</xsl:call-template>
			
			<div class="floatleft full bigmarginbottom">
			
			<div class="floatleft full bigmarginbottom" id="exportIDDiv" style="display:none">
					<div class="floatleft full">
						<xsl:call-template name="createCheckbox">
							<xsl:with-param name="id" select="'exportAlternativeID'" />
							<xsl:with-param name="name" select="'exportAlternativeID'" />
							<xsl:with-param name="element" select="AlternativeListDropDownQuery" />
						</xsl:call-template>
							
						<label for="exportAlternativeID">
							<xsl:value-of select="$i18n.exportAlternativeID" />
						</label>
				    </div>
				    <div class="floatleft fifty">
						<span class="tiny"><xsl:value-of select="$i18n.exportAlternativeIDInformation" /></span>
					</div>
				</div>

				<label for="listName">
					<xsl:value-of select="$i18n.ListName" />
				</label>

				<div class="floatleft full">
				
					<xsl:call-template name="createDropdown">
						<xsl:with-param name="id" select="'listName'"/>
						<xsl:with-param name="name" select="'listName'"/>
						<xsl:with-param name="element" select="Lists/List"/>
						<xsl:with-param name="labelElementName" select="'Name'"/>
						<xsl:with-param name="valueElementName" select="'ID'"/>
						<xsl:with-param name="selectedValue" select="CurrentList"/>
						<xsl:with-param name="class" select="'full'"/>
					</xsl:call-template>
				
				</div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="emptyListDescription" class="floatleft clearboth"><xsl:value-of select="$i18n.EmptyListDescription" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createTextArea">
						<xsl:with-param name="id" select="'emptyListDescription'" />
						<xsl:with-param name="name" select="'emptyListDescription'" />
						<xsl:with-param name="element" select="AlternativeListDropDownQuery" />
						<xsl:with-param name="rows">4</xsl:with-param>
					</xsl:call-template>
				</div>
			</div>
			
			<label for="useFreeTextAlternative" class="floatleft clearboth"><xsl:value-of select="$i18n.FreeTextAlternative" /></label>
				
			<div class="clearboth floatleft marginbottom"><xsl:value-of select="$i18n.FreeTextAlternativeDescription" /></div>
			
			<div class="floatleft full marginbottom">
				<xsl:text>&#160;</xsl:text>
				
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'useFreeTextAlternative'" />
					<xsl:with-param name="name" select="'useFreeTextAlternative'" />
					<xsl:with-param name="title" select="$i18n.FreeTextAlternative" />
					<xsl:with-param name="checked">
						<xsl:if test="AlternativeListDropDownQuery/freeTextAlternative">true</xsl:if>
					</xsl:with-param>
				</xsl:call-template>
				
				<xsl:text>&#160;</xsl:text>
				
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'freeTextAlternative'"/>
					<xsl:with-param name="name" select="'freeTextAlternative'"/>
					<xsl:with-param name="title" select="$i18n.FreeTextAlternative"/>
					<xsl:with-param name="value" select="name"/>
					<xsl:with-param name="width" select="'89%'"/>
					<xsl:with-param name="value" select="AlternativeListDropDownQuery/freeTextAlternative"/>
					<xsl:with-param name="disabled" select="'disabled'"/>
				</xsl:call-template>
			</div>
			
			<h2 class="floatleft full bigmargintop"><xsl:value-of select="$i18n.AdvancedSettings" /></h2>
			
			<div class="floatleft full bigmarginbottom">
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'setAsAttribute'" />
						<xsl:with-param name="name" select="'setAsAttribute'" />
						<xsl:with-param name="element" select="AlternativeListDropDownQuery" /> 
						<xsl:with-param name="class" select="'vertical-align-middle'" />
					</xsl:call-template>
						
					<label for="setAsAttribute">
						<xsl:value-of select="$i18n.setAsAttribute" />
					</label>
				</div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="attributeName" class="floatleft clearboth"><xsl:value-of select="$i18n.attributeName" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'attributeName'"/>
						<xsl:with-param name="name" select="'attributeName'"/>
						<xsl:with-param name="title" select="$i18n.attributeName"/>
						<xsl:with-param name="element" select="AlternativeListDropDownQuery" />
						<xsl:with-param name="maxlength" select="'255'"/>
					</xsl:call-template>
				</div>
			</div>

			<div class="floatleft full bigmarginbottom">
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'setIDAttribute'" />
						<xsl:with-param name="name" select="'setIDAttribute'" />
						<xsl:with-param name="element" select="AlternativeListDropDownQuery" /> 
						<xsl:with-param name="class" select="'vertical-align-middle'" />
					</xsl:call-template>
						
					<label for="setIDAttribute">
						<xsl:value-of select="$i18n.setIDAttribute" />
					</label>
				</div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="idAttributeName" class="floatleft clearboth"><xsl:value-of select="$i18n.idAttributeName" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'idAttributeName'"/>
						<xsl:with-param name="name" select="'idAttributeName'"/>
						<xsl:with-param name="title" select="$i18n.idAttributeName"/>
						<xsl:with-param name="element" select="AlternativeListDropDownQuery" />
						<xsl:with-param name="maxlength" select="'255'"/>
					</xsl:call-template>
				</div>
			</div>		
							
			<div class="floatleft full bigmarginbottom">

				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'lockForManagerUpdate'" />
						<xsl:with-param name="name" select="'lockForManagerUpdate'" />
						<xsl:with-param name="value" select="'true'" />
						<xsl:with-param name="element" select="AlternativeListDropDownQuery" />
					</xsl:call-template>
					
					<label for="lockForManagerUpdate">
						<xsl:value-of select="$i18n.lockForManagerUpdate" />
					</label>
				</div>

			</div>
			
			<div class="floatright margintop clearboth">
				<input type="submit" value="{$i18n.SaveChanges}" />
			</div>
		
		</form>
		
	</xsl:template>
	
	<xsl:template name="appendCreateCommonFieldsFormConterAfterName">
	
		<div class="floatleft full bigmarginbottom">
			<label for="shortDescription" class="floatleft clearboth"><xsl:value-of select="$i18n.ShortDescription" /></label>
			<div class="floatleft full">
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'shortDescription'"/>
					<xsl:with-param name="name" select="'shortDescription'"/>
					<xsl:with-param name="title" select="$i18n.ShortDescription"/>
					<xsl:with-param name="element" select="AlternativeListDropDownQuery" />
				</xsl:call-template>
			</div>
		</div>
	
	</xsl:template>

	<xsl:template match="validationError[messageKey = 'UpdateFailedAlternativeListDropDownQueryNotFound']">
		
		<p class="error">
			<xsl:value-of select="$i18n.AlternativeListDropDownQueryNotFound" />
		</p>
		
	</xsl:template>

	<xsl:template match="fieldName">
	
		<xsl:variable name="fieldName" select="." />
	
		<xsl:choose>
			<xsl:when test="$fieldName = 'shortDescription'">
				<xsl:value-of select="$i18n.shortDescription" />
			</xsl:when>
			<xsl:when test="$fieldName = 'listName'">
				<xsl:value-of select="$i18n.ListName" />
			</xsl:when>
			<xsl:when test="$fieldName = 'attributeName'">
				<xsl:value-of select="$i18n.attributeName" />
			</xsl:when>
			<xsl:when test="$fieldName = 'idAttributeName'">
				<xsl:value-of select="$i18n.idAttributeName" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>
		
	</xsl:template>

</xsl:stylesheet>