$(function() {
	
	setQueryRequiredFunctions["AlternativeListDropDownQueryInstance"] = makeAlternativeListDropDownQueryRequired;
});

function initAlternativeListDropDownQuery(queryID, locked) {
	
	var $query = $("#query_" + queryID);
	
	if ($query.hasClass("hasFreeTextAlternative")) {
		
		var $select = $query.find("select");
		
		$select.on("change", function(e, data) {
			
			var $this = $(this);
			
			var $freeTextInput = $("#" + $this.attr("name") + "Value");
			
			if ($this.val() == "freeTextAlternative") {
				
				$freeTextInput.parent().show();
				
				locked === "true" ? $freeTextInput.attr("disabled", "disabled") : $freeTextInput.removeAttr("disabled");
				
			} else {
				
				$freeTextInput.attr("disabled", "disabled").parent().hide();
			}
			
			if (data == undefined || !data.manual) {
			
				if($query.hasClass("enableAjaxPosting")) {
					
					runAlternativeListDropDownEvaluators($this, queryID);
				};
			}
		});
		
		$select.trigger("change", [{manual: true}]);
		
	} else {
		
		if($query.hasClass("enableAjaxPosting")) {
			
			$query.find("select").on("change", function() {
				
				runAlternativeListDropDownEvaluators($(this), queryID);
			});
		}
	}
}

function runAlternativeListDropDownEvaluators($this, queryID) {
	
	var parameters = {};
	
	parameters[$this.attr("name")] = $this.val();
	
	if($this.val() == "freeTextAlternative"){
		
		parameters["q" + queryID + "_alternativeValue"] = $("#q" + queryID + "_alternativeValue").val();
	}
	
	runQueryEvaluators(queryID, parameters);
}

function makeAlternativeListDropDownQueryRequired(queryID) {
	
	$("#query_" + queryID).find(".heading-wrapper h2").addClass("required");
}
