<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />
	
	<xsl:template match="Document">

		<div class="contentitem">

			<xsl:apply-templates select="UpdateAnonymousPosterEvaluator" />
			
		</div>

	</xsl:template>

	<xsl:template match="UpdateAnonymousPosterEvaluator">

		<h1>
			<xsl:value-of select="$i18n.UpdateEvaluatorDescriptor.title" />
			<xsl:text>&#x20;</xsl:text>
			<xsl:value-of select="AnonymousPosterEvaluator/EvaluatorDescriptor/name" />
		</h1>
		
		<p><xsl:value-of select="$i18n.Description" /></p>

		<xsl:apply-templates select="validationException/validationError" />

		<form method="post" action="{/Document/requestinfo/uri}">

			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="AnonymousPosterEvaluator" />
			</xsl:call-template>
			
			<label class="floatleft">
				<xsl:value-of select="$i18n.selectionMode.title" />
			</label>

			<div class="clearboth floatleft marginbottom">
				<xsl:value-of select="$i18n.selectionMode.description" />
			</div>

			<div class="floatleft full marginbottom">

				<div class="floatleft full">
					<xsl:call-template name="createRadio">
						<xsl:with-param name="id" select="'any'" />
						<xsl:with-param name="name" select="'selectionMode'" />
						<xsl:with-param name="value" select="'ANY'" />
						<xsl:with-param name="element" select="AnonymousPosterEvaluator" />
					</xsl:call-template>

					<label for="any">
						<xsl:value-of select="$i18n.SelectionMode.ANY" />
					</label>
				</div>
			</div>

			<div class="floatleft full marginbottom">

				<div class="floatleft full">
					<xsl:call-template name="createRadio">
						<xsl:with-param name="id" select="'all'" />
						<xsl:with-param name="name" select="'selectionMode'" />
						<xsl:with-param name="value" select="'ALL'" />
						<xsl:with-param name="element" select="AnonymousPosterEvaluator" />
					</xsl:call-template>

					<label for="all">
						<xsl:value-of select="$i18n.SelectionMode.ALL" />
					</label>
				</div>
			</div>

			<label class="floatleft">
				<xsl:value-of select="$i18n.alternatives.title" />
			</label>

			<div class="clearboth floatleft marginbottom">
				<xsl:value-of select="$i18n.alternatives.description" />
			</div>

			<xsl:choose>
				<xsl:when test="Alternatives/Alternative">
					<xsl:apply-templates select="Alternatives/Alternative" />
					
					<xsl:if test="Alternatives/FreeTextAlternative">
					
						<div class="floatleft full marginbottom">
				
							<div class="floatleft full">
								<xsl:call-template name="createCheckbox">
									<xsl:with-param name="id" select="'freeTextAlternative'"/>
									<xsl:with-param name="name" select="'freeTextAlternative'" />
									<xsl:with-param name="value" select="'true'" />
									<xsl:with-param name="element" select="AnonymousPosterEvaluator" />
								</xsl:call-template>
				
								<label for="freeTextAlternative">
									<xsl:value-of select="Alternatives/FreeTextAlternative" />
								</label>
							</div>
						</div>
					
					</xsl:if>
					
				</xsl:when>
				<xsl:otherwise>
					<p class="floatleft full">
						<xsl:value-of select="$i18n.QueryHasNoAlternatives" />
					</p>
				</xsl:otherwise>
			</xsl:choose>

			<div class="floatright clearboth">
				<input type="submit" value="{$i18n.Submit}" />
			</div>

		</form>

	</xsl:template>
	
	<xsl:template match="Alternative">

		<div class="floatleft full marginbottom">

			<div class="floatleft full">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id">
						<xsl:value-of select="'alternative'"/>
						<xsl:value-of select="alternativeID"/>
					</xsl:with-param>				
					<xsl:with-param name="name" select="'alternativeID'" />
					<xsl:with-param name="value" select="alternativeID" />
					<xsl:with-param name="element" select="../../AnonymousPosterEvaluator/AlternativeIDs" />
				</xsl:call-template>

				<label for="alternative{alternativeID}">
					<xsl:value-of select="name" />
				</label>
			</div>
		</div>

	</xsl:template>
	
	<xsl:template match="fieldName">

		<xsl:variable name="fieldName" select="." />

		<xsl:choose>
			<xsl:when test="$fieldName = 'selectionMode'">
				<xsl:value-of select="$i18n.selectionMode" />
			</xsl:when>
			<xsl:when test="$fieldName = 'alternativeID'">
				<xsl:value-of select="$i18n.Alternative" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>
	
</xsl:stylesheet>