var i18n = {
	"DropdownEmptyAlternativeDefault": ""
};

$(function() {

	$("#columnType").on("change", function(e, initialize) {
		
		var columnType = this.value;

		var columnTypeIsString = columnType == "STRING";

		$("#formatValidator, #minContentLength, #maxContentLength")
			.prop("disabled", !columnTypeIsString)
			.parent().parent().toggle(columnTypeIsString);

		$("#formatValidator").on("change", function() {

			var className = columnTypeIsString && this.value;
			var validationMessage = className ? $("#validatorMessage-" + className.replace(/\./g, "_")).val() : "";

			$("#invalidFormatMessage")
				.prop("disabled", !className)
				.val(validationMessage)
				.parent().parent().toggle(!!className);

		});

		var columnTypeIsTextArea = columnType == "TEXTAREA";

		$("#textAreaRows")
			.prop("disabled", !columnTypeIsTextArea)
			.parent().parent().toggle(columnTypeIsTextArea);

		var columnTypeIsDropDown = columnType == "DROPDOWN";

		$("#dropdownAlternatives")
			.toggle(columnTypeIsDropDown)
			.find(".alternatives input").prop('disabled', !columnTypeIsDropDown);

		var columnTypeIsDropDownAlternativeList = columnType == "DROPDOWN_ALTERNATIVE_LIST";
		var columnTypeIsListSearch = columnType == "LIST_SEARCH";

		var shouldShowAlternativeListAlternatives = columnTypeIsDropDownAlternativeList || columnTypeIsListSearch;
		
		$("#alternativeListAlternatives")
			.toggle(shouldShowAlternativeListAlternatives)
			.find("#listName").prop('disabled', !shouldShowAlternativeListAlternatives);

		var shouldShowDropDownEmptyAlternative = columnTypeIsDropDown || columnTypeIsDropDownAlternativeList;

		$("#dropdownEmptyAlternative")
			.toggle(shouldShowDropDownEmptyAlternative)
			.find("input").prop('disabled', !shouldShowDropDownEmptyAlternative);

		if (shouldShowDropDownEmptyAlternative && !initialize) {

			$("#dropdownChooseText").val(i18n.DropdownEmptyAlternativeDefault);
		}

		var columnTypeIsRowSumAdd = columnType == "ROWSUM_ADD";
		var columnTypeIsRowSumMultiply = columnType == "ROWSUM_MULTIPLY";
		var columnTypeIsRowSum = columnTypeIsRowSumAdd || columnTypeIsRowSumMultiply;

		$("#rowSumAddColumns, #rowSumSubtractColumns")
			.toggle(columnTypeIsRowSum)
			.find("input").prop("disabled", !columnTypeIsRowSum)
			.end()
			.find("p.add").toggle(columnTypeIsRowSumAdd)
			.end()
			.find("p.multiply").toggle(columnTypeIsRowSumMultiply);
			
		$("#listSearchSettings")
			.toggle(columnTypeIsListSearch)
			.find("input").prop("disabled", !columnTypeIsListSearch);

	}).trigger("change", true);

});