<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:exsl="http://exslt.org/common">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
		/js/confirmpost.js
	</xsl:variable>

	<xsl:template name="ListTableColumns">

		<th>
			<xsl:value-of select="$i18n.Name" />
		</th>
		<th class="nosort" style="width: 61px;"></th>

	</xsl:template>

	<xsl:template match="AlternativeList" mode="list">

		<xsl:variable name="name" select="name" />

		<tr>
			<td data-title="{$i18n.Name}">
				<a href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/show/{listID}">
					<xsl:value-of select="name" />
				</a>
			</td>
			<td>
				<a href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/usage/{listID}" title="{$i18n.FlowUsage.Button}">
					<img class="alignbottom"
						src="{/Document/requestinfo/contextpath}/static/f/{/Document/module/sectionID}/{/Document/module/moduleID}/pics/magnifying_glass.png" alt="" />
				</a>

				<a class="marginleft" href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/update/{listID}" title="{$i18n.UpdateList}: {name}">
					<img class="alignbottom" src="{/Document/requestinfo/contextpath}/static/f/{/Document/module/sectionID}/{/Document/module/moduleID}/pics/pen.png"
						alt="" />
				</a>

				<a class="marginleft" href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/delete/{listID}"
					onclick="return confirmHyperlinkPost(this);" title="{$i18n.DeleteList}: {name}">
					<img class="alignbottom" src="{/Document/requestinfo/contextpath}/static/f/{/Document/module/sectionID}/{/Document/module/moduleID}/pics/delete.png"
						alt="" />
				</a>
			</td>
		</tr>

	</xsl:template>

	<xsl:template match="ShowAlternativeList">

		<div class="floatright">
			<a href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/update/{AlternativeList/listID}" title="{$i18n.UpdateList}">
				<img class="alignbottom" src="{/Document/requestinfo/contextpath}/static/f/{/Document/module/sectionID}/{/Document/module/moduleID}/pics/pen.png" alt="" />
			</a>

			<xsl:choose>
				<xsl:when test="Queries/Flow">

					<a class="marginleft" href="#" onclick="alert('{$i18n.DeleteListBlockedInUse}'); return false;" title="{$i18n.DeleteListBlockedInUse}">
						<img class="alignbottom"
							src="{/Document/requestinfo/contextpath}/static/f/{/Document/module/sectionID}/{/Document/module/moduleID}/pics/delete_gray.png" alt="" />
					</a>

				</xsl:when>
				<xsl:otherwise>

					<a class="marginleft" href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/delete/{AlternativeList/listID}"
						onclick="return confirmHyperlinkPost(this);" title="{$i18n.DeleteList} {AlternativeList/name}">
						<img class="alignbottom" src="{/Document/requestinfo/contextpath}/static/f/{/Document/module/sectionID}/{/Document/module/moduleID}/pics/delete.png"
							alt="" />
					</a>

				</xsl:otherwise>
			</xsl:choose>

		</div>

		<h1>
			<xsl:value-of select="$i18n.Show" />
			<xsl:text>:&#160;</xsl:text>
			<xsl:value-of select="AlternativeList/name" />
		</h1>

		<p>
			<xsl:value-of select="$i18n.ShowAlternativeList.description" />
		</p>

		<xsl:apply-templates select="validationException/validationError" />
		<xsl:apply-templates select="validationError" />

		<ul>
			<xsl:if test="AlternativeList/allowVehicleType1 = 'true'">
				<li>
					<strong>
						<xsl:value-of select="$i18n.Settings.showVehicleType1" />
					</strong>
				</li>
			</xsl:if>

			<xsl:if test="AlternativeList/allowVehicleType2 = 'true'">
				<li>
					<strong>
						<xsl:value-of select="$i18n.Settings.showVehicleType2" />
					</strong>
				</li>
			</xsl:if>

			<xsl:if test="AlternativeList/allowVehicleType3 = 'true'">
				<li>
					<strong>
						<xsl:value-of select="$i18n.Settings.showVehicleType3" />
					</strong>
				</li>
			</xsl:if>

			<xsl:if test="AlternativeList/allowVehicleType4 = 'true'">
				<li>
					<strong>
						<xsl:value-of select="$i18n.Settings.showVehicleType4" />
					</strong>
				</li>
			</xsl:if>

			<xsl:if test="AlternativeList/allowVehicleType5 = 'true'">
				<li>
					<strong>
						<xsl:value-of select="$i18n.Settings.showVehicleType5" />
					</strong>
				</li>
			</xsl:if>

			<xsl:if test="AlternativeList/allowVehicleType6 = 'true'">
				<li>
					<strong>
						<xsl:value-of select="$i18n.Settings.showVehicleType6" />
					</strong>
				</li>
			</xsl:if>

			<xsl:if test="AlternativeList/allowVehicleType7 = 'true'">
				<li>
					<strong>
						<xsl:value-of select="$i18n.Settings.showVehicleType7" />
					</strong>
				</li>
			</xsl:if>

			<xsl:if test="AlternativeList/allowVehicleType13 = 'true'">
				<li>
					<strong>
						<xsl:value-of select="$i18n.Settings.showVehicleType13" />
					</strong>
				</li>
			</xsl:if>

			<xsl:if test="AlternativeList/allowTerrainVehicle = 'true'">
				<li>
					<strong>
						<xsl:value-of select="$i18n.Settings.showTerrainVehicle" />
					</strong>
				</li>
			</xsl:if>
		</ul>

		<fieldset>
			<legend>
				<xsl:value-of select="$i18n.Events.Title" />
			</legend>

			<p class="nomargin">
				<xsl:value-of select="$i18n.Events.Description" />
			</p>

			<xsl:choose>
				<xsl:when test="Events/AlternativeListEvent">

					<table class="full coloredtable sortabletable oep-table" cellspacing="0">
						<thead>
							<tr>
								<th>
									<xsl:value-of select="$i18n.Events.message" />
								</th>
								<th>
									<xsl:value-of select="$i18n.Events.poster" />
								</th>
								<th>
									<xsl:value-of select="$i18n.Events.added" />
								</th>
							</tr>
						</thead>
						<tbody>

							<xsl:apply-templates select="Events/AlternativeListEvent" mode="list" />

						</tbody>
					</table>

				</xsl:when>
				<xsl:otherwise>
					<p>
						<xsl:value-of select="$i18n.Events.NoEvents" />
					</p>
				</xsl:otherwise>
			</xsl:choose>

			<div class="floatright marginright">
				<a href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/events/{AlternativeList/listID}" title="{$i18n.Events.ShowAll}">
					<xsl:value-of select="$i18n.Events.ShowAll" />
				</a>
			</div>

		</fieldset>

		<a class="btn btn-blue floatright margintop" href="{/Document/requestinfo/currentURI}/{/Document/module/alias}">
			<xsl:value-of select="$i18n.Back" />
		</a>

	</xsl:template>

	<xsl:template name="editListDetails">

		<div class="floatleft full bigmarginbottom">
			<div class="floatleft full">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'allowVehicleType1'" />
					<xsl:with-param name="name" select="'allowVehicleType1'" />
					<xsl:with-param name="element" select="AlternativeList" />
					<xsl:with-param name="title" select="$i18n.Settings.allowVehicleType1" />
					<xsl:with-param name="class" select="'vertical-align-middle'" />
				</xsl:call-template>

				<label for="allowVehicleType1">
					<xsl:value-of select="$i18n.Settings.allowVehicleType1" />
				</label>
			</div>
		</div>

		<div class="floatleft full bigmarginbottom">
			<div class="floatleft full">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'allowVehicleType2'" />
					<xsl:with-param name="name" select="'allowVehicleType2'" />
					<xsl:with-param name="element" select="AlternativeList" />
					<xsl:with-param name="title" select="$i18n.Settings.allowVehicleType2" />
					<xsl:with-param name="class" select="'vertical-align-middle'" />
				</xsl:call-template>

				<label for="allowVehicleType2">
					<xsl:value-of select="$i18n.Settings.allowVehicleType2" />
				</label>
			</div>
		</div>

		<div class="floatleft full bigmarginbottom">
			<div class="floatleft full">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'allowVehicleType3'" />
					<xsl:with-param name="name" select="'allowVehicleType3'" />
					<xsl:with-param name="element" select="AlternativeList" />
					<xsl:with-param name="title" select="$i18n.Settings.allowVehicleType3" />
					<xsl:with-param name="class" select="'vertical-align-middle'" />
				</xsl:call-template>

				<label for="allowVehicleType3">
					<xsl:value-of select="$i18n.Settings.allowVehicleType3" />
				</label>
			</div>
		</div>

		<div class="floatleft full bigmarginbottom">
			<div class="floatleft full">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'allowVehicleType4'" />
					<xsl:with-param name="name" select="'allowVehicleType4'" />
					<xsl:with-param name="element" select="AlternativeList" />
					<xsl:with-param name="title" select="$i18n.Settings.allowVehicleType4" />
					<xsl:with-param name="class" select="'vertical-align-middle'" />
				</xsl:call-template>

				<label for="allowVehicleType4">
					<xsl:value-of select="$i18n.Settings.allowVehicleType4" />
				</label>
			</div>
		</div>

		<div class="floatleft full bigmarginbottom">
			<div class="floatleft full">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'allowVehicleType5'" />
					<xsl:with-param name="name" select="'allowVehicleType5'" />
					<xsl:with-param name="element" select="AlternativeList" />
					<xsl:with-param name="title" select="$i18n.Settings.allowVehicleType5" />
					<xsl:with-param name="class" select="'vertical-align-middle'" />
				</xsl:call-template>

				<label for="allowVehicleType5">
					<xsl:value-of select="$i18n.Settings.allowVehicleType5" />
				</label>
			</div>
		</div>

		<div class="floatleft full bigmarginbottom">
			<div class="floatleft full">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'allowVehicleType6'" />
					<xsl:with-param name="name" select="'allowVehicleType6'" />
					<xsl:with-param name="element" select="AlternativeList" />
					<xsl:with-param name="title" select="$i18n.Settings.allowVehicleType6" />
					<xsl:with-param name="class" select="'vertical-align-middle'" />
				</xsl:call-template>

				<label for="allowVehicleType6">
					<xsl:value-of select="$i18n.Settings.allowVehicleType6" />
				</label>
			</div>
		</div>

		<div class="floatleft full bigmarginbottom">
			<div class="floatleft full">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'allowVehicleType7'" />
					<xsl:with-param name="name" select="'allowVehicleType7'" />
					<xsl:with-param name="element" select="AlternativeList" />
					<xsl:with-param name="title" select="$i18n.Settings.allowVehicleType7" />
					<xsl:with-param name="class" select="'vertical-align-middle'" />
				</xsl:call-template>

				<label for="allowVehicleType7">
					<xsl:value-of select="$i18n.Settings.allowVehicleType7" />
				</label>
			</div>
		</div>

		<div class="floatleft full bigmarginbottom">
			<div class="floatleft full">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'allowVehicleType13'" />
					<xsl:with-param name="name" select="'allowVehicleType13'" />
					<xsl:with-param name="element" select="AlternativeList" />
					<xsl:with-param name="title" select="$i18n.Settings.allowVehicleType13" />
					<xsl:with-param name="class" select="'vertical-align-middle'" />
				</xsl:call-template>

				<label for="allowVehicleType13">
					<xsl:value-of select="$i18n.Settings.allowVehicleType13" />
				</label>
			</div>
		</div>

		<div class="floatleft full bigmarginbottom">
			<div class="floatleft full">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'allowTerrainVehicle'" />
					<xsl:with-param name="name" select="'allowTerrainVehicle'" />
					<xsl:with-param name="element" select="AlternativeList" />
					<xsl:with-param name="title" select="$i18n.Settings.allowTerrainVehicle" />
					<xsl:with-param name="class" select="'vertical-align-middle'" />
				</xsl:call-template>

				<label for="allowTerrainVehicle">
					<xsl:value-of select="$i18n.Settings.allowTerrainVehicle" />
				</label>
			</div>
		</div>

	</xsl:template>

	<xsl:template match="fieldName">

		<xsl:variable name="fieldName" select="." />

		<xsl:choose>
			<xsl:when test="$fieldName = ''">
				<xsl:value-of select="''" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>

</xsl:stylesheet>