package com.nordicpeak.flowengine.biznodevehiclealternativelist;

import java.io.Serializable;

import com.nordicpeak.flowengine.interfaces.ImmutableAlternative;

import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@XMLElement(name = "Alternative")
class ExternalAlternative extends GeneratedElementable implements ImmutableAlternative, Serializable, Comparable<ExternalAlternative> {

	private static final long serialVersionUID = -5630567666409641568L;

	@XMLElement
	private Integer alternativeID;

	@XMLElement
	private String name;

	@XMLElement
	private String attributeValue;

	
	protected ExternalAlternative() {}

	public ExternalAlternative(Integer alternativeID, String name) {

		super();

		this.alternativeID = alternativeID;
		this.name = name;
	}

	@Override
	public Integer getAlternativeID() {

		return alternativeID;
	}

	@Override
	public String getName() {

		return name;
	}

	public void setKey(String string) {

		alternativeID = Integer.parseInt(string);
	}

	public void setAttributeValue(String attributeValue) {
		
		this.attributeValue = attributeValue;
	}
	
	@Override
	public String toString() {

		return name + " (ID:" + alternativeID + ")";
	}

	@Override
	public String getExportXMLValue() {

		return null;
	}

	@Override
	public String getAttributeValue() {

		return attributeValue;
	}

	@Override
	public int compareTo(ExternalAlternative o) {

		return name.compareTo(o.getName());
	}
}
