package com.nordicpeak.flowengine.biznodevehiclealternativelist;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.hierarchy.core.utils.crud.IntegerBeanIDParser;
import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.webutils.http.BeanRequestPopulator;
import se.unlogic.webutils.http.URIParser;

import com.nordicpeak.flowengine.alternativelist.provider.BaseAlternativeListCRUD;

public class ListSourceCRUD extends BaseAlternativeListCRUD<ListSource, BiznodeVehicleAlternativeListInstance, ListSourceCRUD, BiznodeVehicleAlternativeListProviderModule, ListSourceEvent> {

	public ListSourceCRUD(AnnotatedDAOWrapper<ListSource, Integer> queryDAO, BeanRequestPopulator<ListSource> populator, BiznodeVehicleAlternativeListProviderModule callback) {

		super(IntegerBeanIDParser.getInstance(), queryDAO, populator, "AlternativeList", "list source", "/", callback);
		
		setRequirePostForDelete(true);
	}

	@Override
	protected void validateAddPopulation(ListSource source, HttpServletRequest req, User user, URIParser uriParser) throws ValidationException, SQLException, Exception {

		super.validateAddPopulation(source, req, user, uriParser);
		validate(source, req, user, uriParser);
	}

	@Override
	protected void validateUpdatePopulation(ListSource source, HttpServletRequest req, User user, URIParser uriParser) throws ValidationException, SQLException, Exception {

		super.validateUpdatePopulation(source, req, user, uriParser);
		validate(source, req, user, uriParser);
	}

	protected void validate(ListSource source, HttpServletRequest req, User user, URIParser uriParser) throws ValidationException, Exception {

		List<ValidationError> validationErrors = new ArrayList<ValidationError>();

		super.validate(source, req, user, uriParser, validationErrors);

		if (!validationErrors.isEmpty()) {
			throw new ValidationException(validationErrors);
		}
	}

}
