package com.nordicpeak.flowengine.booking.beans;

import java.io.Serializable;
import java.sql.Blob;
import java.sql.Timestamp;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.io.BinarySizeFormater;
import se.unlogic.standardutils.string.StringUtils;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLUtils;

public abstract class BaseAttachment extends GeneratedElementable implements Serializable {

	private static final long serialVersionUID = -6932106553528304903L;

	@DAOManaged(autoGenerated = true)
	@Key
	@XMLElement
	protected Integer attachmentID;

	@DAOManaged
	@XMLElement
	private String filename;

	@DAOManaged
	@XMLElement
	private Long size;

	@DAOManaged
	@XMLElement
	private Timestamp added;

	@DAOManaged
	@XMLElement
	private Blob data;

	public abstract BaseMessage getMessage();

	public Integer getAttachmentID() {

		return attachmentID;
	}

	public void setAttachmentID(Integer attachmentID) {

		this.attachmentID = attachmentID;
	}

	public String getFilename() {

		return filename;
	}

	public void setFilename(String filename) {

		this.filename = filename;
	}

	public Long getSize() {

		return size;
	}

	public void setSize(Long size) {

		this.size = size;
	}

	public Timestamp getAdded() {

		return added;
	}

	public void setAdded(Timestamp added) {

		this.added = added;
	}

	public Blob getData() {

		return data;
	}

	public void setData(Blob data) {

		this.data = data;
	}

	@Override
	public Element toXML(Document doc) {

		Element attachmentElement = super.toXML(doc);

		XMLUtils.appendNewElement(doc, attachmentElement, "FormatedSize", BinarySizeFormater.getFormatedSize(size));

		return attachmentElement;
	}

	@Override
	public String toString() {

		return StringUtils.toLogFormat(filename, 50) + " (ID: " + attachmentID + ")";
	}
}
