package com.nordicpeak.flowengine.booking.listeners;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.hierarchy.core.handlers.UserHandler;
import se.unlogic.standardutils.xml.ElementableListener;

import com.nordicpeak.flowengine.booking.beans.Booking;
import com.nordicpeak.flowengine.booking.beans.BookingCalendar;

public class BookingUserTypeElementableListener implements ElementableListener<Booking> {

	private final UserHandler userHandler;
	
	private final BookingCalendar calendar;

	private final boolean includeSMS;

	private final boolean overrideContactBySMS;

	public BookingUserTypeElementableListener(UserHandler userHandler, BookingCalendar calendar, boolean includeSMS, boolean overrideContactBySMS) {

		this.userHandler = userHandler;
		this.calendar = calendar;
		this.includeSMS = includeSMS;
		this.overrideContactBySMS = overrideContactBySMS;
	}

	@Override
	public void elementGenerated(Document doc, Element element, Booking booking) {

		booking.getPoster(userHandler, calendar);

		booking.appendUserType(doc, element, includeSMS, overrideContactBySMS);
	}

}
