package com.nordicpeak.flowengine.booking.populators.annotations;

import static java.lang.annotation.ElementType.FIELD;
import static java.lang.annotation.RetentionPolicy.RUNTIME;

import java.lang.annotation.Retention;
import java.lang.annotation.Target;

import se.unlogic.standardutils.populators.BeanStringPopulator;
import se.unlogic.standardutils.populators.DummyPopulator;
import se.unlogic.standardutils.xml.XMLParserPopulateable;

import com.nordicpeak.flowengine.evaluators.baseevaluator.BaseEvaluator;

@Retention(RUNTIME)
@Target(FIELD)
//TODO rename XMLPopulate
public @interface PopulateByXMLSettings {

	boolean required() default false;

	long maxLength() default 0;

	long minLength() default 0;

	String nodeName() default "";

	Class<? extends BeanStringPopulator<?>> populator() default DummyPopulator.class;

	Class<? extends XMLParserPopulateable> clazz() default BaseEvaluator.class;

}
