<?xml version="1.0" encoding="ISO-8859-1" standalone="no"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output encoding="ISO-8859-1" method="html" version="4.0"/>

	<xsl:include href="CastorIntegrationProviderTemplates.xsl"/>
	
	<xsl:variable name="java.errorEmailSubject">Fel vid anrop till Castor</xsl:variable>

	<xsl:variable name="java.errorEmailMessage">
		
		&lt;p&gt;Misslyckat anrop till Castor fr rende $flow.name (rende nr. $flowInstance.flowInstanceID).&lt;/p&gt;
		
		&lt;p&gt;Klicka p lnken nedan fr att visa rendet:&lt;/p&gt;
		
		&lt;p&gt;
			&lt;a href="$flowInstance.url"&gt;$flowInstance.url&lt;/a&gt;
		&lt;/p&gt;
		
	</xsl:variable>

	<xsl:variable name="java.invalidPartnerIDErrorEmailMessage">
		
		&lt;p&gt;Fel partner-ID vid anrop till Castor fr rende $flow.name (rende nr. $flowInstance.flowInstanceID).&lt;/p&gt;
		
		&lt;p&gt;Se ver instllningarna p e-tjnsten.&lt;/p&gt;

		&lt;p&gt;Klicka p lnken nedan fr att visa rendet:&lt;/p&gt;
		
		&lt;p&gt;
			&lt;a href="$flowInstance.url"&gt;$flowInstance.url&lt;/a&gt;
		&lt;/p&gt;
		
	</xsl:variable>

	<xsl:variable name="java.invalidCaseIDErrorEmailMessage">
		
		&lt;p&gt;Svar med ogiltigt rende-ID (00000000-0000-0000-0000-000000000000) vid anrop till Castor fr rende $flow.name (rende nr. $flowInstance.flowInstanceID).&lt;/p&gt;
		
		&lt;p&gt;Klicka p lnken nedan fr att visa rendet:&lt;/p&gt;
		
		&lt;p&gt;
			&lt;a href="$flowInstance.url"&gt;$flowInstance.url&lt;/a&gt;
		&lt;/p&gt;
		
	</xsl:variable>
	
	<xsl:variable name="i18n.SaveChanges">Spara ndringar</xsl:variable>
	
	<xsl:variable name="i18n.validation.requiredField" select="'Du mste fylla i fltet:'"/>
	<xsl:variable name="i18n.validation.invalidFormat" select="'Felaktigt format p fltet:'"/>
	<xsl:variable name="i18n.validation.tooShort" select="'Fr kort innehll i fltet:'"/>
	<xsl:variable name="i18n.validation.tooLong" select="'Fr lngt innehll i fltet:'"/>	
	<xsl:variable name="i18n.validation.unknownError" select="'Oknt fel p fltet:'"/>
	<xsl:variable name="i18n.validation.unknownFault" select="'Ett oknt valideringsfel har uppsttt.'"/>
	
	<xsl:variable name="i18n.IntegrationEnabled">Status</xsl:variable>
	<xsl:variable name="i18n.Yes">Aktiverad</xsl:variable>
	<xsl:variable name="i18n.No">Inaktiverad</xsl:variable>
	<xsl:variable name="i18n.Url">Adress</xsl:variable>
	<xsl:variable name="i18n.NoIntegrationSettings">Inga integrationsinstllningar har angets fr den hr e-tjnsten.</xsl:variable>
	<xsl:variable name="i18n.UpdateIntegrationSettings">ndra instllningar</xsl:variable>
	<xsl:variable name="i18n.DeleteIntegrationSettings">Ta bort instllningar</xsl:variable>
	<xsl:variable name="i18n.DeleteIntegrationSettings.Confirm">r du sker p att du vill ta bort integrationsinstllningarna fr den hr e-tjnsten?</xsl:variable>
	<xsl:variable name="i18n.UpdateIntegrationSettingsTitle">Integrationsinstllningar fr e-tjnsten</xsl:variable>
	<xsl:variable name="i18n.flowVersion">version</xsl:variable>
	<xsl:variable name="i18n.Enabled">Aktivera integrationen</xsl:variable>
	
	<xsl:variable name="i18n.Endpoint">Castor-installation</xsl:variable>
	<xsl:variable name="i18n.templateID">Template-ID</xsl:variable>
	<xsl:variable name="i18n.partnerID">Partner-ID</xsl:variable>

	<xsl:variable name="i18n.Enable">Aktivera</xsl:variable>
	<xsl:variable name="i18n.CopiedFromApplicant">Om alla flt lmnas tomma kommer informationen hmtas frn skande-flten</xsl:variable>
	<xsl:variable name="i18n.ToggleFields">[Visa/dlj flt]</xsl:variable>
	
	<xsl:variable name="i18n.Applicant">Skande</xsl:variable>
	<xsl:variable name="i18n.RealEstateOwner">Fastighetsgare</xsl:variable>
	<xsl:variable name="i18n.InvoiceRecipient">Fakturamottagare</xsl:variable>
	<xsl:variable name="i18n.InspectionManager">Kontrollansvarig</xsl:variable>
	<xsl:variable name="i18n.ContactPerson">Kontaktperson</xsl:variable>
	<xsl:variable name="i18n.Appellant">Klagande</xsl:variable>
	<xsl:variable name="i18n.CoApplicant">Medskande</xsl:variable>
	<xsl:variable name="i18n.ConstructionDeveloper">Byggherre</xsl:variable>
	
	<xsl:variable name="i18n.Number">Personnummer</xsl:variable>
	<xsl:variable name="i18n.Name">Namn</xsl:variable>
	<xsl:variable name="i18n.CareOf">C/O</xsl:variable>
	<xsl:variable name="i18n.Address">Adress</xsl:variable>
	<xsl:variable name="i18n.ZIPCode">Postnummer</xsl:variable>
	<xsl:variable name="i18n.PostalAddress">Ort</xsl:variable>
	<xsl:variable name="i18n.Phone">Telefonnummer</xsl:variable>
	<xsl:variable name="i18n.MobilePhone">Mobiltelefon</xsl:variable>
	<xsl:variable name="i18n.Email">E-postadress</xsl:variable>
	<xsl:variable name="i18n.RealEstateName">Fastighet - Namn</xsl:variable>
	<xsl:variable name="i18n.RealEstateNumber">Fastighet - Nummer</xsl:variable>
	<xsl:variable name="i18n.RealEstateAddress">Fastighet - Adress</xsl:variable>
	<xsl:variable name="i18n.RealEstatePostalAddress">Fastighet - Ort</xsl:variable>
	<xsl:variable name="i18n.RealEstateZIPCode">Fastighet - Postnummer</xsl:variable>
	
	<xsl:variable name="i18n.Notifications">Notifikationer</xsl:variable>
	<xsl:variable name="i18n.Notifications.ErrorEmail">E-post vid kommunikationsfel</xsl:variable>
	<xsl:variable name="i18n.Notifications.ErrorEmail.EmailAddresses">E-postadresser fr notifiering vid kommunikationsfel</xsl:variable>
	<xsl:variable name="i18n.Notifications.ConfigurationErrorEmail">E-post vid konfigurationsfel</xsl:variable>
	<xsl:variable name="i18n.Notifications.ConfigurationErrorEmail.EmailAddresses">E-postadresser fr notifiering vid konfigurationsfel</xsl:variable>
	<xsl:variable name="i18n.Notifications.InvalidCaseIDErrorEmail">E-post vid ogiltigt rende-ID</xsl:variable>
	<xsl:variable name="i18n.Notifications.InvalidCaseIDErrorEmail.EmailAddresses">E-postadresser fr notifiering vid ogiltigt rende-ID</xsl:variable>
	
	<xsl:variable name="i18n.Attachments">Bilagor</xsl:variable>
	<xsl:variable name="i18n.addAttachmentsSeparately">Bifoga bilagor som separata filer</xsl:variable>
	
	<xsl:variable name="i18n.AttachmentTypeMappings">Dokumenttypskopplingar fr bilagor</xsl:variable>
	<xsl:variable name="i18n.defaultAttachmentTypeID">Mappnings-ID vid oknd dokumenttyp</xsl:variable>
	<xsl:variable name="i18n.QueryName">Namn p filuppladdningsfrga</xsl:variable>
	<xsl:variable name="i18n.AttachmentTypeID">Mappnings-ID</xsl:variable>
	<xsl:variable name="i18n.AddAttachmentTypeMapping">Lgg till dokumenttypskoppling</xsl:variable>

	<xsl:variable name="i18n.createCaseOnSpecificStatus">Skapa Castor-rende vid specifik status</xsl:variable>
	<xsl:variable name="i18n.createCaseOnSpecificStatus.Description">Castor-rende kommer att skapas frsta gngen rendet stts till vald status</xsl:variable>
	<xsl:variable name="i18n.caseStatusName">Status</xsl:variable>
	
	<xsl:variable name="i18n.SupportedTags.Title">Tillgngliga taggar</xsl:variable>
	<xsl:variable name="i18n.SupportedTags.Description">Utver attributbaserade taggar med formatet $attribute{tagg} s kan fljande taggar anvndas i flten nedan.</xsl:variable>
	
</xsl:stylesheet>
