package com.nordicpeak.flowengine.integration.castor.client;

import se.unlogic.hierarchy.core.interfaces.attributes.AttributeHandler;
import se.unlogic.hierarchy.core.utils.AttributeTagUtils;
import se.unlogic.standardutils.string.StringUtils;
import se.unlogic.standardutils.string.TagReplacer;

import com.nordicpeak.flowengine.interfaces.ImmutableFlowInstance;

public class PersonData {

	private String number;
	private String name;
	private String careOf;
	private String address;
	private String zipCode;
	private String postalAddress;
	private String phone;
	private String mobilePhone;
	private String email;
	private String realEstateName;
	private String realEstateNumber;
	private String realEstateAddress;
	private String realEstatePostalAddress;
	private String realEstateZIPCode;

	public PersonData(String number, String name, String careOf, String address, String zipCode, String postalAddress, String phone, String mobilePhone, String email, String realEstateName, String realEstateNumber, String realEstateAddress, String realEstatePostalAddress, String realEstateZIPCode, ImmutableFlowInstance flowInstance, TagReplacer tagReplacer) {

		AttributeHandler attributeHandler = flowInstance.getAttributeHandler();

		this.number = replaceTags(number, attributeHandler, tagReplacer);
		this.name = replaceTags(name, attributeHandler, tagReplacer);
		this.careOf = replaceTags(careOf, attributeHandler, tagReplacer);
		this.address = replaceTags(address, attributeHandler, tagReplacer);
		this.zipCode = replaceTags(zipCode, attributeHandler, tagReplacer);
		this.postalAddress = replaceTags(postalAddress, attributeHandler, tagReplacer);
		this.phone = replaceTags(phone, attributeHandler, tagReplacer);
		this.mobilePhone = replaceTags(mobilePhone, attributeHandler, tagReplacer);
		this.email = replaceTags(email, attributeHandler, tagReplacer);
		this.realEstateName = replaceTags(realEstateName, attributeHandler, tagReplacer);
		this.realEstateNumber = replaceTags(realEstateNumber, attributeHandler, tagReplacer);
		this.realEstateAddress = replaceTags(realEstateAddress, attributeHandler, tagReplacer);
		this.realEstatePostalAddress = replaceTags(realEstatePostalAddress, attributeHandler, tagReplacer);
		this.realEstateZIPCode = replaceTags(realEstateZIPCode, attributeHandler, tagReplacer);
	}

	private String replaceTags(String text, AttributeHandler attributeHandler, TagReplacer tagReplacer) {

		if (text != null) {

			text = AttributeTagUtils.replaceTags(text, attributeHandler);

			text = tagReplacer.replace(text);
		}

		return text;
	}

	public boolean isPopulated() {

		//TODO When documentation is available this needs to be updated with a more exakt list of required parameters
		return !StringUtils.isEmpty(number, name, careOf, address, zipCode, postalAddress, phone, mobilePhone, email, realEstateName, realEstateNumber, realEstateAddress, realEstatePostalAddress, realEstateZIPCode);
	}

	@Override
	public String toString() {

		return "(number=" + number + ", name=" + name + ", careOf=" + careOf + ", address=" + address + ", zipCode=" + zipCode + ", postalAddress=" + postalAddress + ", phone=" + phone + ", mobilePhone=" + mobilePhone + ", email=" + email + ", realEstateName=" + realEstateName + ", realEstateNumber=" + realEstateNumber + ", realEstateAddress=" + realEstateAddress + ", realEstatePostalAddress=" + realEstatePostalAddress + ", realEstateZIPCode=" + realEstateZIPCode + ")";
	}

	public String getNumber() {

		return number;
	}

	public String getName() {

		return name;
	}

	public String getCareOf() {

		return careOf;
	}

	public String getAddress() {

		return address;
	}

	public String getZIPCode() {

		return zipCode;
	}

	public String getPostalAddress() {

		return postalAddress;
	}

	public String getPhone() {

		return phone;
	}

	public String getMobilePhone() {

		return mobilePhone;
	}

	public String getEmail() {

		return email;
	}

	public String getRealEstateName() {

		return realEstateName;
	}

	public String getRealEstateNumber() {

		return realEstateNumber;
	}

	public String getRealEstateAddress() {

		return realEstateAddress;
	}

	public String getRealEstatePostalAddress() {

		return realEstatePostalAddress;
	}

	public String getRealEstateZIPCode() {

		return realEstateZIPCode;
	}

}
