package com.nordicpeak.flowengine.changeownerinternalusers.beans;

import java.io.Serializable;
import java.sql.Timestamp;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.string.StringTag;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.beans.Contact;
import com.nordicpeak.flowengine.utils.FlowInstanceUtils;

@Table(name = "ownership_change_requests_internal_users")
@XMLElement
public class OwnershipChangeRequest extends GeneratedElementable implements Serializable {

	private static final long serialVersionUID = -3942415081672454957L;

	@DAOManaged
	@Key
	@XMLElement
	private Integer flowInstanceID;

	@DAOManaged
	@XMLElement
	private User poster;

	@DAOManaged
	@XMLElement(name = "Recipient")
	private User recipient;

	@DAOManaged
	@XMLElement
	private Timestamp added;

	@DAOManaged
	@XMLElement
	private boolean declined;

	@DAOManaged
	@StringTag
	@XMLElement
	private String declineReason;

	public Integer getFlowInstanceID() {

		return flowInstanceID;
	}

	public void setFlowInstanceID(Integer flowInstanceID) {

		this.flowInstanceID = flowInstanceID;
	}

	public Timestamp getAdded() {

		return added;
	}

	public void setAdded(Timestamp added) {

		this.added = added;
	}

	public User getPoster() {
		return poster;
	}

	public void setPoster(User poster) {
		this.poster = poster;
	}

	public User getRecipient() {
		return recipient;
	}

	public void setRecipient(User recipient) {
		this.recipient = recipient;
	}

	public boolean isDeclined() {
		return declined;
	}

	public void setDeclined(boolean declined) {
		this.declined = declined;
	}

	public String getDeclineReason() {
		return declineReason;
	}

	public void setDeclineReason(String declineReason) {
		this.declineReason = declineReason;
	}

	public Contact getRecipientContact() {

		return FlowInstanceUtils.getContactForUser(recipient);
	}

	public Contact getPosterContact() {

		return FlowInstanceUtils.getContactForUser(poster);
	}
}
