package com.nordicpeak.flowengine.evaluators.changeposterevaluator;

import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLParser;

import com.nordicpeak.flowengine.evaluators.baseevaluator.BaseEvaluator;

@Table(name = "change_owner_evaluators")
@XMLElement
public class ChangePosterEvaluator extends BaseEvaluator {
	
	private static final long serialVersionUID = 5501896243489595373L;
	
	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean showInLog;
	
	public boolean isShowInLog() {
		
		return showInLog;
	}
	
	public void setShowInLog(boolean showInLog) {
		
		this.showInLog = showInLog;
	}
	
	@Override
	public void populate(XMLParser xmlParser) throws ValidationException {
		
		showInLog = xmlParser.getPrimitiveBoolean("showInLog");
		
	}
	
	@Override
	public String toString() {
		
		return evaluatorDescriptor.toString();
	}
	
}
