<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	
	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>
	
	<xsl:template match="Document">	
		
		<xsl:apply-templates select="ShowQueryValues"/>
		
	</xsl:template>
		
	<xsl:template match="ShowQueryValues">
		
		<div class="query">
			<xsl:attribute name="class">
				<xsl:text>query</xsl:text>
				<xsl:if test="ChildInfoQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>
			
			<a name="query{ChildInfoQueryInstance/QueryInstanceDescriptor/QueryDescriptor/queryID}"/>
			
			<h2>
				<xsl:value-of select="ChildInfoQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
			</h2>
			
			<xsl:if test="Description">
				
				<div class="query-description">
					<xsl:choose>
						<xsl:when test="isHTMLDescription = 'true'">
							<xsl:value-of select="Description" disable-output-escaping="yes"/>
						</xsl:when>
						<xsl:otherwise>
							<p>
								<xsl:value-of select="Description" disable-output-escaping="yes"/>
							</p>
						</xsl:otherwise>
					</xsl:choose>
				</div>
								
			</xsl:if>
			
			<div class="full display-table bigmarginbottom">
			
				<xsl:apply-templates select="ChildInfoQueryInstance/Children/Child"/>
				
			</div>
			
		</div>
		
	</xsl:template>
	
	<xsl:template match="Child">
	
		<div class="bigmarginbottom">
			<strong><xsl:value-of select="$i18n.Children" /></strong>
			<br/>
			
			<xsl:value-of select="firstname" />
			<xsl:text>&#160;</xsl:text>
			<xsl:value-of select="lastname" />
			<br/>
			
			<xsl:value-of select="$i18n.Column.SocialSecurityNumber" />
			<xsl:text>:&#160;</xsl:text>
			<xsl:value-of select="citizenIdentifier" />
			
			<xsl:if test="../../ChildInfoQuery/showAddress = 'true'">
				
				<br/>
				<xsl:value-of select="$i18n.Column.Address" />
				<xsl:text>:&#160;</xsl:text>
				
				<xsl:if test="address">
					<xsl:value-of select="address" />
					<br/>
				</xsl:if>
				
				<xsl:if test="zipCode or postalAddress">
					<xsl:if test="zipCode">
						<xsl:value-of select="zipCode" />
						<xsl:text>&#160;</xsl:text>
					</xsl:if>
					
					<xsl:value-of select="postalAddress" />
				</xsl:if>
				
			</xsl:if>
			
		</div>
	
	</xsl:template>

</xsl:stylesheet>