<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />

	<xsl:template match="Document">

		<div class="contentitem">

			<xsl:apply-templates select="UpdateChildExistingFlowInstanceStatusEvaluator" />
		</div>

	</xsl:template>

	<xsl:template match="UpdateChildExistingFlowInstanceStatusEvaluator">

		<h1>
			<xsl:value-of select="$i18n.UpdateEvaluatorDescriptor.title" />
			<xsl:text>&#x20;</xsl:text>
			<xsl:value-of select="ChildExistingFlowInstanceStatusEvaluator/EvaluatorDescriptor/name" />
		</h1>

		<xsl:apply-templates select="validationException/validationError" />

		<form method="post" action="{/Document/requestinfo/uri}">

			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="ChildExistingFlowInstanceStatusEvaluator" />
			</xsl:call-template>

			<div class="floatleft full bigmarginbottom">

				<label for="weightType" class="floatleft full">
					<xsl:value-of select="$i18n.weightType" />
					<span class="required">*</span>
				</label>

				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'weightType'" />
						<xsl:with-param name="name" select="'weightType'" />
						<xsl:with-param name="element" select="ChildExistingFlowInstanceStatusEvaluator" />
					</xsl:call-template>
				</div>
			</div>

			<div class="floatleft full bigmarginbottom">

				<label for="weight" class="floatleft full">
					<xsl:value-of select="$i18n.weight" />
					<span class="required">*</span>
				</label>

				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'weight'" />
						<xsl:with-param name="name" select="'weight'" />
						<xsl:with-param name="element" select="ChildExistingFlowInstanceStatusEvaluator" />
					</xsl:call-template>
				</div>
			</div>
			
			<xsl:call-template name="selectContentTypes" />			

			<div class="floatright clearboth">
				<input type="submit" value="{$i18n.submit}" />
			</div>

		</form>

	</xsl:template>
	
	<xsl:template name="selectContentTypes">
	
		<h2 class="floatleft bigmargintop">
			<xsl:value-of select="$i18n.statusContentType.title" />
		</h2>
	
		<xsl:call-template name="selectContentType">
			<xsl:with-param name="id" select="'new'"/>
			<xsl:with-param name="value" select="'NEW'"/>
			<xsl:with-param name="label" select="$i18n.contentType.NEW"/>
		</xsl:call-template>

		<xsl:call-template name="selectContentType">
			<xsl:with-param name="id" select="'waiting_for_multisign'"/>
			<xsl:with-param name="value" select="'WAITING_FOR_MULTISIGN'"/>
			<xsl:with-param name="label" select="$i18n.contentType.WAITING_FOR_MULTISIGN"/>
		</xsl:call-template>

		<xsl:call-template name="selectContentType">
			<xsl:with-param name="id" select="'waiting_for_payment'"/>
			<xsl:with-param name="value" select="'WAITING_FOR_PAYMENT'"/>
			<xsl:with-param name="label" select="$i18n.contentType.WAITING_FOR_PAYMENT"/>
		</xsl:call-template>

		<xsl:call-template name="selectContentType">
			<xsl:with-param name="id" select="'submitted'"/>
			<xsl:with-param name="value" select="'SUBMITTED'"/>
			<xsl:with-param name="label" select="$i18n.contentType.SUBMITTED"/>
		</xsl:call-template>

		<xsl:call-template name="selectContentType">
			<xsl:with-param name="id" select="'in_progress'"/>
			<xsl:with-param name="value" select="'IN_PROGRESS'"/>
			<xsl:with-param name="label" select="$i18n.contentType.IN_PROGRESS"/>
		</xsl:call-template>
	
		<xsl:call-template name="selectContentType">
			<xsl:with-param name="id" select="'waiting_for_completion'"/>
			<xsl:with-param name="value" select="'WAITING_FOR_COMPLETION'"/>
			<xsl:with-param name="label" select="$i18n.contentType.WAITING_FOR_COMPLETION"/>
		</xsl:call-template>
	
					
		<xsl:call-template name="selectContentType">
			<xsl:with-param name="id" select="'archived'"/>
			<xsl:with-param name="value" select="'ARCHIVED'"/>
			<xsl:with-param name="label" select="$i18n.contentType.ARCHIVED"/>
		</xsl:call-template>
	
	</xsl:template>
	
	<xsl:template name="selectContentType">
		<xsl:param name="id" />
		<xsl:param name="value" />
		<xsl:param name="label" />
	
		<div class="floatleft full">
			<xsl:call-template name="createCheckbox">
				<xsl:with-param name="id" select="$id"/>
				<xsl:with-param name="name" select="'contentTypes'"/>
				<xsl:with-param name="valueElementName" select="'contentType'"/>
				<xsl:with-param name="element" select="ChildExistingFlowInstanceStatusEvaluator" />
				<xsl:with-param name="value" select="$value"/>
			</xsl:call-template>
			
			<label for="{$id}">
				<xsl:value-of select="$label" />
			</label>
		</div>
	
	</xsl:template>
	
	<xsl:template match="fieldName">

		<xsl:variable name="fieldName" select="." />

		<xsl:choose>
			<xsl:when test="$fieldName = 'weightType'">
				<xsl:value-of select="$i18n.weightType" />
			</xsl:when>
			<xsl:when test="$fieldName = 'weight'">
				<xsl:value-of select="$i18n.weight" />
			</xsl:when>
			<xsl:when test="$fieldName = 'contentTypes'">
				<xsl:value-of select="$i18n.contentType" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>

</xsl:stylesheet>