package com.nordicpeak.flowengine.evaluators.citizenidgroupmembershipquerystateevaluator;

import javax.servlet.http.HttpServletRequest;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.xml.XMLUtils;
import se.unlogic.webutils.http.BeanRequestPopulator;
import se.unlogic.webutils.http.URIParser;
import se.unlogic.webutils.populators.annotated.AnnotatedRequestPopulator;

import com.nordicpeak.flowengine.evaluators.basequerystateevaluator.BaseQueryStateEvaluationCRUD;

public class CitizenIDGroupMembershipQueryStateEvaluatorCRUD extends BaseQueryStateEvaluationCRUD<CitizenIDGroupMembershipQueryStateEvaluator, CitizenIDGroupMembershipQueryStateEvaluationProviderModule> {
	
	private static final BeanRequestPopulator<CitizenIDGroupMembershipQueryStateEvaluator> POPULATOR = new AnnotatedRequestPopulator<CitizenIDGroupMembershipQueryStateEvaluator>(CitizenIDGroupMembershipQueryStateEvaluator.class);
	
	public CitizenIDGroupMembershipQueryStateEvaluatorCRUD(Class<CitizenIDGroupMembershipQueryStateEvaluator> beanClass, AnnotatedDAOWrapper<CitizenIDGroupMembershipQueryStateEvaluator, Integer> evaluatorDAO, CitizenIDGroupMembershipQueryStateEvaluationProviderModule callback) {
		
		super(beanClass, evaluatorDAO, POPULATOR, "CitizenIDGroupMembershipQueryStateEvaluator", "group query state evaluator", null, callback);
	}
	
	@Override
	protected void appendUpdateFormData(CitizenIDGroupMembershipQueryStateEvaluator query, Document doc, Element updateTypeElement, User user, HttpServletRequest req, URIParser uriParser) throws Exception {
		super.appendUpdateFormData(query, doc, updateTypeElement, user, req, uriParser);
		
		if (query.getGroupIDs() != null) {
			XMLUtils.append(doc, updateTypeElement, "Groups", callback.getGroupHandler().getGroups(query.getGroupIDs(), true));
		}
	}
}
