package com.nordicpeak.flowengine.coloredtag.beans;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.util.List;

import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.OneToMany;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.reflection.ReflectionUtils;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "flowengine_colored_tag_settings")
@XMLElement(name = "Settings")
public class ColoredTagSettings extends GeneratedElementable implements Serializable {

	private static final long serialVersionUID = 3268646669132872847L;

	public static final Field FIELD_FLOW_FAMILY_ID = ReflectionUtils.getField(ColoredTagSettings.class, "flowFamilyID");
	public static final Field FIELD_TAGS = ReflectionUtils.getField(ColoredTagSettings.class, "tags");

	@DAOManaged(autoGenerated = true)
	@Key
	@XMLElement
	private Integer settingsID;

	@DAOManaged
	@XMLElement
	private Integer flowFamilyID;

	@DAOManaged
	@XMLElement
	@WebPopulate
	private boolean enabled;

	@DAOManaged(columnName = "tagID")
	@OneToMany
	@XMLElement(fixCase = true)
	private List<ColoredTag> tags;

	@Override
	public String toString() {

		return "(settingsID=" + settingsID + ", flowFamilyID=" + flowFamilyID + ")";
	}

	public Integer getSettingsID() {

		return settingsID;
	}

	public void setSettingsID(Integer settingsID) {

		this.settingsID = settingsID;
	}

	public Integer getFlowFamilyID() {

		return flowFamilyID;
	}

	public void setFlowFamilyID(Integer flowFamilyID) {

		this.flowFamilyID = flowFamilyID;
	}

	public boolean isEnabled() {

		return enabled;
	}

	public void setEnabled(boolean enabled) {

		this.enabled = enabled;
	}

	public List<ColoredTag> getTags() {

		return tags;
	}

	public void setTags(List<ColoredTag> tags) {

		this.tags = tags;
	}

	public ColoredTag getTag(Integer tagID) {

		if (tags != null && tagID != null) {

			for (ColoredTag tag : tags) {

				if (tag.getTagID().equals(tagID)) {

					return tag;
				}
			}
		}

		return null;
	}

}
