package com.nordicpeak.flowengine.culling.beans;

import java.io.Serializable;

import com.nordicpeak.flowengine.culling.enums.CullingCategory;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "flowengine_culling_settings")
@XMLElement(name = "Setting")
public class AutomaticCullingSetting extends GeneratedElementable implements Serializable {

	private static final long serialVersionUID = -2881372784113729471L;

	@DAOManaged(columnName = "flowFamilyID")
	@Key
	@XMLElement
	private Integer flowFamilyID;

	@DAOManaged
	@Key
	@XMLElement
	private String name;

	@DAOManaged
	@XMLElement
	private Integer lifetimeDays;
	
	@DAOManaged
	@XMLElement
	private CullingCategory category;

	public AutomaticCullingSetting() {}

	public AutomaticCullingSetting(String name, Integer lifetimeDays, Integer flowFamilyID, CullingCategory category) {

		this.name = name;
		this.lifetimeDays = lifetimeDays;
		this.flowFamilyID = flowFamilyID;
		this.category = category;
	}

	public Integer getFlowFamilyID() {

		return flowFamilyID;
	}

	public void setFlowFamilyID(Integer flowFamilyID) {

		this.flowFamilyID = flowFamilyID;
	}

	public String getName() {

		return name;
	}

	public void setName(String name) {

		this.name = name;
	}

	public Integer getLifetimeDays() {

		return lifetimeDays;
	}

	public void setLifetimeDays(Integer lifetimeDays) {

		this.lifetimeDays = lifetimeDays;
	}

	public CullingCategory getCategory() {
		return category;
	}

	public void setCategory(CullingCategory category) {
		this.category = category;
	}
}