
$(function() {
	
	setQueryRequiredFunctions["DateTimeQueryInstance"] = makeDateTimeQueryRequired;
	
});

function initDateTimeQuery(queryID, timeInterval, startTime, endTime) {
	
	var $query = $("#query_" + queryID);
	
	$query.find(".time-field input[type='time']").each(function(){
		
		var input = $(this);
		
		input.attr("step", timeInterval * 60);
		input.attr("min", startTime);
		input.attr("max", endTime);
	});
	
	if (!Modernizr.inputtypes.date) {

		$query.find(".date-field input[type='date']").datepicker({
            changeMonth: true,
            changeYear: true,
            showWeek: true,
            dayNamesShort: true,
            onSelect: function() {
                $(this).trigger("blur");
            }
        });
    
    }
	
	if (!Modernizr.inputtypes.time) {
		
		$query.find(".time-field input[type='time']").timePicker({
			startTime: startTime,
			endTime: endTime,
    		step: timeInterval
    	});
	}
	
}

function makeDateTimeQueryRequired(queryID) {
	
	$("#query_" + queryID).find(".heading-wrapper h2").addClass("required");
	
}