$(function() {
	
	$("#useTimeFields").on("change", function() {
		
		var fields = $("#timeInterval, #useMultiTime, #earliestTime, #latestTime");
		
		if ($(this).prop("checked")) {
			
			fields.removeAttr("disabled").parent().parent().show();
			
		} else {
			
			fields.attr("disabled", "disabled").parent().parent().hide();
		}
		
		$("#useMultiTime").trigger("change");
	});
	
	$("#useMultiTime").on("change", function() {
		
		var fields = $("#allowStartTimeAfterEndTime");
		
		if ($(this).prop("checked") && $("#useTimeFields").prop("checked")){
			
			fields.removeAttr("disabled").parent().parent().show();
			
		} else {
			
			fields.attr("disabled", "disabled").parent().parent().hide();
		}
		
		$("#allowStartTimeAfterEndTime").trigger("change");
	});
	
	$("#allowStartTimeAfterEndTime").on("change", function() {
		
		var fields = $("#earliestTime, #latestTime");
		
		if ($("#useTimeFields").prop("checked")){
			
			if ($(this).prop("checked")){
				
				fields.attr("disabled", "disabled").parent().parent().hide();
				
			} else {
				
				fields.removeAttr("disabled").parent().parent().show();
			}
			
		} else {
			
			fields.attr("disabled", "disabled").parent().parent().hide();
		}
	});
	
	$("#useDateFields").on("change", function() {
		
		var $dateRestrictionContainer = $("#dateRestrictionContainer");
		
		var $useMultiDate = $dateRestrictionContainer.find("#useMultiDate");
		var $minDate = $dateRestrictionContainer.find("#minDate");
		
		var $startDateRestrictionNone = $dateRestrictionContainer.find("#startDateRestrictionNone");
		var $restrictFutureStartDates = $dateRestrictionContainer.find("#restrictFutureStartDates");
		var $restrictPastStartDates = $dateRestrictionContainer.find("#restrictPastStartDates");

		var $endDateRestrictionNone = $dateRestrictionContainer.find("#endDateRestrictionNone");
		var $restrictFutureEndDates = $dateRestrictionContainer.find("#restrictFutureEndDates");
		var $restrictPastEndDates = $dateRestrictionContainer.find("#restrictPastEndDates");
		
		var $minDaysInFutureStartDateInfoContainer = $dateRestrictionContainer.find("#minDaysInFutureStartDateInfoContainer");
		var $minDaysInPastStartDateInfoContainer = $dateRestrictionContainer.find("#minDaysInPastStartDateInfoContainer");
		var $restrictedStartDays = $dateRestrictionContainer.find("#restrictedStartDays");

		var $minDaysInFutureEndDateInfoContainer = $dateRestrictionContainer.find("#minDaysInFutureEndDateInfoContainer");
		var $minDaysInPastEndDateInfoContainer = $dateRestrictionContainer.find("#minDaysInPastEndDateInfoContainer");
		var $restrictedEndDays = $dateRestrictionContainer.find("#restrictedEndDays");

		$minDaysInFutureStartDateInfoContainer.hide();
		$minDaysInPastStartDateInfoContainer.hide();
		$minDaysInFutureEndDateInfoContainer.hide();
		$minDaysInPastEndDateInfoContainer.hide();
		
		if ($(this).prop("checked")) {
			
			$dateRestrictionContainer.show();
			$useMultiDate.removeAttr("disabled");
			$minDate.removeAttr("disabled");

			if($startDateRestrictionNone.prop("checked")) {
				
				$restrictedStartDays.attr("disabled", "disabled").parent().parent().hide();
				
			} else if($restrictFutureStartDates.prop("checked")) {
				
				$minDaysInFutureStartDateInfoContainer.show();
				$restrictedStartDays.removeAttr("disabled").parent().parent().show();
				
			} else if($restrictPastStartDates.prop("checked")) {
				
				$minDaysInPastStartDateInfoContainer.show();
				$restrictedStartDays.removeAttr("disabled").parent().parent().show();
				
			} else {
				
				$startDateRestrictionNone.prop("checked", "true");
			}

			if($endDateRestrictionNone.prop("checked")) {
				
				$restrictedEndDays.attr("disabled", "disabled").parent().parent().hide();
				
			} else if($restrictFutureEndDates.prop("checked")) {
				
				$minDaysInFutureEndDateInfoContainer.show();
				$restrictedEndDays.removeAttr("disabled").parent().parent().show();
				
			} else if($restrictPastEndDates.prop("checked")) {
				
				$minDaysInPastEndDateInfoContainer.show();
				$restrictedEndDays.removeAttr("disabled").parent().parent().show();
				
			} else {
				
				$endDateRestrictionNone.prop("checked", "true");
			}			
			
		} else {
			
			$dateRestrictionContainer.hide();
			$useMultiDate.attr("disabled", "disabled");
			$minDate.attr("disabled", "disabled");
			$restrictedStartDays.attr("disabled", "disabled").parent().parent().hide();
			$restrictedEndDays.attr("disabled", "disabled").parent().parent().hide();
		}
		
		$("#useMultiDate").trigger("change");
		$("#restrictTomorrowOnTime").trigger("change");
	});
	
	$("#useMultiDate").on("change", function() {
		
		$endDateFieldset = $("#end-date-fieldset");
		$intervalRestrictionFieldset = $("#interval-restriction-fieldset");
		$restrictDateInterval = $("#restrictDateInterval");
		
		if ($(this).prop("checked") && !$(this).prop("disabled")) {
			
			$endDateFieldset.removeAttr("disabled").show();
			$intervalRestrictionFieldset.removeAttr("disabled").show();
			$restrictDateInterval.removeAttr("disabled").parent().parent().show();
			
		} else {
			
			$endDateFieldset.attr("disabled", "disabled").hide();
			$intervalRestrictionFieldset.attr("disabled", "disabled").hide();
			$restrictDateInterval.attr("disabled", "disabled").parent().parent().hide();
		}
		
		$("#restrictDateInterval").trigger("change");
	});
	
	$("#restrictDateInterval").on("change", function() {
		
		$intervalRestrictionContainer = $("#intervalRestrictionContainer");
		
		$dateRestrictionIntervalMinimum = $intervalRestrictionContainer.find("#dateRestrictionIntervalMinimum");
		$dateRestrictionIntervalMaximum = $intervalRestrictionContainer.find("#dateRestrictionIntervalMaximum");
		$dateRestrictionIntervalUnitDays = $intervalRestrictionContainer.find("#dateRestrictionIntervalUnitDays");
		$dateRestrictionIntervalUnitMonths = $intervalRestrictionContainer.find("#dateRestrictionIntervalUnitMonths");
		$dateIntervalRestriction = $intervalRestrictionContainer.find("#dateIntervalRestriction");
		
		if ($(this).prop("checked") && !$(this).prop("disabled")) {
			
			$intervalRestrictionContainer.show();
			$dateRestrictionIntervalMinimum.removeAttr("disabled");
			$dateRestrictionIntervalMaximum.removeAttr("disabled");
			$dateRestrictionIntervalUnitDays.removeAttr("disabled");
			$dateRestrictionIntervalUnitMonths.removeAttr("disabled");
			$dateIntervalRestriction.removeAttr("disabled");
			
		} else {
			
			$intervalRestrictionContainer.hide();
			$dateRestrictionIntervalMinimum.attr("disabled", "disabled");
			$dateRestrictionIntervalMaximum.attr("disabled", "disabled");
			$dateRestrictionIntervalUnitDays.attr("disabled", "disabled");
			$dateRestrictionIntervalUnitMonths.attr("disabled", "disabled");
			$dateIntervalRestriction.attr("disabled", "disabled");
		}
	});
	
	$("input[name=startDateRestrictionType]").on("change", function() {
		
		$("#useDateFields").trigger("change");
	});

	$("input[name=endDateRestrictionType]").on("change", function() {
		
		$("#useDateFields").trigger("change");
	});

	$("input[name=tomorrowRestrictionMode]").on("change", function() {
		
		$("#restrictTomorrowOnTime").trigger("change");
	});
	
	
	$("#restrictTomorrowOnTime").on("change", function() {
		
		if ($(this).prop("checked")) {
			
			$("#restrictTomorrowTime").removeAttr("disabled").show();
			$("#tomorrowRestrictionModeContainer").show();

			if($("#tomorrowRestrictionModeToday").prop("checked")) {
				
				$("#tomorrowRestrictionModeTodayInfoContainer").show();
				$("#tomorrowRestrictionModeTomorrowInfoContainer").hide();
				
			} else if($("#tomorrowRestrictionModeTomorrow").prop("checked")) {
				
				$("#tomorrowRestrictionModeTodayInfoContainer").hide();
				$("#tomorrowRestrictionModeTomorrowInfoContainer").show();
				
			} else {
				
				$("#tomorrowRestrictionModeToday").prop("checked", "true");
				$("#tomorrowRestrictionModeTodayInfoContainer").show();
				$("#tomorrowRestrictionModeTomorrowInfoContainer").hide();
			}			
			
		} else {
			
			$("#restrictTomorrowTime").attr("disabled", "disabled").hide();
			$("#tomorrowRestrictionModeContainer").hide();
			$("#tomorrowRestrictionModeTodayInfoContainer").hide();
			$("#tomorrowRestrictionModeTomorrowInfoContainer").hide();			
		}
	});
	
	$("#restrictCurrentMonth").on("change", function() {
		
		if ($(this).prop("checked")) {
			
			$("#upcoming-months-container").show();
			$("#restrictUpcomingMonths").removeAttr("disabled");
			
		} else {
		
			$("#restrictUpcomingMonths").attr("disabled", "disabled");
			$("#upcoming-months-container").hide();
			$("#restrictUpcomingMonths").prop("checked", false).trigger("change");
		}
	});	

	$("#restrictUpcomingMonths").on("change", function() {
			
		if ($(this).prop("checked")) {
			
			$("#number-of-upcomming-months-container").show();
			$("#numberOfUpcomingMonths").removeAttr("disabled");
			
		} else {
			
			$("#number-of-upcomming-months-container").hide();
			$("#numberOfUpcomingMonths").attr("disabled", "disabled");
		}
	});		
	
	$("#endDateRestrictCurrentMonth").on("change", function() {
		
		if ($(this).prop("checked")) {
			
			$("#upcoming-end-months-container").show();
			$("#restrictUpcomingEndMonths").removeAttr("disabled");
			
		} else {
		
			$("#restrictUpcomingEndMonths").attr("disabled", "disabled");
			$("#upcoming-end-months-container").hide();
			$("#restrictUpcomingEndMonths").prop("checked", false).trigger("change");
		}
	});	

	$("#restrictUpcomingEndMonths").on("change", function() {
			
		if ($(this).prop("checked")) {
			
			$("#number-of-upcomming-end-months-container").show();
			$("#numberOfUpcomingEndMonths").removeAttr("disabled");
			
		} else {
			
			$("#number-of-upcomming-end-months-container").hide();
			$("#numberOfUpcomingEndMonths").attr("disabled", "disabled");
		}
	});
	
	$("#timeInterval").on("change", function() {
		
		var fields = $("#earliestTime, #latestTime"); 
		var timeInterval = $(this).val() - 0;
		
		$(".time-picker").remove();
		
		fields.each(function() {
			
			var field = $(this);
			var existingTimePicker = this.timePicker;
			
			if (existingTimePicker) { // Remove old timepicker
				
				field.off();
				this.timePicker = undefined;
			}
			
			field.timePicker({
				startTime: "00:00",
				endTime: "23:59",
				step: timeInterval
	    	});
			
			if (field.val() != "") { // Select closest time if something was selected previously
				field.trigger("focus").trigger("blur");
			}
		});
		
		$(".time-picker ul li.selected").trigger("click");
	});
	
	$("#useTimeFields").trigger("change");
	$("#useMultiTime").trigger("change");
	$("#useDateFields").trigger("change");
	$("#timeInterval").trigger("change");
	$("#restrictCurrentMonth").trigger("change");
	$("#restrictUpcomingMonths").trigger("change");
	$("#endDateRestrictCurrentMonth").trigger("change");
	$("#restrictUpcomingEndMonths").trigger("change");
	
	if (!Modernizr.inputtypes.date) {

		$(".date-field input[type='date']").datepicker({
            changeMonth: true,
            changeYear: true,
            showWeek: true,
            dayNamesShort: true,
            onSelect: function() {
                $(this).trigger("blur");
            }
        });
    }
	
});