package com.nordicpeak.flowengine.deduplication.beans;

import java.sql.Date;

import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.date.DateStringyfier;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "flow_family_deduplication_settings")
@XMLElement
public class FlowFamilyDeduplicationSettings extends GeneratedElementable {
	
	
	@DAOManaged
	@Key
	@XMLElement
	private Integer flowFamilyID;
	
	@DAOManaged
	@WebPopulate
	@XMLElement(valueFormatter = DateStringyfier.class)
	private Date startDate;
	
	@DAOManaged
	@WebPopulate
	@XMLElement(valueFormatter = DateStringyfier.class)
	private Date endDate;
	
	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean matchPoster;
	
	@DAOManaged
	@WebPopulate
	@XMLElement
	private String attribute;
	
	@DAOManaged
	@WebPopulate(required = true)
	@XMLElement
	private String statusName;
	
	public Integer getFlowFamilyID() {
		
		return flowFamilyID;
	}
	
	public void setFlowFamilyID(Integer flowFamilyID) {
		
		this.flowFamilyID = flowFamilyID;
	}
	
	public Date getStartDate() {
		return startDate;
	}
	
	public void setStartDate(Date startDate) {
		this.startDate = startDate;
	}
	
	public Date getEndDate() {
		return endDate;
	}
	
	public void setEndDate(Date endDate) {
		this.endDate = endDate;
	}
	
	public boolean isMatchPoster() {
		return matchPoster;
	}
	
	public void setMatchPoster(boolean matchPoster) {
		this.matchPoster = matchPoster;
	}
	
	public String getAttribute() {
		return attribute;
	}
	
	public void setAttribute(String attribute) {
		this.attribute = attribute;
	}
	
	public String getStatusName() {
		return statusName;
	}
	
	public void setStatusName(String statusName) {
		this.statusName = statusName;
	}
	
}
