<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" >
	<xsl:output method="xml" doctype-system="http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd" doctype-public="-//W3C//DTD XHTML 1.0 Transitional//EN" indent="yes" encoding="ISO-8859-1"/>

	<xsl:template match="Document">
		
		<html xmlns="http://www.w3.org/1999/xhtml">
			
			<head>
				<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
				
				<title>
					<xsl:value-of select="$i18n.PDF.Signatures" />
				</title>
				
				<link rel="stylesheet" type="text/css" href="classpath://com/nordicpeak/flowengine/documentsigner/staticcontent/css/pdf.css" />
				
			</head>
			
			<body>
			
				<xsl:apply-templates select="Signatures" />
				
			</body>
		</html>
		
	</xsl:template>
	
	<xsl:template match="Signatures">
		
		<div class="signatures">
			<h2>
				<xsl:value-of select="$i18n.PDF.Signatures" />
			</h2>
			
			<p>
				<xsl:value-of select="$i18n.PDF.Signatures.description" />
			</p>
			
			<xsl:apply-templates select="Document/Signers/DocumentSigner" mode="signature" />
			
		</div>
		
	</xsl:template>
	
	<xsl:template match="DocumentSigner" mode="signature">
	
		<div class="bigmarginbottom">
		
			<div>
				<strong><xsl:value-of select="$i18n.DocumentSigner.name"/>:&#160;</strong>
				<xsl:value-of select="firstname"/>
				<xsl:text>&#160;</xsl:text>
				<xsl:value-of select="lastname"/>
			</div>
			
			<xsl:if test="../../../ShowCitizenIdentifier = 'true'">
				<div>
					<strong><xsl:value-of select="$i18n.DocumentSigner.citizenID"/>:&#160;</strong>
					<xsl:value-of select="citizenID"/>
				</div>
			</xsl:if>
			
			<div>
				<strong><xsl:value-of select="$i18n.DocumentSigner.signedDate"/>:&#160;</strong>
				<xsl:value-of select="signedDate"/>
			</div>
			
			<div>
				<strong>
					<xsl:value-of select="$i18n.DocumentSigner.signedChecksum1"/>
					<xsl:value-of select="../../FormattedHashAlgorithm"/>
					<xsl:value-of select="$i18n.DocumentSigner.signedChecksum2"/>
					<xsl:text>:&#160;</xsl:text>
				</strong>
				<xsl:value-of select="signingChecksum"/>
			</div>
			
		</div>
	
	</xsl:template>
	
</xsl:stylesheet>