package com.nordicpeak.flowengine.documentsigner;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.hierarchy.core.interfaces.SystemInterface;
import se.unlogic.hierarchy.core.utils.usergrouplist.UserGroupListConnector;
import se.unlogic.standardutils.json.JsonObject;


public class UserGroupListConnectorWithTitle extends UserGroupListConnector {

	private final String titleAttribute;
	
	public UserGroupListConnectorWithTitle(SystemInterface systemInterface, String titleAttribute) {
		super(systemInterface);
		
		this.titleAttribute = titleAttribute;
	}

	@Override
	protected JsonObject getUserJson(User user) {
		
		JsonObject instance = super.getUserJson(user);
		
		if (user.getAttributeHandler() != null && titleAttribute != null) {
			
			String title = user.getAttributeHandler().getString(titleAttribute);
			
			if (title != null) {
				instance.putField("Title", title);
			}
		}
		
		return instance;
	}
}
