var DocumentSigning18n = {
	deleteConfirm: "Are you sure you want to remove the person",
	moduleURI: "/not-set"
};



$(function() {
	
	var alternativesContainers = $("#signers").sortable({ cursor: 'move', update: function(event, ui) {
		
		updateSortOrder($(this));
		
	}}).each(function(){
		
		var container = $(this);
		
		sortSigningPartiesAfterSortIndex(container);
	});
	
	$("#type_poster, #type_internal, #type_external").on("change", applySignerType);
	
	// Overrides UserGroupList.js
	var superAddUserGroupEntry = addUserGroupEntry;
	
	addUserGroupEntry = function(item, list, prefix, template, showUserURL) {
		
		list.children("li").not(".hidden").remove();
		
		superAddUserGroupEntry.apply(null, arguments);
		
		var fields = $("#internalFields");
		
		fields.find("input[name='email']").val(item.Email);
		fields.find("input[name='username']").val(item.Username);
		fields.find("input[name='title']").val(item.Title);
	};
	
	// IE fix for missing String.endsWith
	if (!String.prototype.endsWith) {
		String.prototype.endsWith = function(suffix) {
			return this.indexOf(suffix, this.length - suffix.length) !== -1;
		};
	 }
	 
	 
	 
	 	
		
});

//Overrides UserGroupList.js
function getUserGroupLabel(template, item) {
	var label = item.Name;
	
	var showUsername = template.hasClass("show-username-true") && item.Username;
	var showEmail = template.hasClass("show-email-true") && item.Email;
	var showTitle = item.Title;
	
	if (showUsername) {
		label += " (" + item.Username;
	}
	
	if (showTitle) {
		if (showUsername) {
			label += ", ";
		} else {
			label += " (";
		}
		label += item.Title;
	}
	
	if (showEmail) {
		if (showUsername || showTitle) {
			label += ", ";
		} else {
			label += " (";
		}
		label += item.Email;
	}
	
	if (showUsername || showEmail || showTitle) {
		label += ")";
	}
	
	return label;
}

function updateSortOrder(alternativesContainer) {
	
	alternativesContainer.children().each(function(i) {
		var alternative = $(this);
		alternative.find("input.sortorder").val(i);
	});
}

function sortSigningPartiesAfterSortIndex(alternativesContainer){
	
	alternativesContainer.children().sort(function(a, b){
		
		return parseInt($(a).find('input[type="hidden"].sortorder').val()) - parseInt($(b).find('input[type="hidden"].sortorder').val());
		
	}).appendTo(alternativesContainer);
}

function addDocumentSigner(button, event) {
	event.preventDefault();
	event.stopPropagation();
	
	var uuid = "g" + generateUUID();
	var container = $("#signers");
	var template = $("#signerTemplate").children().first().clone();
	
	template.find("input").prop("disabled", false).each(function() {
		
		var input = $(this);
		
		input.attr("id", input.attr("id") + "-" + uuid);
		
		if (input.attr("name") == "signerID") {
			
			input.val(uuid);
			
		} else {
			
			input.attr("name", input.attr("name") + uuid);
		}
	});
	
	template.find("input.sortorder").val(container.children().length);
	
	container.append(template);
	
	template.find("a.open-signer-modal").trigger("click");
}

function deleteDocumentSigner(button, event) {
	event.preventDefault();
	event.stopPropagation();
	
	if(confirm(DocumentSigning18n.deleteConfirm + "?")) {
		
		var $button = $(button);
		
		var alternatives = $button.closest("tbody");
		$button.closest("tr").remove();
		updateSortOrder(alternatives);
	}
}

function generateUUID() {
	
	var chars = '0123456789abcdef'.split('');
	var uuid = [], rnd = Math.random;
	var r;
	
	uuid[8] = uuid[13] = uuid[18] = uuid[23] = '-';
	uuid[14] = '4';
	
	for (var i = 0; i < 36; i++) {
		if (!uuid[i]) {
			r = 0 | rnd()*16;
			uuid[i] = chars[(i == 19) ? (r & 0x3) | 0x8 : r & 0xf];
		}
	}
	
	return uuid.join('');
}

function openDocumentSignerModal(button, event) {
	event.preventDefault();
	event.stopPropagation();
	
	var alternativesContainer = $("#signers");
	var modal = $("#signerModal");
	var modalParent = modal.parent();
	var alternative = $(button).closest("tr");
	
	var tempSaveAndOpensigner = $("#saveAndOpenSigner");
	
	$(tempSaveAndOpensigner).on("click",  () => {
			$(tempSaveAndOpensigner).data('clicked', true)});
	
	var saveChanges = false;
	
	
	var isNew;
	
	var config = {
		otherClose: '.close',
		
		beforeOpen: function() {
		
			$(tempSaveAndOpensigner).data('clicked', false);
			
			$("#invalidEmail, #invalidMobilePhone, #invalidCitizenID, #emailOrPhoneRequired").hide();
			
			modal.find("input[name='type']").prop("checked", false);
			
			var type = alternative.find("input[name^='signer-type']").val();
			isNew = type == "";
			
			
			
			if (isNew) {
				
				applySignerType();
				
				$("#internal-user-list").children("li").not(".hidden").remove();
				$("#externalFields").find("input").val("");
				
			} else {
				modal.find("input[name='type'][value='" + type + "']").prop("checked", true);
				applySignerType();
				
				if (type == "INTERNAL_USER") {
					
					var userID = alternative.find("input[name^='signer-userID']").val();
					var firstname = alternative.find("input[name^='signer-firstname']").val();
					var lastname = alternative.find("input[name^='signer-lastname']").val();
					var email = alternative.find("input[name^='signer-email']").val();
					var username = alternative.find("input[name^='signer-username']").val();
					var title = alternative.find("input[name^='signer-title']").val();
					
					if (lastname != "") {
						firstname += " " + lastname;
					}
					
					var list = $("#internal-user-list");
					var item = {ID: userID, Name : firstname, Email: email, Username: username, Title: title, label: firstname, value: userID}
					var prefix = getUserGroupPrefix(list);
					var showUserURL = "";
					var template = getUserGroupTemplate(prefix);
					
					addUserGroupEntry(item, list, prefix, template, showUserURL);
					
				} else if (type == "EXTERNAL_USER") {
					
					$("#externalFields").find("input[type='text']").each(function(){
						
						var input = $(this);
						var savedInput = alternative.find("input[name^='signer-" + input.prop("name") + "']");
						
						if (savedInput.length > 0) {
							input.val(savedInput.val());
							
						} else {
							input.val("");
						}
					});
				}
			}
		},

		afterContent: function() {
			var feather = this;
			feather.$content.removeClass("no-sections");
			
			modal.detach(); // Avoid ID clashes
			
			feather.$content.find("input[type='button']").on("click", function(){
				saveChanges = true;
			});
			
			$("#internal-user-search").removeData("ui-autocomplete");
			
			feather.$content.find(".usergroup-list").each(function(){
				var list = $(this);
				initUserGroupList(list);
			 });
		},
		
		beforeClose: function() {
			var feather = this;
			
			if (saveChanges) {
				
				var type = feather.$content.find("input[name='type']:checked").val();
				
				if (type == undefined) {
					
					alternative.remove();
					
				} else {
					
					alternative.find("input[name^='signer-type']").val(type)
					
					var visiblename = "";
					var firstname = "";
					var lastname = "";
					var email = "";
					var citizenID = "";
					var mobilePhone = "";
					var userID = "";
					var username = "";
					var title = "";
					
					if (type == "POSTER") {
						
						var posterInfo = $("#poster-info");
						firstname = posterInfo.data("firstname");
						lastname = posterInfo.data("lastname");
						email = posterInfo.data("email");
						userID = posterInfo.data("userid");
						username = posterInfo.data("username");
						
						visiblename = firstname + " " + lastname;
						
						if (username != "") {
							visiblename += " (" + username + ")";
						}
						
					} else if (type == "INTERNAL_USER") {
						
						var userEntry = $("#internal-user-list").children(".internal-user-list-entry");
						
						if (userEntry.length == 1) {
							
							userID = userEntry.children("input[name='internal-user']").val();
							firstname = userEntry.children("input[name^='internal-user-name']").val();
							visiblename = firstname;
							
							var fields = $("#internalFields");
							
							email = fields.find("input[name='email']").val();
							username = fields.find("input[name='username']").val();
							title = fields.find("input[name='title']").val();
							
							if (email != "") {
								
								visiblename = visiblename.substring(0, visiblename.length - 1 - email.length);
								
								if (visiblename.endsWith(", ")) {
									visiblename = visiblename.substring(0, visiblename.length - 2);
								}
								
								if (visiblename.endsWith("(")) {
									visiblename = visiblename.substring(0, visiblename.length - 1);
								} else {
									visiblename += ')';
								}
							}
							
							var nameParanIndex = firstname.indexOf(" (");
							
							if (nameParanIndex != -1) {
								firstname = firstname.substring(0, nameParanIndex);
							}
							
						} else {
							alternative.remove();
						}
						
					} else if (type == "EXTERNAL_USER") {
						
						var fields = $("#externalFields");
						
						firstname = fields.find("input[name='firstname']").val();
						lastname = fields.find("input[name='lastname']").val();
						email = fields.find("input[name='email']").val();
						citizenID = fields.find("input[name='citizenID']").val();
						mobilePhone = fields.find("input[name='mobilePhone']").val();
						
						var errors = false;
						
						var emailOrPhoneRequired = $("#emailOrPhoneRequired").hide();
						var invalidEmail = $("#invalidEmail").hide();
						var invalidMobilePhone = $("#invalidMobilePhone").hide();
						var invalidCitizenID = $("#invalidCitizenID").hide();
						
						if (email == "" && mobilePhone == "") {
							errors = true;
							emailOrPhoneRequired.show();
						}
						
						if (email != "" && !validateField("email", email)) {
							errors = true;
							invalidEmail.show();
						}
						
						if (mobilePhone != "" && !validateField("mobilePhone", mobilePhone)) {
							errors = true;
							invalidMobilePhone.show();
						}
						
						if (citizenID != "" && !validateField("citizenID", citizenID)) {
							errors = true;
							invalidCitizenID.show();
						}
						
						if (errors) {
							saveChanges = false;
							$(tempSaveAndOpensigner).data('clicked', false);
							return false;
						}
					}
					
					alternative.find("input[name^='signer-firstname']").val(firstname)
					alternative.find("input[name^='signer-lastname']").val(lastname)
					alternative.find("input[name^='signer-email']").val(email)
					alternative.find("input[name^='signer-citizenID']").val(citizenID)
					alternative.find("input[name^='signer-mobilePhone']").val(mobilePhone)
					alternative.find("input[name^='signer-userID']").val(userID)
					alternative.find("input[name^='signer-username']").val(username)
					alternative.find("input[name^='signer-title']").val(title)
					
					if (visiblename == "") {
						visiblename = firstname + " " + lastname;
					}
					
					alternative.find("td.name span").text(visiblename);
					alternative.find("td.email").text(email);
					alternative.find("td.citizenid").text(citizenID);
					alternative.find("td.mobilePhone").text(mobilePhone);
					
					alternative.find("img.usericon").toggle(type == "POSTER" || type == "INTERNAL_USER");
				}
				
			} else if (isNew) {
				
				alternative.remove();
			}
			
			modalParent.append(modal);
			
		},
		afterClose: function() {
			
			$("#addDocumentSignerRef").on("click", function(e) {
				//stop other handlers from triggering
			     e.stopImmediatePropagation();
			});
			
			if($(tempSaveAndOpensigner).data('clicked')) {
				setTimeout(function() {
	    			$("#addDocumentSignerRef").trigger("click");
				},200);
				
			}
		},
	};
	
	$.featherlight(modal, config);
}

function applySignerType() {
	var modal = $("#signerModal");
	var type = modal.find("input[name='type']:checked").val();
	
	var internal = type == "INTERNAL_USER";
	$("#internalFields").toggle(internal).find("input").prop("disabled", !internal);
	
	var external = type == "EXTERNAL_USER";
	$("#externalFields").toggle(external).find("input").prop("disabled", !external);
}

function validateField(fieldName, fieldValue) {
	
	var valid = true;
	
	$.ajax({
		url: DocumentSigning18n.moduleURI + "/validatefield",
		data: {
			field: fieldName,
			value: fieldValue
		},
		async: false,
		beforeSend: function(jqXHR, settings) {
			jqXHR.setRequestHeader('NoLoginRedirect', 'true');
		},
		success: function (result) {
			if (result != null && result.valid == false) {
				valid = false;
			}
		},
	});
	
	return valid;
}