package com.nordicpeak.flowengine.queries.dynamictablequery;

import java.lang.reflect.Field;

import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.populators.EnumPopulator;
import se.unlogic.webutils.http.BeanRequestPopulator;

import com.nordicpeak.flowengine.populators.AlternativesPopulator;
import com.nordicpeak.flowengine.queries.basetablequery.ColumnType;
import com.nordicpeak.flowengine.queries.basetablequery.TableColumnCRUD;

public class DynamicTableColumnCRUD extends TableColumnCRUD<DropDownAlternative, DynamicTableCellValue, DynamicTableRow, DynamicTableQueryInstance, DynamicTableColumn, DynamicTableQuery, DynamicTableQueryProviderModule> {

	protected static EnumPopulator<ColumnType> COLUM_TYPE_POPULATOR = new EnumPopulator<>(ColumnType.class);
	protected static AlternativesPopulator<DropDownAlternative> ALTERNATIVES_POPLATOR = new AlternativesPopulator<>(DropDownAlternative.class, "DropDownAlternatives");

	public DynamicTableColumnCRUD(AnnotatedDAOWrapper<DynamicTableColumn, Integer> tableColumnDAO, BeanRequestPopulator<DynamicTableColumn> populator, String typeElementName, String typeLogName, String listMethodAlias, DynamicTableQueryProviderModule callback) {

		super(tableColumnDAO, populator, typeElementName, typeLogName, listMethodAlias, callback);
	}

	@Override
	protected AlternativesPopulator<DropDownAlternative> getAlternativesPopulator() {

		return ALTERNATIVES_POPLATOR;
	}

	@Override
	protected Field[] getColumnRelations() {

		return new Field[] { DynamicTableColumn.QUERY_RELATION, DynamicTableColumn.ROWSUM_ADD_COLUMNS_RELATION, DynamicTableColumn.ROWSUM_SUBTRACT_COLUMNS_RELATION };
	}

}
