package com.nordicpeak.flowengine.easitgetitemsalternativelist;

import java.io.Serializable;
import java.util.List;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.OneToMany;
import se.unlogic.standardutils.dao.annotations.OrderBy;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "easit_alternative_list_endpoints")
@XMLElement(name = "Endpoint")
public class EasitGetItemsEndpoint extends GeneratedElementable implements Serializable {

	private static final long serialVersionUID = -3028605956403671547L;

	@DAOManaged(autoGenerated = true)
	@Key
	@XMLElement
	private Integer endpointID;

	@DAOManaged
	@OrderBy
	@XMLElement
	private String name;

	@DAOManaged
	@XMLElement
	private String webServiceAddress;

	@DAOManaged
	@XMLElement
	private String apiKey;

	@DAOManaged
	@OneToMany
	private List<ListSource> listSources;

	public Integer getEndpointID() {

		return endpointID;
	}

	public void setEndpointID(Integer endpointID) {

		this.endpointID = endpointID;
	}

	public String getName() {

		return name;
	}

	public void setName(String name) {

		this.name = name;
	}

	public String getWebServiceAddress() {

		return webServiceAddress;
	}

	public void setWebServiceAddress(String webServiceAddress) {

		this.webServiceAddress = webServiceAddress;
	}

	public String getApiKey() {

		return apiKey;
	}

	public void setApiKey(String apiKey) {

		this.apiKey = apiKey;
	}

	public List<ListSource> getListSources() {

		return listSources;
	}

	public void setListSources(List<ListSource> listSources) {

		this.listSources = listSources;
	}

	@Override
	public String toString() {

		return name + " (endpointID: " + endpointID + ")";
	}

}
