package com.nordicpeak.flowengine.integration.efecte.beans;

import java.util.List;

import se.unlogic.emailutils.framework.EmailUtils;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.OneToMany;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.string.StringUtils;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.integration.base.beans.BaseIntegrationEndpoint;

@Table(name = "efecte_integration_endpoints")
@XMLElement(name = "Endpoint")
public class IntegrationEndpoint extends BaseIntegrationEndpoint {

	@DAOManaged
	@XMLElement
	private String importAddress;

	@DAOManaged
	@XMLElement
	private String searchAddress;

	@DAOManaged
	@XMLElement
	private String fileUploadAddress;

	@DAOManaged
	@XMLElement
	private String emailAddress;

	@DAOManaged
	@XMLElement
	private String emailSenderAddress;

	@DAOManaged
	@XMLElement
	private String emailSenderName;

	@DAOManaged
	@OneToMany
	private List<IntegrationSettings> integrationSettings;

	public String getImportAddress() {

		return importAddress;
	}

	public void setImportAddress(String address) {

		this.importAddress = address;
	}

	public List<IntegrationSettings> getIntegrationSettings() {

		return integrationSettings;
	}

	public void setIntegrationSettings(List<IntegrationSettings> integrationSettings) {

		this.integrationSettings = integrationSettings;
	}

	public String getSearchAddress() {

		return searchAddress;
	}

	public void setSearchAddress(String searchAddress) {

		this.searchAddress = searchAddress;
	}

	public String getFileUploadAddress() {

		return fileUploadAddress;
	}

	public void setFileUploadAddress(String fileUploadAddress) {

		this.fileUploadAddress = fileUploadAddress;
	}

	public String getEmailAddress() {

		return emailAddress;
	}

	public void setEmailAddress(String emailAddress) {

		this.emailAddress = emailAddress;
	}

	public String getEmailSenderAddress() {

		return emailSenderAddress;
	}

	public void setEmailSenderAddress(String senderEmailAddress) {

		this.emailSenderAddress = senderEmailAddress;
	}

	public String getEmailSenderName() {

		return emailSenderName;
	}

	public void setEmailSenderName(String senderEmailName) {

		this.emailSenderName = senderEmailName;
	}

	public boolean hasEmailConfiguration() {

		return EmailUtils.isValidEmailAddress(emailAddress) && EmailUtils.isValidEmailAddress(emailSenderAddress) && !StringUtils.isEmpty(emailSenderName);
	}
}
