$(function(){
	
	$('.notification-email-toggle').on("change", function(){
		
		$(this).closest('.notification-email').find('.notification-email-text').toggle(this.checked);
		
	}).trigger("change");	
	
	
	var $caseStatusName = $('#caseStatusName');
	
	$('#createCaseOnSpecificStatus').on("change", function(){
		
		$caseStatusName.parent().toggle(this.checked);
		
	}).trigger("change");
	
	var url = $caseStatusName.parent().data("connectorUrl");
	
	$caseStatusName.autocomplete({
		source: function(request, response) {
			return getStatuses(response, url, $caseStatusName);
		},
		select: function( event, ui ) {
			
			$caseStatusName.val(ui.item.value);
			return false;
		},
		focus: function(event, ui) {
			event.preventDefault();
		}
	});
	
	$caseStatusName.on("focus", function(){
			
		$(this).autocomplete("search", " ");
	});
	
});

function getStatuses(response, searchURL, searchInput) {
	
	searchInput.addClass("ui-autocomplete-loading");
	
	$.ajax({
		url : searchURL,
		dataType : "json",
		contentType: "application/x-www-form-urlencoded;charset=UTF-8",
		success : function(data) {
			
			if (data.hits != undefined && data.hits.length > 0) {
				
				response($.map(data.hits, function(item) {
					
					return {
						label : item,
						value : item,
					}
				}));
			} else {
				response(null);
			}
			
			searchInput.removeClass("ui-autocomplete-loading");
			
		},
		error : function() {
			
			searchInput.removeClass("ui-autocomplete-loading");
		}
	});
}