<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:exsl="http://exslt.org/common">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
		/js/confirmpost.js
	</xsl:variable>
	
	<xsl:variable name="scripts">
		/js/externalalternativelists.js
	</xsl:variable>
	
	
	<xsl:template name="ListTableColumns">
	
		<th><xsl:value-of select="$i18n.Name" /></th>
		<th><xsl:value-of select="$i18n.URL" /></th>
		<th><xsl:value-of select="$i18n.CacheTime" /></th>
		<th><xsl:value-of select="$i18n.Size" /></th>
		<th class="nosort" style="width: 61px;"></th>
	
	</xsl:template>
	
	<xsl:template match="AlternativeList" mode="list">
	
		<xsl:variable name="name" select="name"/>
	
		<tr>
			<td data-title="{$i18n.Name}">
				<a href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/show/{listID}">
					<xsl:value-of select="name"/>
				</a>
			</td>
			<td class="word-break-all" data-title="{$i18n.URL}"><xsl:value-of select="url"/></td>
			<td data-title="{$i18n.CacheTime}">
				<xsl:if test="cacheRefreshTime">
					<xsl:value-of select="cacheRefreshTime"/>
					<xsl:text>m</xsl:text>
				</xsl:if>
			</td>
			<td data-title="{$i18n.Size}"><xsl:value-of select="../../ListSize[Name = $name]/Value"/></td>
			<td>
				<a href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/usage/{listID}" title="{$i18n.FlowUsage.Button}">
					<img class="alignbottom" src="{/Document/requestinfo/contextpath}/static/f/{/Document/module/sectionID}/{/Document/module/moduleID}/pics/magnifying_glass.png" alt="" />
				</a>
				
				<a  class="marginleft" href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/update/{listID}" title="{$i18n.UpdateList}: {name}">
					<img class="alignbottom" src="{/Document/requestinfo/contextpath}/static/f/{/Document/module/sectionID}/{/Document/module/moduleID}/pics/pen.png" alt="" />
				</a>
				
				<a class="marginleft" href="{/Document/requestinfo/currentURI}/{/Document/module/alias}/delete/{listID}" onclick="return confirmHyperlinkPost(this);" title="{$i18n.DeleteList}: {name}">
					<img class="alignbottom" src="{/Document/requestinfo/contextpath}/static/f/{/Document/module/sectionID}/{/Document/module/moduleID}/pics/delete.png" alt="" />
				</a>
			</td>
		</tr>
		
	</xsl:template>
	
	<xsl:template name="editListDetails">

		<div class="floatleft full bigmarginbottom">
			<label for="url" class="floatleft"><xsl:value-of select="$i18n.URL" /></label>
			<div class="floatleft full">
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'url'"/>
					<xsl:with-param name="name" select="'url'"/>
					<xsl:with-param name="title" select="$i18n.URL"/>
					<xsl:with-param name="element" select="AlternativeList" />
				</xsl:call-template>
		    </div>
		</div>
		
		<div class="floatleft full bigmarginbottom">
			<label for="cacheRefreshTime" class="floatleft"><xsl:value-of select="$i18n.CacheRefreshTime" /></label>
			<div class="floatleft full">
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'cacheRefreshTime'"/>
					<xsl:with-param name="name" select="'cacheRefreshTime'"/>
					<xsl:with-param name="title" select="$i18n.CacheRefreshTime"/>
					<xsl:with-param name="element" select="AlternativeList" />
				</xsl:call-template>
		    </div>
		</div>
		
		<div class="floatleft full bigmarginbottom">
			<div class="floatleft full">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'keepOldListOnRefreshFail'" />
					<xsl:with-param name="name" select="'keepOldListOnRefreshFail'" />
					<xsl:with-param name="element" select="AlternativeList" /> 
					<xsl:with-param name="title" select="$i18n.keepOldListOnRefreshFail"/>
					<xsl:with-param name="class" select="'vertical-align-middle'" />
				</xsl:call-template>
					
				<label for="keepOldListOnRefreshFail">
					<xsl:value-of select="$i18n.keepOldListOnRefreshFail" />
				</label>
		    </div>
		</div>

		<div class="floatleft full bigmarginbottom">
			<div class="floatleft full">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'enableAttributeFiltering'" />
					<xsl:with-param name="name" select="'enableAttributeFiltering'" />
					<xsl:with-param name="element" select="AlternativeList" /> 
					<xsl:with-param name="title" select="$i18n.enableAttributeFiltering"/>
					<xsl:with-param name="class" select="'vertical-align-middle'" />
				</xsl:call-template>
					
				<label for="enableAttributeFiltering">
					<xsl:value-of select="$i18n.enableAttributeFiltering" />
				</label>
		    </div>
		</div>
		
		<div id="dynamicURLContainer" class="floatleft full bigmarginbottom">
			<label for="dynamicURL" class="floatleft"><xsl:value-of select="$i18n.DynamicURL" /></label>
			<div class="floatleft full">
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'dynamicURL'"/>
					<xsl:with-param name="name" select="'dynamicURL'"/>
					<xsl:with-param name="title" select="$i18n.DynamicURL"/>
					<xsl:with-param name="element" select="AlternativeList" />
				</xsl:call-template>
		    </div>
		    
		    <xsl:call-template name="tagTable" />
		    
		</div>
		
		<h2><xsl:value-of select="$i18n.Authentication"/></h2>
		
		<div class="floatleft full bigmarginbottom">
			<div class="floatleft full">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'useAuthentication'" />
					<xsl:with-param name="name" select="'useAuthentication'" />
					<xsl:with-param name="element" select="AlternativeList" /> 
					<xsl:with-param name="class" select="'vertical-align-middle'" />
				</xsl:call-template>
					
				<label for="useAuthentication">
					<xsl:value-of select="$i18n.UseAuthentication" />
				</label>
		    </div>
		</div>
		
		<div class="floatleft full bigmarginbottom">
			<label for="username" class="floatleft"><xsl:value-of select="$i18n.Username" /></label>
			<div class="floatleft full">
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'username'"/>
					<xsl:with-param name="name" select="'username'"/>
					<xsl:with-param name="title" select="$i18n.Username"/>
					<xsl:with-param name="element" select="AlternativeList" />
				</xsl:call-template>
		    </div>
		</div>			
		
		<div class="floatleft full bigmarginbottom">
			<label for="password" class="floatleft"><xsl:value-of select="$i18n.Password" /></label>
			<div class="floatleft full">
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'password'"/>
					<xsl:with-param name="name" select="'password'"/>
					<xsl:with-param name="title" select="$i18n.Password"/>
					<xsl:with-param name="element" select="AlternativeList" />
				</xsl:call-template>
		    </div>
		</div>
			
		<div class="floatleft full bigmarginbottom">
			<label for="password" class="floatleft clearboth"><xsl:value-of select="$i18n.Encoding" /></label>
			
			<div class="floatleft full">
				<xsl:call-template name="createDropdown">
					<xsl:with-param name="id" select="'encoding'"/>
					<xsl:with-param name="name" select="'encoding'"/>
					<xsl:with-param name="selectedValue" select="AlternativeList/encoding" />
					<xsl:with-param name="element" select="AllowedEncodings/Encoding"/>
					<xsl:with-param name="simple" select="true()"/>
				</xsl:call-template>
			</div>
		</div>
				
		<h2><xsl:value-of select="$i18n.XPath"/></h2>
		
		<p><xsl:value-of select="$i18n.XPathDescription"/></p>		
		
		<div class="floatleft full bigmarginbottom">
			<label for="alternativeXPath" class="floatleft"><xsl:value-of select="$i18n.AlternativeXPath" /></label>
			<div class="floatleft full">
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'alternativeXPath'"/>
					<xsl:with-param name="name" select="'alternativeXPath'"/>
					<xsl:with-param name="title" select="$i18n.AlternativeXPath"/>
					<xsl:with-param name="element" select="AlternativeList" />
				</xsl:call-template>
		    </div>
		</div>
		
		<div class="floatleft full bigmarginbottom">
			<label for="keyXPath" class="floatleft"><xsl:value-of select="$i18n.KeyXPath" /></label>
			<div class="floatleft full">
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'keyXPath'"/>
					<xsl:with-param name="name" select="'keyXPath'"/>
					<xsl:with-param name="title" select="$i18n.KeyXPath"/>
					<xsl:with-param name="element" select="AlternativeList" />
				</xsl:call-template>
		    </div>
		</div>
		
		<div class="floatleft full bigmarginbottom">
			<label for="valueXPath" class="floatleft"><xsl:value-of select="$i18n.ValueXPath" /></label>
			<div class="floatleft full">
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'valueXPath'"/>
					<xsl:with-param name="name" select="'valueXPath'"/>
					<xsl:with-param name="title" select="$i18n.ValueXPath"/>
					<xsl:with-param name="element" select="AlternativeList" />
				</xsl:call-template>
		    </div>
		</div>		
		
	</xsl:template>

	<xsl:template name="tagTable">
	
		<div class="floatleft margintop full">

			<p><xsl:value-of select="$i18n.TagsTable.description.part1"/></p>
			<p><xsl:value-of select="$i18n.DynamicURLExample" /></p>
			<p><xsl:value-of select="$i18n.TagsTable.description.part2"/></p>
		
			<table class="full border">
				<tr>
					<th>
						<xsl:value-of select="$i18n.Tag"/>
					</th>
					<th>
						<xsl:value-of select="$i18n.Description"/>
					</th>
				</tr>
				<tr>
					<td>
						<xsl:text>$user.firstname</xsl:text>
					</td>
					<td>
						<xsl:value-of select="$i18n.UserFirstnameTag"/>
					</td>
				</tr>
				<tr>
					<td>
						<xsl:text>$user.lastname</xsl:text>
					</td>
					<td>
						<xsl:value-of select="$i18n.UserLastnameTag"/>
					</td>
				</tr>
				<tr>
					<td>
						<xsl:text>$user.email</xsl:text>
					</td>
					<td>
						<xsl:value-of select="$i18n.UserEmailTag"/>
					</td>
				</tr>
				<tr>
					<td>
						<xsl:text>$user.username</xsl:text>
					</td>
					<td>
						<xsl:value-of select="$i18n.UserUsernameTag"/>
					</td>
				</tr>
				<tr>
					<td>
						<xsl:text>$user.userID</xsl:text>
					</td>
					<td>
						<xsl:value-of select="$i18n.UserUserIDTag"/>
					</td>
				</tr>
				<tr>
					<td>
						<xsl:text>$user.attribute{citizenIdentifier}</xsl:text>
					</td>
					<td>
						<xsl:value-of select="$i18n.UserCitizenIdentifierTag"/>
					</td>
				</tr>
			</table>
		
		</div>
	
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'InvalidURL']">
		
		<p class="error">
			<xsl:value-of select="$i18n.validationError.InvalidURL" />
		</p>
		
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'InvalidSource']">
		
		<p class="error">
			<xsl:value-of select="$i18n.validationError.InvalidSource" />
		</p>
		
	</xsl:template>
	
	<xsl:template match="fieldName">

		<xsl:variable name="fieldName" select="." />

		<xsl:choose>
			<xsl:when test="$fieldName = 'url'">
				<xsl:value-of select="$i18n.URL" />
			</xsl:when>
			<xsl:when test="$fieldName = 'cacheRefreshTime'">
				<xsl:value-of select="$i18n.CacheRefreshTime" />
			</xsl:when>
			<xsl:when test="$fieldName = 'dynamicURL'">
				<xsl:value-of select="$i18n.DynamicURL" />
			</xsl:when>
			<xsl:when test="$fieldName = 'username'">
				<xsl:value-of select="$i18n.Username" />
			</xsl:when>
			<xsl:when test="$fieldName = 'password'">
				<xsl:value-of select="$i18n.Password" />
			</xsl:when>
			<xsl:when test="$fieldName = 'encoding'">
				<xsl:value-of select="$i18n.Encoding" />
			</xsl:when>
			<xsl:when test="$fieldName = 'alternativeXPath'">
				<xsl:value-of select="$i18n.AlternativeXPath" />
			</xsl:when>
			<xsl:when test="$fieldName = 'keyXPath'">
				<xsl:value-of select="$i18n.KeyXPath" />
			</xsl:when>
			<xsl:when test="$fieldName = 'valueXPath'">
				<xsl:value-of select="$i18n.ValueXPath" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>
	
</xsl:stylesheet>