package com.nordicpeak.flowengine.externalalternativelist;

import java.lang.reflect.Field;
import java.sql.Timestamp;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.reflection.ReflectionUtils;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.alternativelist.provider.BaseAlternativeListEvent;

@Table(name = "external_alternative_list_events")
@XMLElement(name = "AlternativeListEvent")
public class ListSourceEvent extends BaseAlternativeListEvent<ListSource, ListSourceEvent> {
	
	public static final Field LIST_RELATION = ReflectionUtils.getField(ListSourceEvent.class, "list");
	
	@DAOManaged(columnName = "listID")
	@ManyToOne
	@XMLElement
	private ListSource list;
	
	public ListSourceEvent() {
		super();
	}
	
	public ListSourceEvent(ListSource list, Timestamp added, User poster, String message) {
		super(list, added, poster, message);
	}
	
	@Override
	public ListSource getList() {
		return list;
	}
	
	@Override
	public void setList(ListSource list) {
		this.list = list;
	}
	
}
