package com.nordicpeak.flowengine.flowinstanceadmin2.beans;

import java.sql.Date;
import java.time.LocalDate;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.date.DateStringyfier;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.flowinstanceadmin2.enums.ManagerDisplayMode;
import com.nordicpeak.flowengine.flowinstanceadmin2.enums.OpenMode;

@Table(name = "flowengine_flowadmin_user_settings")
@XMLElement
public class FlowInstanceAdminUserSettings extends GeneratedElementable {

	@DAOManaged(columnName = "userID")
	@Key
	@XMLElement
	private User user;

	@DAOManaged
	@XMLElement
	private String columnOrder;

	@DAOManaged
	@XMLElement
	private String columnVisibility;

	@DAOManaged
	@XMLElement
	private String lastSavedTable;

	@DAOManaged
	@XMLElement
	private String tableUnassigned;

	@DAOManaged
	@XMLElement
	private String tablePrioritized;

	@DAOManaged
	@XMLElement
	private String tableMine;

	@DAOManaged
	@XMLElement
	private String tableBookmarked;

	@DAOManaged
	@XMLElement
	private String tableActive;

	@DAOManaged
	@XMLElement
	private String tableAll;

	@DAOManaged
	@XMLElement
	private OpenMode openMode;

	@DAOManaged
	@XMLElement
	private ManagerDisplayMode managerDisplayMode;

	@DAOManaged
	@XMLElement
	private DateInterval dateInterval;

	@DAOManaged
	@XMLElement(valueFormatter = DateStringyfier.class)
	private Date fromDate;

	@DAOManaged
	@XMLElement(valueFormatter = DateStringyfier.class)
	private Date toDate;

	public User getUser() {

		return user;
	}

	public void setUser(User user) {

		this.user = user;
	}

	public String getColumnOrder() {

		return columnOrder;
	}

	public void setColumnOrder(String columnOrder) {

		this.columnOrder = columnOrder;
	}

	public String getColumnVisibility() {

		return columnVisibility;
	}

	public void setColumnVisibility(String columnVisibility) {

		this.columnVisibility = columnVisibility;
	}

	public String getTableUnassigned() {

		return tableUnassigned;
	}

	public void setTableUnassigned(String tableUnassigned) {

		this.tableUnassigned = tableUnassigned;
	}

	public String getTablePrioritized() {

		return tablePrioritized;
	}

	public void setTablePrioritized(String tablePrioritized) {

		this.tablePrioritized = tablePrioritized;
	}

	public String getTableMine() {

		return tableMine;
	}

	public void setTableMine(String tableMine) {

		this.tableMine = tableMine;
	}

	public String getTableBookmarked() {

		return tableBookmarked;
	}

	public void setTableBookmarked(String tableBookmarked) {

		this.tableBookmarked = tableBookmarked;
	}

	public String getTableActive() {

		return tableActive;
	}

	public void setTableActive(String tableActive) {

		this.tableActive = tableActive;
	}

	public String getTableAll() {

		return tableAll;
	}

	public void setTableAll(String tableAll) {

		this.tableAll = tableAll;
	}

	public String getLastSavedTable() {

		return lastSavedTable;
	}

	public void setLastSavedTable(String lastSavedTable) {

		this.lastSavedTable = lastSavedTable;
	}

	public OpenMode getOpenMode() {

		return openMode;
	}

	public void setOpenMode(OpenMode openMode) {

		this.openMode = openMode;
	}

	public ManagerDisplayMode getManagerDisplayMode() {

		return managerDisplayMode;
	}

	public void setManagerDisplayMode(ManagerDisplayMode managerDisplayMode) {

		this.managerDisplayMode = managerDisplayMode;
	}

	public DateInterval getDateInterval() {

		return dateInterval;
	}

	public void setDateInterval(DateInterval dateInterval) {

		this.dateInterval = dateInterval;
	}

	public Date getFromDate() {

		return fromDate;
	}

	public void setFromDate(Date fromDate) {

		this.fromDate = fromDate;
	}

	public Date getToDate() {

		return toDate;
	}

	public void setToDate(Date toDate) {

		this.toDate = toDate;
	}

	public Date calculateFromDate(DateInterval defaultDateInterval) {

		if(dateInterval == DateInterval.ALL || (dateInterval == null && defaultDateInterval == DateInterval.ALL)) {
			
			return null;
		}
		
		if (dateInterval != DateInterval.CUSTOM) {

			int monthsBack = dateInterval != null ? dateInterval.getValue() : defaultDateInterval.getValue();

			return java.sql.Date.valueOf(LocalDate.now().minusMonths(monthsBack));
		}

		return fromDate;
	}

}
