package com.nordicpeak.flowengine.flowinstanceadmin2.enums;

public enum TableSettingColumnType {

	INSTANCE_ID("instanceID"),
	EXTERNAL_ID("externalID"),
	EVENTS("events"),
	SELECT("select"),
	STATUS("status"),
	SUBMITTED("submitted"),
	POSTER("poster"),
	DESCRIPTION("description"),
	FLOW_NAME("flowName"),
	VERSION("version"),
	CATEGORY("category"),
	SITE_PROFILE("siteProfile"),
	MANAGERS("managers"),
	COLORED_TAG("coloredTag");

	private String name;

	TableSettingColumnType(String name) {

		this.name = name;
	}

	public String getName() {

		return name;
	}

	public static TableSettingColumnType fromName(String name) {

		TableSettingColumnType[] rowTypes = TableSettingColumnType.values();

		for (TableSettingColumnType rowType : rowTypes) {

			if (rowType.name != null && rowType.name.equals(name)) {

				return rowType;
			}
		}

		return null;
	}

	@Override
	public String toString() {

		return name;
	}

}
