package com.nordicpeak.flowengine.flowinstanceadmin2.export.excel.beans;

import java.util.List;

import se.unlogic.standardutils.annotations.NoDuplicates;
import se.unlogic.standardutils.annotations.SplitOnLineBreak;
import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.collections.CaseInsensitiveStringComparator;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.OneToMany;
import se.unlogic.standardutils.dao.annotations.SimplifiedRelation;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "flow_instance_excel_exporter_settings")
@XMLElement
public class FlowFamilyExportSettings extends GeneratedElementable {

	@DAOManaged
	@Key
	@XMLElement
	private Integer flowFamilyID;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean enabled;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean exportLastStatusChange = false;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean exportExternalFlowID = false;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean hideQueryColumns;

	@DAOManaged
	@OneToMany(autoAdd = true, autoGet = true, autoUpdate = true)
	@SimplifiedRelation(table = "flow_instance_excel_exporter_attributes", remoteValueColumnName = "exportAttribute", preserveListOrder = true, indexColumn = "sortIndex")
	@WebPopulate(maxLength = 255)
	@SplitOnLineBreak
	@NoDuplicates(comparator = CaseInsensitiveStringComparator.class)
	@XMLElement(fixCase = true, childName = "exportAttribute")
	private List<String> exportAttributes;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean addDateToFileName;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean exportColoredTags;	
	
	public Integer getFlowFamilyID() {

		return flowFamilyID;
	}

	public void setFlowFamilyID(Integer flowFamilyID) {

		this.flowFamilyID = flowFamilyID;
	}

	public boolean isEnabled() {

		return enabled;
	}

	public void setEnabled(boolean enabled) {

		this.enabled = enabled;
	}

	public boolean isExportLastStatusChange() {

		return exportLastStatusChange;
	}

	public void setExportLastStatusChange(boolean exportLastStatusChange) {

		this.exportLastStatusChange = exportLastStatusChange;
	}

	public boolean isExportExternalFlowID() {

		return exportExternalFlowID;
	}

	public void setExportExternalFlowID(boolean exportExternalFlowID) {

		this.exportExternalFlowID = exportExternalFlowID;
	}

	public boolean isHideQueryColumns() {

		return hideQueryColumns;
	}

	public void setHideQueryColumns(boolean hideQueryColumns) {

		this.hideQueryColumns = hideQueryColumns;
	}

	public List<String> getExportAttributes() {

		return exportAttributes;
	}

	public void setExportAttributes(List<String> exportAttributes) {

		this.exportAttributes = exportAttributes;
	}

	public boolean addDateToFileName() {

		return addDateToFileName;
	}

	public void setAddDateToFileName(boolean addDateToFileName) {

		this.addDateToFileName = addDateToFileName;
	}

	public boolean isExportColoredTags() {
		
		return exportColoredTags;
	}

	public void setExportColoredTags(boolean exportColoredTags) {
		
		this.exportColoredTags = exportColoredTags;
	}
}
