
var CHECK_PROGRESS_INTERVAL = 1000;

$(function() {
	
	var table = $("#flowversionlist");
	
	if (table.length > 0) {
		$("#select-page").on("change", function(){
			var checkbox = $(this);
			
			table.find("input[type='checkbox']").prop("checked", checkbox.prop("checked"));
		});
	}
	
	$("#exportSettingsForm").on("click", "#enabled", function(e) {
	
		$("#settingsContainer").toggle($(this).is(":checked"));
	});	
});


$(document).on("initTable", function(event, initData) {
	
	var panel = initData.panel;
	var tableElement = initData.tableElement;
	var table = initData.table;
	
	var excelExportButton = panel.find(".excel-export");
	
	var updateExcelExportButton = function() {
		
		if (table.isInternalSelection()) {
		
			excelExportButton.removeClass("disabled");
		
		} else {
		
			excelExportButton.addClass("disabled");
		}
	}
	
	table.on('select.dt', function() {
		updateExcelExportButton();
	});
	
	table.on('deselect.dt', function() {
		updateExcelExportButton();
	});
	
	table.on('search.dt', function() {
		excelExportButton.removeClass("disabled");
	});
	
	excelExportButton.on("click", function() {
		
		var rows = table.rows({ selected: true });
		
		if (!rows.any()) {

			window.location = excelExportButton.data("baseurl");
		
		} else if (FlowInstanceAdmin2.adminFlowInstanceProviders && !table.isInternalSelection()) {
			
			alert(FlowInstanceAdmin2.i18n.requiresInternalSelection);
		
		} else {
		
			var cells = table.cells(rows.toArray()[0], "instanceID:name");
			var selectedIDs = cells.data().toArray();
			
			submitSelection(selectedIDs, excelExportButton.data("url"));
		}
	});
});

function exportFlowInstances(input, event) {
	event.preventDefault();
	
	var form = input.form;
	var $input = $(input);
	
	if (!$.featherlight.current()) {
		
		var modal = $('#exportProgressModal');
		
		var progressCheck = null;
		var scheduledProgressCheck = null;
		
		$.featherlight(modal, {
			
			afterContent: function() {
				
				var featherlight = this;
				var content = featherlight.$content;
				
				content.removeClass("no-sections");
				content.closest('.featherlight-content').addClass('small-modal');

				var versionDiv = content.find(".progressTextVersion, .versionBar");
				var totalDiv = content.find(".progressTextTotal");
				var headerWorking = content.find("h1.working");
				var headerDone = content.find("h1.done");
				
				versionDiv.hide();
				totalDiv.hide();
				headerWorking.show();
				headerDone.hide();
				
				content.find('.versionBar .progressBar').css('width', '0%');
				content.find('.totalBar .progressBar').css('width', '0%');
				
				$input.prop('disabled', true);
				
				var start = Date.now();
				var $form = $(form);
				$form.find("input[name='timestamp']").val(start);
				
				progressCheck = function() {
					
					$.ajax({
						url: modal.data("url") + start,
						cache: false,
						beforeSend: function(jqXHR, settings) {
							jqXHR.setRequestHeader('NoLoginRedirect', 'true');
						},
						success: function(data) {
							
							if (data.done != null) {
								
								if (data.done == true) {
									
									headerWorking.hide();
									headerDone.show();
									
									content.find(".versionProgress").text(content.find(".versionTotal").text());
									content.find(".totalProgress").text(content.find(".total").text());
									content.find('.versionBar .progressBar').css('width', "100%");
									content.find('.totalBar .progressBar').css('width', "100%");
									
								} else {
									
									featherlight.close();
								}
								
							} else if (data.total != null) {
								
								var formatValue = function(text) {
									if (text != null) {
										return text;
									} else {
										return "0";
									}
								}
								
								if (data.version != null) {
									
									content.find(".version").text(data.version);
									content.find(".versionProgress").text(data.versionProgress);
									content.find(".versionTotal").text(data.versionTotal);
									
									if (versionDiv.css("display") == "none") {
										versionDiv.show();
									}
								}
								
								content.find(".totalProgress").text(formatValue(data.totalProgress));
								content.find(".total").text(data.total);
								
								if (totalDiv.css("display") == "none") {
									totalDiv.show();
								}
									
								var versionProgressPercentage = parseInt((100 * data.versionProgress) / data.versionTotal);
								var totalProgressPercentage = parseInt((100 * data.totalProgress) / data.total);
								content.find('.versionBar .progressBar').css('width', versionProgressPercentage + '%');
								content.find('.totalBar .progressBar').css('width', totalProgressPercentage + '%');
							}
							
							if (data.done == null) {
								scheduledProgressCheck = window.setTimeout(progressCheck, CHECK_PROGRESS_INTERVAL);
							}
						},
						error: function(jqXHR, textStatus, errorThrown) {
							
							content.find(".versionProgress").text("?");
							content.find(".totalProgress").text("?");
							
//							featherlight.close();
						}
					});
				};
				
				scheduledProgressCheck = window.setTimeout(progressCheck, CHECK_PROGRESS_INTERVAL);
				
				form.action = $input.data("url");
				form.submit();
			},
		
			beforeClose: function() {
				
				if (progressCheck != null) {
					window.clearTimeout(scheduledProgressCheck);
					
					if (window.stop) {
						window.stop();
					}
				}
				
				$input.prop('disabled', false);
			},
		});
	}
}
