package com.nordicpeak.flowengine.voting;

import java.io.Serializable;
import java.sql.Timestamp;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "flow_family_votes")
@XMLElement(name = "Vote")
public class FlowFamilyVote extends GeneratedElementable implements Serializable {
	
	private static final long serialVersionUID = 5949025706273639735L;
	
	@DAOManaged
	@Key
	@XMLElement
	private Integer flowInstanceID;
	
	@DAOManaged(columnName = "userID")
	@Key
	@XMLElement
	private User user;
	
	@DAOManaged
	@XMLElement
	private Timestamp timestamp;
	
	public Integer getFlowInstanceID() {
		return flowInstanceID;
	}
	
	public void setFlowInstanceID(Integer flowInstanceID) {
		this.flowInstanceID = flowInstanceID;
	}
	
	public User getUser() {
		return user;
	}
	
	public void setUser(User user) {
		this.user = user;
	}
	
	public Timestamp getTimestamp() {
		return timestamp;
	}
	
	public void setTimestamp(Timestamp timestamp) {
		this.timestamp = timestamp;
	}
	
}
