package com.nordicpeak.flowengine.voting;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.net.URLDecoder;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Collection;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.sql.DataSource;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import com.nordicpeak.flowengine.FlowAdminModule;
import com.nordicpeak.flowengine.beans.Contact;
import com.nordicpeak.flowengine.beans.Flow;
import com.nordicpeak.flowengine.beans.FlowAdminExtensionShowView;
import com.nordicpeak.flowengine.beans.FlowFamily;
import com.nordicpeak.flowengine.beans.FlowInstance;
import com.nordicpeak.flowengine.beans.FlowInstanceAttribute;
import com.nordicpeak.flowengine.beans.FlowInstanceEvent;
import com.nordicpeak.flowengine.beans.FlowType;
import com.nordicpeak.flowengine.beans.Status;
import com.nordicpeak.flowengine.dao.FlowEngineDAOFactory;
import com.nordicpeak.flowengine.enums.EventType;
import com.nordicpeak.flowengine.events.StatusChangedByManagerEvent;
import com.nordicpeak.flowengine.interfaces.FlowAdminExtensionViewProvider;
import com.nordicpeak.flowengine.interfaces.ImmutableFlowFamily;
import com.nordicpeak.flowengine.interfaces.ImmutableFlowInstance;
import com.nordicpeak.flowengine.interfaces.ImmutableFlowInstanceEvent;
import com.nordicpeak.flowengine.interfaces.PDFProvider;
import com.nordicpeak.flowengine.notifications.StandardFlowNotificationHandler;
import com.nordicpeak.flowengine.utils.FlowInstanceEventGenerator;
import com.nordicpeak.flowengine.utils.FlowInstanceUtils;
import com.nordicpeak.flowengine.utils.PDFByteAttachment;

import it.sauronsoftware.cron4j.Scheduler;
import se.unlogic.cron4jutils.CronStringValidator;
import se.unlogic.hierarchy.core.annotations.CheckboxSettingDescriptor;
import se.unlogic.hierarchy.core.annotations.HTMLEditorSettingDescriptor;
import se.unlogic.hierarchy.core.annotations.InstanceManagerDependency;
import se.unlogic.hierarchy.core.annotations.ModuleSetting;
import se.unlogic.hierarchy.core.annotations.TextAreaSettingDescriptor;
import se.unlogic.hierarchy.core.annotations.TextFieldSettingDescriptor;
import se.unlogic.hierarchy.core.annotations.WebPublic;
import se.unlogic.hierarchy.core.annotations.XSLVariable;
import se.unlogic.hierarchy.core.beans.LinkTag;
import se.unlogic.hierarchy.core.beans.ScriptTag;
import se.unlogic.hierarchy.core.beans.SimpleForegroundModuleResponse;
import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.hierarchy.core.enums.CRUDAction;
import se.unlogic.hierarchy.core.enums.EventTarget;
import se.unlogic.hierarchy.core.events.CRUDEvent;
import se.unlogic.hierarchy.core.exceptions.AccessDeniedException;
import se.unlogic.hierarchy.core.exceptions.ModuleConfigurationException;
import se.unlogic.hierarchy.core.exceptions.URINotFoundException;
import se.unlogic.hierarchy.core.interfaces.ForegroundModuleResponse;
import se.unlogic.hierarchy.core.interfaces.SectionInterface;
import se.unlogic.hierarchy.core.interfaces.modules.descriptors.ForegroundModuleDescriptor;
import se.unlogic.hierarchy.core.utils.AccessUtils;
import se.unlogic.hierarchy.core.utils.AttributeTagUtils;
import se.unlogic.hierarchy.core.utils.HierarchyAnnotatedDAOFactory;
import se.unlogic.hierarchy.core.utils.ModuleUtils;
import se.unlogic.hierarchy.core.utils.ModuleViewFragmentTransformer;
import se.unlogic.hierarchy.core.utils.ViewFragmentModule;
import se.unlogic.hierarchy.foregroundmodules.AnnotatedForegroundModule;
import se.unlogic.hierarchy.foregroundmodules.MethodMapping;
import se.unlogic.openhierarchy.foregroundmodules.siteprofile.interfaces.SiteProfile;
import se.unlogic.openhierarchy.foregroundmodules.siteprofile.interfaces.SiteProfileHandler;
import se.unlogic.standardutils.collections.CollectionUtils;
import se.unlogic.standardutils.dao.AnnotatedDAO;
import se.unlogic.standardutils.dao.HighLevelQuery;
import se.unlogic.standardutils.dao.OrderByCriteria;
import se.unlogic.standardutils.dao.QueryOperators;
import se.unlogic.standardutils.dao.QueryParameterFactory;
import se.unlogic.standardutils.dao.querys.ArrayListQuery;
import se.unlogic.standardutils.dao.querys.ObjectQuery;
import se.unlogic.standardutils.dao.querys.UpdateQuery;
import se.unlogic.standardutils.date.DateUtils;
import se.unlogic.standardutils.db.tableversionhandler.TableVersionHandler;
import se.unlogic.standardutils.db.tableversionhandler.UpgradeResult;
import se.unlogic.standardutils.db.tableversionhandler.XMLDBScriptProvider;
import se.unlogic.standardutils.enums.Order;
import se.unlogic.standardutils.json.JsonArray;
import se.unlogic.standardutils.json.JsonObject;
import se.unlogic.standardutils.json.JsonUtils;
import se.unlogic.standardutils.populators.IntegerPopulator;
import se.unlogic.standardutils.rss.RSSGenerator;
import se.unlogic.standardutils.rss.RSSItem;
import se.unlogic.standardutils.rss.SimpleRSSItem;
import se.unlogic.standardutils.string.SingleTagSource;
import se.unlogic.standardutils.string.StringUtils;
import se.unlogic.standardutils.string.TagReplacer;
import se.unlogic.standardutils.time.TimeUtils;
import se.unlogic.standardutils.validation.PositiveStringIntegerValidator;
import se.unlogic.standardutils.validation.StringIntegerValidator;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.standardutils.xml.XMLUtils;
import se.unlogic.standardutils.xsl.XSLVariableReader;
import se.unlogic.standardutils.xsl.XSLVariableReaderRenamer;
import se.unlogic.webutils.http.HTTPUtils;
import se.unlogic.webutils.http.RequestUtils;
import se.unlogic.webutils.http.URIParser;
import se.unlogic.webutils.http.enums.ContentDisposition;
import se.unlogic.webutils.populators.annotated.AnnotatedRequestPopulator;

public class FlowVoteModule extends AnnotatedForegroundModule implements FlowAdminExtensionViewProvider, ViewFragmentModule<ForegroundModuleDescriptor>, Runnable {
	
	protected static final String ACTIVE_FLOW_INSTANCE_IDS_SQL = "SELECT ffi.flowInstanceID FROM flowengine_flow_instances ffi INNER JOIN flowengine_flows ff ON ffi.flowID = ff.flowID INNER JOIN flowengine_flow_statuses ffs ON ffi.statusID = ffs.statusID WHERE ff.flowFamilyID = ? AND ffi.firstSubmitted IS NOT NULL AND ffs.contentType != 'ARCHIVED' AND ffs.name IN (";
	protected static final String ARCHIVED_FLOW_INSTANCE_IDS_SQL = "SELECT ffi.flowInstanceID FROM flowengine_flow_instances ffi INNER JOIN flowengine_flows ff ON ffi.flowID = ff.flowID INNER JOIN flowengine_flow_statuses ffs ON ffi.statusID = ffs.statusID WHERE ff.flowFamilyID = ? AND ffi.firstSubmitted IS NOT NULL AND ffs.name IN (";
	
	protected static final List<String> LIST_FLOW_INSTANCES_ATTRIBUTES = Arrays.asList("title");
	protected static final List<Field> LIST_FLOW_INSTANCES_IGNORED_FIELDS = Arrays.asList(FlowType.ALLOWED_ADMIN_GROUPS_RELATION, FlowType.ALLOWED_QUERIES_RELATION, FlowType.ALLOWED_ADMIN_USERS_RELATION, FlowType.CATEGORIES_RELATION, Flow.STATUSES_RELATION, Flow.DEFAULT_FLOW_STATE_MAPPINGS_RELATION, Flow.STEPS_RELATION, Flow.TAGS_RELATION, FlowFamily.MANAGER_USERS_RELATION, FlowFamily.MANAGER_GROUPS_RELATION);
	
	protected static final String FLOW_INSTANCE_ATTRIBUTE_TITLE = "description";
	protected static final String FLOW_INSTANCE_ATTRIBUTE_DESCRIPTION = "longdescription";
	protected static final String FLOW_INSTANCE_ATTRIBUTE_REJECTED = "rejectionDescription";
	
	private static final String ACTION_VOTE = "vote";
	private static final String ACTION_REMOVE_VOTE = "removeVote";
	protected static final String ACTION_PAUSE_VOTE_PRENUMERATION = "pauseVotingPrenumeration";
	protected static final String ACTION_ACTIVATE_VOTE_PRENUMERATION = "activateVotingPrenumeration";
	protected static final String CANCELLED_PRENUMERATION = "cancelledPrenumeration";
	
	private static final AnnotatedRequestPopulator<FlowFamilyVoteSettings> POPULATOR = new AnnotatedRequestPopulator<FlowFamilyVoteSettings>(FlowFamilyVoteSettings.class);
	
	@XSLVariable(prefix = "java.")
	private String adminExtensionViewTitle = "Add flow instances as manager settings";
	
	@XSLVariable(prefix = "java.")
	private String votingEndedEventDetails = "not set";
	
	@ModuleSetting
	@TextFieldSettingDescriptor(name = "Vote complete check interval", description = "How often this module should check for completed votings (specified in crontab format)", required = true, formatValidator = CronStringValidator.class)
	private String voteCompleteCheckInterval = "0 0 * * *";
	
	@ModuleSetting
	@CheckboxSettingDescriptor(name = "Enable fragment XML debug", description = "Enables debugging of fragment XML")
	private boolean debugFragmentXML;
	
	@ModuleSetting
	@CheckboxSettingDescriptor(name = "Send confirmation notifications when voting", description = "")
	private boolean sendVotedConfirmationNotifications = true;
	
	@ModuleSetting
	@CheckboxSettingDescriptor(name = "Send received vote notifications", description = "")
	private boolean sendReceivedVoteNotifications = true;
	
	@ModuleSetting
	@TextFieldSettingDescriptor(name = "Voting confirmation email subject", description = "", required = true)
	@XSLVariable(prefix = "java.")
	private String votedEmailSubject;
	
	@ModuleSetting
	@HTMLEditorSettingDescriptor(name = "Voting confirmation email message", description = "", required = true)
	@XSLVariable(prefix = "java.")
	private String votedEmailMessage;
	
	@ModuleSetting
	@TextAreaSettingDescriptor(name = "SMS confirmation to users when voting", description = "", required = true)
	@XSLVariable(prefix = "java.")
	private String votedSMS;
	
	@ModuleSetting
	@TextFieldSettingDescriptor(name = "Others voted on my proposal email subject", description = "", required = true)
	@XSLVariable(prefix = "java.")
	private String voteReceivedEmailSubject;

	@ModuleSetting
	@HTMLEditorSettingDescriptor(name = "Others voted on my proposal email message", description = "", required = true)
	@XSLVariable(prefix = "java.")
	private String voteReceivedEmailMessage;
	
	@ModuleSetting
	@TextAreaSettingDescriptor(name = "SMS to users when others vote on their proposals", description = "", required = true)
	@XSLVariable(prefix = "java.")
	private String voteReceivedSMS;
	
	@ModuleSetting
	@TextFieldSettingDescriptor(name = "Voting complete email subject", description = "", required = true)
	@XSLVariable(prefix = "java.")
	private String votingCompletedEmailSubject;

	@ModuleSetting
	@HTMLEditorSettingDescriptor(name = "Voting complete email message", description = "", required = true)
	@XSLVariable(prefix = "java.")
	private String votingCompletedEmailMessage;
	
	@ModuleSetting
	@TextAreaSettingDescriptor(name = "SMS to users when voting is completed", description = "", required = true)
	@XSLVariable(prefix = "java.")
	private String votingCompletedSMS;

	//RSS-feed settings
	@TextFieldSettingDescriptor(name = "RSS Language", description = "Specifies the language the feed is written in", required = true)
	@ModuleSetting
	private String feedLanguage = "sv-se";

	@TextFieldSettingDescriptor(name = "RSS TTL", description = "Specifies the number of minutes the feed can stay cached before refreshing it from the source", required = true, formatValidator = PositiveStringIntegerValidator.class)
	@ModuleSetting
	private Integer feedTTL = 60;

	@TextFieldSettingDescriptor(name = "RSS item description max length", description = "Specifies the max allowed length for rss item description, where 0 is unlimited", required = true, formatValidator = StringIntegerValidator.class)
	@ModuleSetting
	private Integer feedItemDescriptionMaxLength = 247;
	
	@InstanceManagerDependency
	protected SiteProfileHandler siteProfileHandler;
	
	@InstanceManagerDependency
	protected StandardFlowNotificationHandler standardFlowNotificationHandler;
	
	@InstanceManagerDependency
	protected PDFProvider pdfProvider;
	
	protected FlowAdminModule flowAdminModule;
	
	private ModuleViewFragmentTransformer<ForegroundModuleDescriptor> viewFragmentTransformer;
	
	private Scheduler scheduler;
	private String scheduleID;

	private FlowEngineDAOFactory flowDAOFactory;
	
	private AnnotatedDAO<FlowFamilyVote> votesDAO;
	private AnnotatedDAO<FlowFamilyVoteSettings> settingsDAO;
	private QueryParameterFactory<FlowFamilyVote, Integer> votesFlowInstanceIDParamFactory;
	
	private QueryParameterFactory<FlowFamilyVote, User> votesUserParamFactory;
	private QueryParameterFactory<FlowFamilyVoteSettings, Integer> settingFlowFamilyIDParamFactory;
	private QueryParameterFactory<FlowFamilyVoteSettings, String> settingAliasParamFactory;
	
	private QueryParameterFactory<FlowInstance, Integer> flowInstanceIDParamFactory;
	private OrderByCriteria<FlowInstance> flowInstanceOrderByLastStatusChangeCriteria;
	
	private List<ScriptTag> updateScriptTags;
	private List<LinkTag> updateLinks;
	
	@Override
	public void init(ForegroundModuleDescriptor moduleDescriptor, SectionInterface sectionInterface, DataSource dataSource) throws Exception {
		
		viewFragmentTransformer = new ModuleViewFragmentTransformer<ForegroundModuleDescriptor>(sectionInterface.getForegroundModuleXSLTCache(), this, sectionInterface.getSystemInterface().getEncoding());
		
		super.init(moduleDescriptor, sectionInterface, dataSource);
		initScheduler();
	}
	
	@Override
	protected void createDAOs(DataSource dataSource) throws Exception {
		
		//Automatic table version handling
		UpgradeResult upgradeResult = TableVersionHandler.upgradeDBTables(dataSource, FlowVoteModule.class.getName(), new XMLDBScriptProvider(this.getClass().getResourceAsStream("DB script.xml")));
		
		if (upgradeResult.isUpgrade()) {
			
			log.info(upgradeResult.toString());
		}
		
		HierarchyAnnotatedDAOFactory daoFactory = new HierarchyAnnotatedDAOFactory(dataSource, systemInterface.getUserHandler(), systemInterface.getGroupHandler(), false, true, false);
		
		settingsDAO = daoFactory.getDAO(FlowFamilyVoteSettings.class);
		settingFlowFamilyIDParamFactory = settingsDAO.getParamFactory("flowFamilyID", Integer.class);
		settingAliasParamFactory = settingsDAO.getParamFactory("alias", String.class);
		
		votesDAO = daoFactory.getDAO(FlowFamilyVote.class);
		votesFlowInstanceIDParamFactory = votesDAO.getParamFactory("flowInstanceID", Integer.class);
		votesUserParamFactory = votesDAO.getParamFactory("user", User.class);
		
		flowDAOFactory = new FlowEngineDAOFactory(dataSource, systemInterface.getUserHandler(), systemInterface.getGroupHandler());
		new FlowInstanceEventGenerator(flowDAOFactory);
		flowInstanceIDParamFactory = flowDAOFactory.getFlowInstanceDAO().getParamFactory("flowInstanceID", Integer.class);
		flowDAOFactory.getFlowInstanceAttributeDAO().getParamFactory("name", String.class);
		flowDAOFactory.getFlowFamilyDAO().getParamFactory("flowFamilyID", Integer.class);
		
		flowInstanceOrderByLastStatusChangeCriteria = flowDAOFactory.getFlowInstanceDAO().getOrderByCriteria("lastStatusChange", Order.DESC);
	}
	
	@Override
	protected void moduleConfigured() throws Exception {
		
		viewFragmentTransformer.setDebugXML(debugFragmentXML);
		
		XSLVariableReader variableReader = ModuleUtils.getXSLVariableReader(moduleDescriptor, sectionInterface.getSystemInterface());
		
		if (variableReader != null) {
			
			Map<String, String> map = new HashMap<String, String>();
			map.put("scripts", "updatescripts");
			map.put("links", "updatelinks");
			XSLVariableReaderRenamer variableReaderRenamer = new XSLVariableReaderRenamer(variableReader, map);
			updateScriptTags = CollectionUtils.combine(ModuleUtils.getGlobalScripts(variableReaderRenamer), ModuleUtils.getScripts(variableReaderRenamer, sectionInterface, getStaticContentPrefix(), moduleDescriptor));
			updateLinks = ModuleUtils.getLinks(variableReaderRenamer, sectionInterface, getStaticContentPrefix(), moduleDescriptor);
		}
	}
	
	@Override
	public void update(ForegroundModuleDescriptor descriptor, DataSource dataSource) throws Exception {
		
		super.update(descriptor, dataSource);
		
		scheduler.reschedule(scheduleID, voteCompleteCheckInterval);
	}
	
	@Override
	public void unload() throws Exception {
		
		stopScheduler();
		
		super.unload();
	}
	
	protected synchronized void initScheduler() {
		
		scheduler = new Scheduler(systemInterface.getApplicationName() + " - " + moduleDescriptor.toString());
		scheduler.setDaemon(true);
		
		scheduleID = scheduler.schedule(voteCompleteCheckInterval, this);
		scheduler.start();
	}
	
	protected synchronized void stopScheduler() {
		
		try {
			if (scheduler != null) {
				
				scheduler.stop();
				scheduler = null;
			}
			
		} catch (IllegalStateException e) {
			log.error("Error stopping scheduler", e);
		}
	}
	
	public FlowFamilyVoteSettings getSetting(ImmutableFlowFamily flowFamily) throws SQLException {
		
		HighLevelQuery<FlowFamilyVoteSettings> query = new HighLevelQuery<FlowFamilyVoteSettings>();
		
		query.addParameter(settingFlowFamilyIDParamFactory.getParameter(flowFamily.getFlowFamilyID()));
		
		return settingsDAO.get(query);
	}
	
	public FlowFamilyVoteSettings getSetting(String alias) throws SQLException {
		
		HighLevelQuery<FlowFamilyVoteSettings> query = new HighLevelQuery<FlowFamilyVoteSettings>();
		
		query.addParameter(settingAliasParamFactory.getParameter(alias));
		
		return settingsDAO.get(query);
	}

	public List<FlowFamilyVoteSettings> getAllSettings() throws SQLException {
		
		HighLevelQuery<FlowFamilyVoteSettings> query = new HighLevelQuery<FlowFamilyVoteSettings>();
		
		return settingsDAO.getAll(query);
	}
	
	public FlowFamilyVote getVote(ImmutableFlowInstance flowInstance, User user) throws SQLException {
		
		if (user == null) {
			return null;
		}
		
		HighLevelQuery<FlowFamilyVote> query = new HighLevelQuery<FlowFamilyVote>();
		
		query.addParameter(votesFlowInstanceIDParamFactory.getParameter(flowInstance.getFlowInstanceID()));
		query.addParameter(votesUserParamFactory.getParameter(user));
		
		return votesDAO.get(query);
	}
	
	public List<FlowFamilyVote> getVotes(ImmutableFlowInstance flowInstance) throws SQLException {
		
		HighLevelQuery<FlowFamilyVote> query = new HighLevelQuery<FlowFamilyVote>();
		
		query.addParameter(votesFlowInstanceIDParamFactory.getParameter(flowInstance.getFlowInstanceID()));
		
		return votesDAO.getAll(query);
	}
	
	@Override
	protected ForegroundModuleResponse processForegroundRequest(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Throwable {

		String method = getMethod(req, uriParser);

		if (method != null) {

			MethodMapping methodMapping = this.methodMap.get(method);

			if (methodMapping == null) {

				ForegroundModuleResponse moduleResponse = listVotingsWeb(req, res, user, uriParser);

				if (moduleResponse != null) {

					if (this.scripts != null) {

						moduleResponse.addScripts(scripts);
					}

					if (this.links != null) {

						moduleResponse.addLinks(links);
					}
				}

				return moduleResponse;

			} else {

				if (user == null && methodMapping.getAnnotation().requireLogin()) {

					throw new AccessDeniedException("Login required");
				}

				try {
					ForegroundModuleResponse moduleResponse = this.invoke(methodMapping.getMethod(), req, res, user, uriParser);

					if (moduleResponse != null) {

						if (this.scripts != null && methodMapping.getAnnotation().autoAppendScripts()) {

							moduleResponse.addScripts(scripts);
						}

						if (this.links != null && methodMapping.getAnnotation().autoAppendLinks()) {

							moduleResponse.addLinks(links);
						}
					}

					return moduleResponse;

				} catch (InvocationTargetException e) {

					if (e.getCause() != null && e.getCause() instanceof Exception) {
						throw (Exception) e.getCause();
					} else {
						throw e;
					}
				}
			}

		} else {

			throw new URINotFoundException(uriParser.getFormattedURI() + ", No alias provided, ");
		}
	}
	
	private ForegroundModuleResponse listVotingsWeb(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws ModuleConfigurationException, SQLException, AccessDeniedException, URINotFoundException {
		
		String alias = null;
		FlowFamilyVoteSettings setting = null;
		
		if (uriParser.size() == 2 && (alias = uriParser.get(1)) != null && (setting = getSetting(alias)) != null) {
			
			return listVotingsInternal(setting, null, req, res, user, uriParser);
		}
		
		throw new URINotFoundException(uriParser.getFormattedURI() + ", No settings found for alias " + alias + ", ");
	}
	
	private ForegroundModuleResponse listVotingsInternal(FlowFamilyVoteSettings setting, ValidationError validationError, HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws ModuleConfigurationException, SQLException, AccessDeniedException, URINotFoundException {
		
		log.info("User " + user + " listing votings");
		
		if (setting.getSiteProfileID() != null) {
			
			FlowFamily flowFamily = flowAdminModule.getFlowFamily(setting.getFlowFamilyID());
			SiteProfile profile = flowAdminModule.getCurrentSiteProfile(req, user, uriParser, flowFamily);
			
			if (profile == null || !profile.getProfileID().equals(setting.getSiteProfileID())) {
				
				throw new URINotFoundException(uriParser.getFormattedURI() + ", User is using wrong siteprofile, ");
			}
		}
		
		Document doc = this.createDocument(req, uriParser, user);
		
		Element listVotingsElement = null;
		
		if(setting.isVotingActivated()) {
			
			listVotingsElement = doc.createElement("ListVotings");
			
		} else {
			
			listVotingsElement = doc.createElement("ListPropositions");
		}
		
		doc.getDocumentElement().appendChild(listVotingsElement);
		
		listVotingsElement.appendChild(setting.toXML(doc));
		
		if (validationError != null) {
			
			XMLUtils.append(doc, listVotingsElement, validationError);
		}
		
		return new SimpleForegroundModuleResponse(doc, this.getDefaultBreadcrumb());
	}
	
	@WebPublic(alias = "archived")
	public ForegroundModuleResponse listArchivedVotingsWeb(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws ModuleConfigurationException, SQLException, AccessDeniedException, URINotFoundException {
		
		String alias = null;
		FlowFamilyVoteSettings setting = null;
		
		if (uriParser.size() == 3 && (alias = uriParser.get(2)) != null && (setting = getSetting(alias)) != null) {
			
			return listArchivedVotingsInternal(setting, null, req, res, user, uriParser);
		}
		
		throw new URINotFoundException(uriParser.getFormattedURI() + ", No settings found for alias " + alias + ", ");
	}
	
	private ForegroundModuleResponse listArchivedVotingsInternal(FlowFamilyVoteSettings setting, ValidationError validationError, HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws ModuleConfigurationException, SQLException, AccessDeniedException, URINotFoundException {
		
		log.info("User " + user + " listing archived votings");
		
		if (setting.getSiteProfileID() != null) {
			
			FlowFamily flowFamily = flowAdminModule.getFlowFamily(setting.getFlowFamilyID());
			SiteProfile profile = flowAdminModule.getCurrentSiteProfile(req, user, uriParser, flowFamily);
			
			if (profile == null || !profile.getProfileID().equals(setting.getSiteProfileID())) {
				
				throw new URINotFoundException(uriParser.getFormattedURI() + ", User is using wrong siteprofile, ");
			}
		}
		
		Document doc = this.createDocument(req, uriParser, user);
		
		Element listArchivedVotingsElement = null;
		
		if(setting.isVotingActivated()) {
			
			listArchivedVotingsElement = doc.createElement("ListArchivedVotings");
			
		} else {
			
			listArchivedVotingsElement = doc.createElement("ListArchivedPropositions");
		}
		
		doc.getDocumentElement().appendChild(listArchivedVotingsElement);
		
		listArchivedVotingsElement.appendChild(setting.toXML(doc));
		
		if (validationError != null) {
			
			XMLUtils.append(doc, listArchivedVotingsElement, validationError);
		}
		
		return new SimpleForegroundModuleResponse(doc, this.getDefaultBreadcrumb());
	}
	
	private Date getVoteEnding(FlowInstance flowInstance, FlowFamilyVoteSettings setting) {
		
		if (!setting.isVotingActivated() || CollectionUtils.isEmpty(flowInstance.getEvents())) {
			
			return null;
		}
		
		for (int i = flowInstance.getEvents().size() - 1; i > -1; i--) {
			
			ImmutableFlowInstanceEvent event = flowInstance.getEvents().get(i);
			
			if (setting.getPublishedStatuses().stream().anyMatch(event.getStatus()::equalsIgnoreCase) && event.getEventType() == EventType.STATUS_UPDATED) {
				
				Calendar calendar = Calendar.getInstance();
				calendar.setTime(event.getAdded());
				calendar.add(Calendar.DAY_OF_MONTH, setting.getVotingDays());
				
				return new Timestamp(calendar.getTimeInMillis());
			}
		}
		
		return null;
	}
	
	private Integer getVoteCount(FlowInstance flowInstance) throws SQLException {
		
		ObjectQuery<Integer> query = new ObjectQuery<Integer>(dataSource, "SELECT COUNT(flowInstanceID) FROM flow_family_votes WHERE flowInstanceID = ?", IntegerPopulator.getPopulator());
		query.setInt(1, flowInstance.getFlowInstanceID());
		
		return query.executeQuery();
	}
	
	private List<Integer> getActiveFlowInstanceIDs(FlowFamilyVoteSettings setting) throws SQLException {
		
		StringBuilder sql = new StringBuilder(ACTIVE_FLOW_INSTANCE_IDS_SQL);
		StringUtils.repeatString("?,", setting.getPublishedStatuses().size() - 1, sql);
		sql.append("?)");
		
		ArrayListQuery<Integer> query = new ArrayListQuery<Integer>(dataSource, sql.toString(), IntegerPopulator.getPopulator());
		
		query.setInt(1, setting.getFlowFamilyID());
		
		int i = 2;
		for (String statusName : setting.getPublishedStatuses()) {
			query.setString(i++, statusName);
		}
		
		return query.executeQuery();
	}
	
	private List<Integer> getArchivedFlowInstanceIDs(FlowFamilyVoteSettings setting) throws SQLException {
		
		StringBuilder sql = new StringBuilder(ARCHIVED_FLOW_INSTANCE_IDS_SQL);
		StringUtils.repeatString("?,", setting.getArchivedStatuses().size() - 1, sql);
		sql.append("?)");
		
		ArrayListQuery<Integer> query = new ArrayListQuery<Integer>(dataSource, sql.toString(), IntegerPopulator.getPopulator());
		
		query.setInt(1, setting.getFlowFamilyID());
		
		int i = 2;
		for (String statusName : setting.getArchivedStatuses()) {
			query.setString(i++, statusName);
		}
		
		return query.executeQuery();
	}
	
	private List<FlowInstance> getFlowInstances(List<Integer> flowInstanceIDs, FlowFamilyVoteSettings setting) throws SQLException {
		
		return getFlowInstancesWithRelations(flowInstanceIDs, FlowInstance.STATUS_RELATION, FlowInstance.ATTRIBUTES_RELATION, FlowInstance.EVENTS_RELATION);
	}
	
	private List<FlowInstance> getFlowInstancesWithRelations(List<Integer> flowInstanceIDs, Field... relations) throws SQLException {
		
		if (CollectionUtils.isEmpty(flowInstanceIDs)) {
			return null;
		}
		
		HighLevelQuery<FlowInstance> query = new HighLevelQuery<FlowInstance>();
		
		query.addParameter(flowInstanceIDParamFactory.getWhereInParameter(flowInstanceIDs));
		
		query.addOrderByCriteria(flowInstanceOrderByLastStatusChangeCriteria);
		
		if (relations != null) {
			
			query.addRelations(relations);
			
//			query.addRelationParameter(FlowInstanceAttribute.class, flowInstanceAttributeNameParamFactory.getWhereInParameter(LIST_FLOW_INSTANCES_ATTRIBUTES));
		}
		
		return flowDAOFactory.getFlowInstanceDAO().getAll(query);
	}
	
	@WebPublic
	public ForegroundModuleResponse show(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Throwable {

		return show(req, res, user, uriParser, false);
	}
	
	private ForegroundModuleResponse show(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser, boolean openVoteModal) throws Throwable  {
		
		Integer flowInstanceID;
		FlowInstance flowInstance;
		FlowFamilyVoteSettings setting;
		boolean cancelledPrenumeration = false;
		
		if (uriParser.size() == 3 && (flowInstanceID = uriParser.getInt(2)) != null && (flowInstance = flowAdminModule.getFlowInstance(flowInstanceID)) != null && (setting = getSetting(flowInstance.getFlow().getFlowFamily())) != null) {
			
			if (setting.getSiteProfileID() != null) {
				
				FlowFamily flowFamily = flowAdminModule.getFlowFamily(setting.getFlowFamilyID());
				SiteProfile profile = flowAdminModule.getCurrentSiteProfile(req, user, uriParser, flowFamily);
				
				if (profile == null || !profile.getProfileID().equals(setting.getSiteProfileID())) {
					
					throw new URINotFoundException(uriParser.getFormattedURI() + ", User is using wrong siteprofile, ");
				}
			}
			
			Date voteEnding = null;
			Date propositionDate = null;
			FlowFamilyVote vote = null;
			boolean active = false;
			boolean owner = false;

			cancelledPrenumeration = flowInstance.getAttributeHandler().getPrimitiveBoolean(CANCELLED_PRENUMERATION);
			
			owner = user != null && flowInstance.getOwners() != null && flowInstance.getOwners().contains(user) ? true : false ;
			
			if(setting.isVotingActivated()) {
				
				voteEnding = getVoteEnding(flowInstance, setting);
				vote = getVote(flowInstance, user);
				active = setting.getPublishedStatuses().stream().anyMatch(flowInstance.getStatus().getName()::equalsIgnoreCase) && voteEnding != null && new Date().before(voteEnding);
				
			} else {
			
				propositionDate = flowInstance.getFirstSubmitted();
				
				active = setting.getPublishedStatuses().stream().anyMatch(flowInstance.getStatus().getName()::equalsIgnoreCase);
			}
			
			boolean correctMunicipality = true;
			
			if (setting.getMunicipalCode() != null) {
				
				if (user != null) {
				
					String municipalCode = user.getAttributeHandler().getString("official.kommunKod");
					
					if (!setting.getMunicipalCode().equalsIgnoreCase(municipalCode)) {
						
						correctMunicipality = false;
					}
					
				} else {
					correctMunicipality = false;
				}
			}
			
			List<ValidationError> validationErrors = null;
			
			if (req.getMethod().equalsIgnoreCase("POST")) {
				
				String action = req.getParameter("action");
				
				if(!setting.isVotingActivated()) {
					
					throw new URINotFoundException(uriParser);
				}
				
				if (user == null) {
					
					systemInterface.getLoginHandler().processLoginRequest(req, res, uriParser, true);
					return null;
				}
				
				validationErrors = new ArrayList<ValidationError>();

				if (!active && (ACTION_VOTE.equals(action) || ACTION_REMOVE_VOTE.equals(action))) {
					
					validationErrors.add(new ValidationError("VotingDisabled"));
				}
				
				if (!correctMunicipality) {
					
					validationErrors.add(new ValidationError("WrongMunicipalCode"));
				}
				
				if (CollectionUtils.isEmpty(validationErrors)) {
					
					if (ACTION_REMOVE_VOTE.equals(action)) {
						
						if (vote != null) {
							
							votesDAO.delete(vote);
							vote = null;
						}
						
					} else if (setting.isVotingActivated() && ACTION_VOTE.equals(action) && vote == null) {
						
						vote = new FlowFamilyVote();
						vote.setUser(user);
						vote.setTimestamp(new Timestamp(System.currentTimeMillis()));
						vote.setFlowInstanceID(flowInstance.getFlowInstanceID());
						
						votesDAO.add(vote);
						
						if (standardFlowNotificationHandler != null) {
							
							if (sendVotedConfirmationNotifications) {
								
								Contact contact = FlowInstanceUtils.getContactForUser(user);
								
								sendContactEmail(flowInstance, contact, votedEmailSubject, votedEmailMessage, setting);
								sendContactSMS(flowInstance, contact, votedSMS, setting);
							}
							
							if (sendReceivedVoteNotifications && !cancelledPrenumeration) {
								
								Collection<Contact> contacts = standardFlowNotificationHandler.getContactsFromDB(flowInstance);
								
								if (contacts != null) {
									
									for (Contact contact : contacts) {
										
										sendContactEmail(flowInstance, contact, voteReceivedEmailSubject, voteReceivedEmailMessage, setting);
										sendContactSMS(flowInstance, contact, voteReceivedSMS, setting);
									}
								}
							}
						}
					} else if (setting.isVotingActivated() && (ACTION_PAUSE_VOTE_PRENUMERATION.equals(action) || ACTION_ACTIVATE_VOTE_PRENUMERATION.equals(action))) {
						
						if(owner) {
							
							cancelledPrenumeration = setPrenumeration(flowInstance, action);
							
						} else {
							
							log.warn("Blocking action " + action + "for flowInstanceID " + flowInstance.getFlowInstanceID() + " from user " + user + " using address " + req.getRemoteAddr());
						}
					}
				}
			}
			
			log.info("User " + user + " requesting vote form for " + flowInstance);
			
			Document doc = createDocument(req, uriParser, user);
			
			Element voteFormElement = doc.createElement("VoteForm");
			doc.getDocumentElement().appendChild(voteFormElement);
			
			voteFormElement.appendChild(flowInstance.toXML(doc));
			XMLUtils.append(doc, voteFormElement, setting);
			XMLUtils.append(doc, voteFormElement, vote);
			
			if (user != null) {
				XMLUtils.appendNewElement(doc, voteFormElement, "LoggedIn");
				
				if (openVoteModal) {
					XMLUtils.appendNewElement(doc, voteFormElement, "OpenVoteModal");
				}
				
				if(owner) {

					if(cancelledPrenumeration) {
						
						XMLUtils.appendNewElement(doc, voteFormElement, "NoActiveVoteReceivedPrenumeration");
							
					} else {
							
						XMLUtils.appendNewElement(doc, voteFormElement, "ActiveVoteReceivedPrenumeration");
					}
				}
			}
			
			if (!correctMunicipality) {
				XMLUtils.appendNewElement(doc, voteFormElement, "WrongMunicipality");
			}
			
			XMLUtils.appendNewElement(doc, voteFormElement, "Votes", getVoteCount(flowInstance));
			
			if (voteEnding != null) {
				XMLUtils.appendNewElement(doc, voteFormElement, "VoteEnding", DateUtils.DATE_FORMATTER.format(voteEnding));
			}
			
			if(propositionDate != null) {
				
				XMLUtils.appendNewElement(doc, voteFormElement, "PropositionDate", DateUtils.DATE_FORMATTER.format(propositionDate));
			}
			
			if (active) {
				
				XMLUtils.appendNewElement(doc, voteFormElement, "Active");
				
				if(owner) {
					
					XMLUtils.appendNewElement(doc, voteFormElement, "Owner");
				}
			}

			if(setting.isAdditionalAttributes()) {
				
				if(!StringUtils.isEmpty(setting.getExtraInfoAttribute1())) {
					
					String attributedString1 = AttributeTagUtils.replaceTags(setting.getExtraInfoAttribute1(), flowInstance.getAttributeHandler());
					
					XMLUtils.appendNewElement(doc, voteFormElement, "extraInfoAttribute1", attributedString1);
				}

				if(!StringUtils.isEmpty(setting.getExtraInfoAttribute2())) {
					
					String attributedString2 = AttributeTagUtils.replaceTags(setting.getExtraInfoAttribute2(), flowInstance.getAttributeHandler());
					
					XMLUtils.appendNewElement(doc, voteFormElement, "extraInfoAttribute2", attributedString2);
				}

				if(!StringUtils.isEmpty(setting.getExtraInfoAttribute3())) {
					
					String attributedString3 = AttributeTagUtils.replaceTags(setting.getExtraInfoAttribute3(), flowInstance.getAttributeHandler());
					
					XMLUtils.appendNewElement(doc, voteFormElement, "extraInfoAttribute3", attributedString3);
				}
			}
			
			if(!setting.isHideAttachedFiles()) {
			
				try {
					File pdf = pdfProvider.getPDF(flowInstance.getFlowInstanceID(), FlowInstanceUtils.getLatestPDFEvent(flowInstance).getEventID());
					List<PDFByteAttachment> pdfAttachments = pdfProvider.getPDFAttachments(pdf, false);
					
					if (!CollectionUtils.isEmpty(pdfAttachments)) {
						
						Element filesElement = XMLUtils.appendNewElement(doc, voteFormElement, "Files");
						
						int index = 0;
						for (PDFByteAttachment attachment : pdfAttachments) {
							
							Element fileElement = XMLUtils.appendNewElement(doc, filesElement, "File");
							XMLUtils.appendNewElement(doc, fileElement, "AttachmentName", attachment.getAttachmentName());
							XMLUtils.appendNewElement(doc, fileElement, "FileName", attachment.getFilename());
							XMLUtils.appendNewElement(doc, fileElement, "Index", index++);
						}
					}
	
	            } catch (Exception e) {
	
	                log.error("Error getting PDF attachments for flow instance " + flowInstance, e);
	            }
			}
			
			if (validationErrors != null) {
				
				XMLUtils.append(doc, voteFormElement, "ValidationErrors", validationErrors);
				voteFormElement.appendChild(RequestUtils.getRequestParameters(req, doc));
			}
			
			SimpleForegroundModuleResponse foregroundModuleRespone = new SimpleForegroundModuleResponse(doc,flowInstance.getUserDescription(), getDefaultBreadcrumb());

			String longDescription = flowInstance.getAttributeHandler().getString(FLOW_INSTANCE_ATTRIBUTE_DESCRIPTION);
			
			if(longDescription != null) {
				
				longDescription = StringUtils.toLogFormat(longDescription, 1000);
				
				foregroundModuleRespone.setDescription(longDescription);
			}
			
			
			return foregroundModuleRespone;
		}
		
		throw new URINotFoundException(uriParser);
	}

	
	private boolean setPrenumeration(FlowInstance flowInstance, String action) throws SQLException {
		
		FlowInstanceAttribute attribute = null;
		
		boolean cancelledPrenumeration = false;
		
		if(ACTION_PAUSE_VOTE_PRENUMERATION.equals(action)) {
			
			attribute = new FlowInstanceAttribute(CANCELLED_PRENUMERATION, "true");
			cancelledPrenumeration = true;
			
		} else {
			
			attribute = new FlowInstanceAttribute(CANCELLED_PRENUMERATION, "false");
			cancelledPrenumeration = false;
		}
		
		attribute.setFlowInstance((FlowInstance) flowInstance);

		flowAdminModule.getDAOFactory().getFlowInstanceAttributeDAO().addOrUpdate(attribute, null);

		flowInstance.getAttributeHandler().setAttribute(CANCELLED_PRENUMERATION, true);
		
		return cancelledPrenumeration;
	}

	@WebPublic
	public ForegroundModuleResponse file(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Throwable {
		
		Integer flowInstanceID;
		FlowInstance flowInstance;
		FlowFamilyVoteSettings voteSettings;
		Integer attachmentIndex;
		
		if (uriParser.size() == 4 && (flowInstanceID = uriParser.getInt(2)) != null && (attachmentIndex = uriParser.getInt(3)) != null && (flowInstance = flowAdminModule.getFlowInstance(flowInstanceID)) != null && (voteSettings = getSetting(flowInstance.getFlow().getFlowFamily())) != null) {
			
			if (voteSettings.getSiteProfileID() != null) {
				
				FlowFamily flowFamily = flowAdminModule.getFlowFamily(voteSettings.getFlowFamilyID());
				SiteProfile profile = flowAdminModule.getCurrentSiteProfile(req, user, uriParser, flowFamily);
				
				if (profile == null || !profile.getProfileID().equals(voteSettings.getSiteProfileID())) {
					
					throw new URINotFoundException(uriParser.getFormattedURI() + ", User is using wrong siteprofile, ");
				}
			}
			
			if(!voteSettings.getPublishedStatuses().stream().anyMatch(flowInstance.getStatus().getName()::equalsIgnoreCase) && !CollectionUtils.contains(voteSettings.getArchivedStatuses(), flowInstance.getStatus().getName())) {
				
				throw new AccessDeniedException("The requested flow instance " + flowInstance + " does not have the a status that allows attachments to be downloaded");
			}
			
			try {
				File pdf = pdfProvider.getPDF(flowInstance.getFlowInstanceID(), FlowInstanceUtils.getLatestPDFEvent(flowInstance).getEventID());
                List<PDFByteAttachment> pdfAttachments = pdfProvider.getPDFAttachments(pdf, true);

				if (attachmentIndex >= 0 && attachmentIndex < pdfAttachments.size()) {
                	
                	PDFByteAttachment attachment = pdfAttachments.get(attachmentIndex);
                	HTTPUtils.sendFile(new ByteArrayInputStream(attachment.getData()), attachment.getFilename(), null, null, req, res, ContentDisposition.INLINE, (long) attachment.getData().length);
                	return null;
                }

            } catch (IOException e) {

                log.info("Error sending PDF attachment with index " + attachmentIndex + " from flow instance " + flowInstance + " to user " + user + ", " + e);
                
            } catch (Exception e) {

                log.error("Error getting PDF attachments for flow instance " + flowInstance, e);
            }
			
		}
		
		throw new URINotFoundException(uriParser);
	}
	
	public Document createDocument(HttpServletRequest req, URIParser uriParser, User user) {
		
		Document doc = XMLUtils.createDomDocument();
		Element documentElement = doc.createElement("Document");
		documentElement.appendChild(RequestUtils.getRequestInfoAsXML(doc, req, uriParser));
		documentElement.appendChild(this.moduleDescriptor.toXML(doc));
		
		XMLUtils.appendNewElement(doc, documentElement, "fullAlias", getFullAlias());
		XMLUtils.appendNewElement(doc, documentElement, "ModuleURI", req.getContextPath() + getFullAlias());
		
		doc.appendChild(documentElement);
		return doc;
	}
	
	@InstanceManagerDependency(required = true)
	public void setFlowAdminModule(FlowAdminModule flowAdminModule) {
		
		if (flowAdminModule == null && this.flowAdminModule != null) {
			
			this.flowAdminModule.removeExtensionViewProvider(this);
		}
		
		this.flowAdminModule = flowAdminModule;
		
		if (this.flowAdminModule != null) {
			
			this.flowAdminModule.addExtensionViewProvider(this);
		}
	}
	
	@Override
	public int getPriority() {
		return 0;
	}
	
	@Override
	public FlowAdminExtensionShowView getShowView(Flow flow, HttpServletRequest req, User user, URIParser uriParser) throws TransformerConfigurationException, TransformerException, SQLException {
		
		Document doc = createDocument(req, uriParser, user);
		
		Element showViewElement = doc.createElement("ShowSettings");
		doc.getDocumentElement().appendChild(showViewElement);
		
		showViewElement.appendChild(flow.toXML(doc));
		
		boolean enabled = false;
		
		FlowFamilyVoteSettings settings = getSetting(flow.getFlowFamily());
		
		if (settings != null) {
			
			XMLUtils.append(doc, showViewElement, settings);
			XMLUtils.appendNewElement(doc, showViewElement, "ServerURL", RequestUtils.getServerURL(req));
			XMLUtils.appendNewElement(doc, showViewElement, "Protocol", req.getScheme());
			
			if (settings.getSiteProfileID() != null) {
				
				SiteProfile siteProfile = siteProfileHandler.getProfile(settings.getSiteProfileID());
				
				if (siteProfile != null) {
					showViewElement.appendChild(siteProfile.toXML(doc));
				}
			}

			enabled = true;
		}
		
		return new FlowAdminExtensionShowView(viewFragmentTransformer.createViewFragment(doc, true), enabled);
	}
	
	@Override
	public String getExtensionViewTitle() {
		
		return adminExtensionViewTitle;
	}
	
	@WebPublic(toLowerCase = true)
	public ForegroundModuleResponse updateFlowSettings(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Exception {
		
		Flow flow = flowAdminModule.getRequestedFlow(req, user, uriParser);
		
		if (flow == null) {
			
			return flowAdminModule.list(req, res, user, uriParser, new ValidationError("FlowNotFound"));
			
		} else if (!flowAdminModule.hasFlowAccess(user, flow)) {
			
			throw new AccessDeniedException("User does not have access to flow type " + flow.getFlowType());
		}
		
		FlowFamilyVoteSettings setting = getSetting(flow.getFlowFamily());
		
		List<ValidationError> validationErrors = null;
		
		if (req.getMethod().equalsIgnoreCase("POST")) {
			
			validationErrors = new ArrayList<ValidationError>();
			
			if (setting == null) {
				
				setting = new FlowFamilyVoteSettings();
			}
			
			try {
				setting = POPULATOR.populate(setting, req);
				
			} catch (ValidationException e) {
				
				validationErrors.addAll(e.getErrors());
			}
			
			//Check if chosen alias is available
			if(!isValidAlias(setting.getAlias(), flow.getFlowFamily().getFlowFamilyID())) {
				
				validationErrors.add(new ValidationError("DuplicateAlias", setting.getAlias()));
			}
			
			List<Flow> flows = flowAdminModule.getFlowVersions(flow.getFlowFamily());
			Set<String> statusNames = new HashSet<String>();
			
			for (Flow flow2 : flows) {
				for (Status status : flow2.getStatuses()) {
					statusNames.add(status.getName().toLowerCase());
				}
			}
			
			if (!CollectionUtils.isEmpty(setting.getPublishedStatuses())) {
					
				for(String publishedStatus : setting.getPublishedStatuses()) {
					
					if(!statusNames.stream().anyMatch(publishedStatus::equalsIgnoreCase)) {
						
						validationErrors.add(new ValidationError("UnknownStatus", publishedStatus, "publishedStatus"));
					}
				}
			}
			
			if (!StringUtils.isEmpty(setting.getVotePassedStatus()) && !statusNames.contains(setting.getVotePassedStatus().toLowerCase())) {
				validationErrors.add(new ValidationError("UnknownStatus", setting.getVotePassedStatus(), "votePassedStatus"));
			}
			
			if (!StringUtils.isEmpty(setting.getVoteFailedStatus()) && !statusNames.contains(setting.getVoteFailedStatus().toLowerCase())) {
				validationErrors.add(new ValidationError("UnknownStatus", setting.getVoteFailedStatus(), "voteFailedStatus"));
			}
			
			if (!CollectionUtils.isEmpty(setting.getArchivedStatuses())) {
				for (String archivedStatus : setting.getArchivedStatuses()) {
					
					if (!statusNames.contains(archivedStatus.toLowerCase())) {
						validationErrors.add(new ValidationError("UnknownStatus", archivedStatus, "archivedStatus"));
					}
				}
			}
			
			if (validationErrors.isEmpty()) {
				
				log.info("User " + user + " updated flow vote settings for flowfamily " + flow.getFlowFamily());
				
				if (setting.getFlowFamilyID() != null) {
					settingsDAO.update(setting);
					
				} else {
					
					setting.setFlowFamilyID(flow.getFlowFamily().getFlowFamilyID());
					settingsDAO.add(setting);
				}
				
				flowAdminModule.redirectToMethod(req, res, "/showflow/" + flow.getFlowID() + "#flowvotesettings");
				return null;
			}
		}
		
		log.info("User " + user + " requesting update flow vote settings for flowfamily " + flow.getFlowFamily());
		
		Document doc = createDocument(req, uriParser, user);
		
		Element settingsElement = doc.createElement("UpdateSettings");
		doc.getDocumentElement().appendChild(settingsElement);
		
		settingsElement.appendChild(flow.toXML(doc));
		
		XMLUtils.append(doc, settingsElement, "SiteProfiles", siteProfileHandler.getProfiles());
		
		XMLUtils.append(doc, settingsElement, setting);

		if (validationErrors != null) {
			
			XMLUtils.append(doc, settingsElement, "ValidationErrors", validationErrors);
			settingsElement.appendChild(RequestUtils.getRequestParameters(req, doc));
		}
		
		SimpleForegroundModuleResponse response = new SimpleForegroundModuleResponse(doc, this.getDefaultBreadcrumb());
		response.addScripts(updateScriptTags);
		response.addLinks(updateLinks);
		
		return response;
	}
	
	public boolean isValidAlias(String alias, Integer flowFamilyID) throws SQLException {
		
		HighLevelQuery<FlowFamilyVoteSettings> query = new HighLevelQuery<FlowFamilyVoteSettings>();
		
		query.addParameter(settingAliasParamFactory.getParameter(alias));
		query.addParameter(settingFlowFamilyIDParamFactory.getParameter(flowFamilyID, QueryOperators.NOT_EQUALS));
		
		return !settingsDAO.getBoolean(query);
	}	
	
	@WebPublic(toLowerCase = true)
	public ForegroundModuleResponse deleteFlowSettings(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Exception {
		
		if(!HTTPUtils.isPost(req)) {
			
			throw new AccessDeniedException("Delete requests using method " + req.getMethod() + " are not allowed.");
		}
		
		Flow flow = flowAdminModule.getRequestedFlow(req, user, uriParser);
		
		if (flow == null) {
			
			return flowAdminModule.list(req, res, user, uriParser, new ValidationError("FlowNotFound"));
			
		} else if (!flowAdminModule.hasFlowAccess(user, flow)) {
			
			throw new AccessDeniedException("User does not have access to flow type " + flow.getFlowType());
		}
		
		
		FlowFamilyVoteSettings settings = getSetting(flow.getFlowFamily());
		
		if (settings != null) {
			
			log.info("User " + user + " deleting person data informer settings for flow " + flow);
			
			settingsDAO.delete(settings);
			
		} else {
			
			log.warn("User " + user + " trying to delete person data informer settings for flow " + flow + " which has no settings");
		}
		
		flowAdminModule.redirectToMethod(req, res, "/showflow/" + flow.getFlowID() + "#flowvotesettings");
		
		return null;
	}
	
	@Override
	public ForegroundModuleDescriptor getModuleDescriptor() {
		
		return moduleDescriptor;
	}
	
	@Override
	public List<LinkTag> getLinkTags() {
		
		return null;
	}
	
	@Override
	public List<ScriptTag> getScriptTags() {
		
		return null;
	}
	
	@WebPublic(alias = "statuses")
	public ForegroundModuleResponse searchStatuses(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Throwable {
		
		String search = req.getParameter("q");
		
		if (user == null || StringUtils.isEmpty(search)) {
			
			sendEmptyJSONResponse(res);
			return null;
		}
		
		if (!systemInterface.getEncoding().equalsIgnoreCase("UTF-8")) {
			search = URLDecoder.decode(search, "UTF-8");
		}
		
		Integer flowFamilyID;
		FlowFamily flowFamily;
		
		if (uriParser.size() == 3 && (flowFamilyID = uriParser.getInt(2)) != null && (flowFamily = flowAdminModule.getFlowFamily(flowFamilyID)) != null) {
			
			if (flowFamily.getManagerAccess(user) == null && !AccessUtils.checkAccess(user, flowAdminModule)) {
				
				sendEmptyJSONResponse(res);
				return null;
			}
			
			List<Flow> flows = flowAdminModule.getFlowVersions(flowFamily);
			
			if (flows == null) {
				
				sendEmptyJSONResponse(res);
				return null;
			}
			
			Set<String> statusNames = new HashSet<String>();
			
			String searchLower = search.toLowerCase();
			
			for (Flow flow : flows) {
				for (Status status : flow.getStatuses()) {
					
					if (status.getName().toLowerCase().contains(searchLower)) {
						statusNames.add(status.getName());
					}
				}
			}
			
			log.info("User " + user + " searching for statuses using query " + search + " in flowfamily " + flowFamily + ", found " + CollectionUtils.getSize(statusNames) + " hits");
			
			if (statusNames.isEmpty()) {
				
				sendEmptyJSONResponse(res);
				return null;
			}
			
			JsonArray jsonArray = new JsonArray();
			
			for (String status : statusNames) {
				
				jsonArray.addNode(status);
			}
			
			sendJSONResponse(jsonArray, res);
			return null;
		}
		
		sendEmptyJSONResponse(res);
		return null;
	}
	
	protected static void sendEmptyJSONResponse(HttpServletResponse res) throws IOException {
		
		JsonObject jsonObject = new JsonObject(1);
		jsonObject.putField("hitCount", "0");
		HTTPUtils.sendReponse(jsonObject.toJson(), JsonUtils.getContentType(), res);
	}
	
	protected void sendJSONResponse(JsonArray jsonArray, HttpServletResponse res) throws IOException {
		
		JsonObject jsonObject = new JsonObject(2);
		jsonObject.putField("hitCount", Integer.toString(jsonArray.size()));
		jsonObject.putField("hits", jsonArray);
		HTTPUtils.sendReponse(jsonObject.toJson(), JsonUtils.getContentType(), res);
	}
	
	@WebPublic(alias = "activedata")
	public ForegroundModuleResponse getActiveVotingsData(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Throwable {
		
		res.setCharacterEncoding(systemInterface.getEncoding());
		res.setContentType(JsonUtils.getContentType());
		
		PrintWriter writer = res.getWriter();
		
		Integer flowFamilyID;
		FlowFamily flowFamily;
		FlowFamilyVoteSettings setting;
		
		if (uriParser.size() == 3 && (flowFamilyID = uriParser.getInt(2)) != null && (flowFamily = flowAdminModule.getFlowFamily(flowFamilyID)) != null && (setting = getSetting(flowFamily)) != null) {
			
			List<Flow> flows = flowAdminModule.getFlowVersions(flowFamily);
			
			if (flows == null) {
				
				writer.append("{\"rows\": []}");
				writer.flush();
				return null;
			}
			
			log.info("Sending active votings for flowFamily + " + flowFamily + " to user " + user);
			long start = System.currentTimeMillis();
			
			try {
				writer.append("{\"rows\":[");
				
				List<FlowInstance> flowInstances = getFlowInstances(getActiveFlowInstanceIDs(setting), setting);
				
				if (!CollectionUtils.isEmpty(flowInstances)) {
					
					JsonArray row = new JsonArray(9);
					
					for (Iterator<FlowInstance> instanceIterator = flowInstances.iterator(); instanceIterator.hasNext();) {
						
						FlowInstance flowInstance = instanceIterator.next();
						
						row.addNode(flowInstance.getFlowInstanceID());
						row.addNode(flowInstance.getUserDescription());
						
						if(setting.isShowStatusInList()) {
							
							row.addNode(flowInstance.getStatus().getName());
						}
						
						if(setting.isAdditionalAttributes()) {
							
							if(!StringUtils.isEmpty(setting.getExtraInfoAttribute1()) && !setting.isHideInList1()) {
								
								String attributedString1 = AttributeTagUtils.replaceTags(setting.getExtraInfoAttribute1(), flowInstance.getAttributeHandler());
								
								row.addNode(attributedString1);
							}
							if(!StringUtils.isEmpty(setting.getExtraInfoAttribute2()) && !setting.isHideInList2()) {
								
								String attributedString2 = AttributeTagUtils.replaceTags(setting.getExtraInfoAttribute2(), flowInstance.getAttributeHandler());
								
								row.addNode(attributedString2);
							}
							if(!StringUtils.isEmpty(setting.getExtraInfoAttribute3()) && !setting.isHideInList3()) {
								
								String attributedString3 = AttributeTagUtils.replaceTags(setting.getExtraInfoAttribute3(), flowInstance.getAttributeHandler());
								
								row.addNode(attributedString3);
							}
						}

						Date voteEnding = getVoteEnding(flowInstance, setting);
						
						if (voteEnding != null) {
							row.addNode(DateUtils.DATE_FORMATTER.format(voteEnding));
							
						} else {
							row.addNode("");
						}
						
						row.addNode(getVoteCount(flowInstance));
						
						if (getVote(flowInstance, user) != null) {
							row.addNode(1);
						} else {
							row.addNode(0);
						}
						
						writer.append(row.toJson());
						
						row.clearNodes();
						
						if (instanceIterator.hasNext()) {
							writer.append(",");
						}
					}
				}
				
				writer.append("]}");
				writer.flush();
				
				start = System.currentTimeMillis() - start;
				log.info("Took " + TimeUtils.millisecondsToString(start));
				return null;
				
			} catch (Exception e) {
				
				writer.append("{\"rows\": [], \"error\": \"Internal error\"}");
				writer.flush();
				throw e;
			}
			
		} else {
			
			writer.append("{\"rows\": [], \"error\": \"No parameter\"}");
			writer.flush();
			return null;
		}
	}
	
	@WebPublic(alias = "archiveddata")
	public ForegroundModuleResponse getArchivedVotingsData(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Throwable {
		
		res.setCharacterEncoding(systemInterface.getEncoding());
		res.setContentType(JsonUtils.getContentType());
		
		PrintWriter writer = res.getWriter();
		
		Integer flowFamilyID;
		FlowFamily flowFamily;
		FlowFamilyVoteSettings setting;
		
		if (uriParser.size() == 3 && (flowFamilyID = uriParser.getInt(2)) != null && (flowFamily = flowAdminModule.getFlowFamily(flowFamilyID)) != null && (setting = getSetting(flowFamily)) != null) {
			
			List<Flow> flows = flowAdminModule.getFlowVersions(flowFamily);
			
			if (flows == null) {
				
				writer.append("{\"rows\": []}");
				writer.flush();
				return null;
			}
			
			log.info("Sending archived votings for flowFamily + " + flowFamily + " to user " + user);
			long start = System.currentTimeMillis();
			
			try {
				writer.append("{\"rows\":[");
				
				List<FlowInstance> flowInstances = getFlowInstances(getArchivedFlowInstanceIDs(setting), setting);
				
				if (!CollectionUtils.isEmpty(flowInstances)) {
					
					JsonArray row = new JsonArray(8);
					
					for (Iterator<FlowInstance> instanceIterator = flowInstances.iterator(); instanceIterator.hasNext();) {
						
						FlowInstance flowInstance = instanceIterator.next();
						
						row.addNode(flowInstance.getFlowInstanceID());
						row.addNode(flowInstance.getUserDescription());

						if(setting.isAdditionalAttributes()) {
							
							if(!StringUtils.isEmpty(setting.getExtraInfoAttribute1()) && !setting.isHideInList1()) {
								
								String attributedString1 = AttributeTagUtils.replaceTags(setting.getExtraInfoAttribute1(), flowInstance.getAttributeHandler());
								
								row.addNode(attributedString1);
							}
							if(!StringUtils.isEmpty(setting.getExtraInfoAttribute2()) && !setting.isHideInList2()) {
								
								String attributedString2 = AttributeTagUtils.replaceTags(setting.getExtraInfoAttribute2(), flowInstance.getAttributeHandler());
								
								row.addNode(attributedString2);
							}
							if(!StringUtils.isEmpty(setting.getExtraInfoAttribute3()) && !setting.isHideInList3()) {
								
								String attributedString3 = AttributeTagUtils.replaceTags(setting.getExtraInfoAttribute3(), flowInstance.getAttributeHandler());
								
								row.addNode(attributedString3);
							}
						}
						
						row.addNode(flowInstance.getStatus().getName());
						
						Date voteEnding = getVoteEnding(flowInstance, setting);
						
						if (voteEnding != null) {
							row.addNode(DateUtils.DATE_FORMATTER.format(voteEnding));
							
						} else {
							row.addNode("");
						}
						
						row.addNode(getVoteCount(flowInstance));
						
						writer.append(row.toJson());
						
						row.clearNodes();
						
						if (instanceIterator.hasNext()) {
							writer.append(",");
						}
					}
				}
				
				writer.append("]}");
				writer.flush();
				
				start = System.currentTimeMillis() - start;
				log.info("Took " + TimeUtils.millisecondsToString(start));
				return null;
				
			} catch (Exception e) {
				
				writer.append("{\"rows\": [], \"error\": \"Internal error\"}");
				writer.flush();
				throw e;
			}
			
		} else {
			
			writer.append("{\"rows\": [], \"error\": \"No parameter\"}");
			writer.flush();
			return null;
		}
	}

	@WebPublic(alias = "activepropositionsdata")
	public ForegroundModuleResponse getActivePropositionsData(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Throwable {
		
		res.setCharacterEncoding(systemInterface.getEncoding());
		res.setContentType(JsonUtils.getContentType());
		
		PrintWriter writer = res.getWriter();
		
		Integer flowFamilyID;
		FlowFamily flowFamily;
		FlowFamilyVoteSettings setting;
		
		if (uriParser.size() == 3 && (flowFamilyID = uriParser.getInt(2)) != null && (flowFamily = flowAdminModule.getFlowFamily(flowFamilyID)) != null && (setting = getSetting(flowFamily)) != null) {
			
			List<Flow> flows = flowAdminModule.getFlowVersions(flowFamily);
			
			if (flows == null) {
				
				writer.append("{\"rows\": []}");
				writer.flush();
				return null;
			}
			
			log.info("Sending active propositions for flowFamily + " + flowFamily + " to user " + user);
			long start = System.currentTimeMillis();
			
			try {
				writer.append("{\"rows\":[");
				
				List<FlowInstance> flowInstances = getFlowInstances(getActiveFlowInstanceIDs(setting), setting);
				
				if (!CollectionUtils.isEmpty(flowInstances)) {
					
					JsonArray row = new JsonArray(8);
					
					for (Iterator<FlowInstance> instanceIterator = flowInstances.iterator(); instanceIterator.hasNext();) {
						
						FlowInstance flowInstance = instanceIterator.next();

						row.addNode(flowInstance.getFlowInstanceID());
						row.addNode(flowInstance.getUserDescription());
						
						if(setting.isAdditionalAttributes()) {
							
							if(!StringUtils.isEmpty(setting.getExtraInfoAttribute1()) && !setting.isHideInList1()) {
								
								String attributedString1 = AttributeTagUtils.replaceTags(setting.getExtraInfoAttribute1(), flowInstance.getAttributeHandler());
								
								row.addNode(attributedString1);
							}
							if(!StringUtils.isEmpty(setting.getExtraInfoAttribute2()) && !setting.isHideInList2()) {
								
								String attributedString2 = AttributeTagUtils.replaceTags(setting.getExtraInfoAttribute2(), flowInstance.getAttributeHandler());
								
								row.addNode(attributedString2);
							}
							if(!StringUtils.isEmpty(setting.getExtraInfoAttribute3()) && !setting.isHideInList3()) {
								
								String attributedString3 = AttributeTagUtils.replaceTags(setting.getExtraInfoAttribute3(), flowInstance.getAttributeHandler());
								
								row.addNode(attributedString3);
							}
						}
						
						row.addNode(DateUtils.DATE_FORMATTER.format(flowInstance.getFirstSubmitted()));
						
						if(setting.isShowStatusInList()) {
							
							row.addNode(flowInstance.getStatus().getName());
						}
						
						String descriptionFragment = StringUtils.toLogFormat(flowInstance.getAttributeHandler().getString(FLOW_INSTANCE_ATTRIBUTE_DESCRIPTION), 50);
						
						if(!StringUtils.isEmpty(descriptionFragment)) {
							
							row.addNode(descriptionFragment);
							
						} else {
							
							row.addNode("");
						}
						
						writer.append(row.toJson());
						
						row.clearNodes();
						
						if (instanceIterator.hasNext()) {
							writer.append(",");
						}
					}
				}
				
				writer.append("]}");
				writer.flush();
				
				start = System.currentTimeMillis() - start;
				log.info("Took " + TimeUtils.millisecondsToString(start));
				return null;
				
			} catch (Exception e) {
				
				writer.append("{\"rows\": [], \"error\": \"Internal error\"}");
				writer.flush();
				throw e;
			}
			
		} else {
			
			writer.append("{\"rows\": [], \"error\": \"No parameter\"}");
			writer.flush();
			return null;
		}
	}
	
	@WebPublic(alias = "archivedpropositionsdata")
	public ForegroundModuleResponse getArchivedPropositionsData(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Throwable {
		
		res.setCharacterEncoding(systemInterface.getEncoding());
		res.setContentType(JsonUtils.getContentType());
		
		PrintWriter writer = res.getWriter();
		
		Integer flowFamilyID;
		FlowFamily flowFamily;
		FlowFamilyVoteSettings setting;
		
		if (uriParser.size() == 3 && (flowFamilyID = uriParser.getInt(2)) != null && (flowFamily = flowAdminModule.getFlowFamily(flowFamilyID)) != null && (setting = getSetting(flowFamily)) != null) {
			
			List<Flow> flows = flowAdminModule.getFlowVersions(flowFamily);
			
			if (flows == null) {
				
				writer.append("{\"rows\": []}");
				writer.flush();
				return null;
			}
			
			log.info("Sending archived propositions for flowFamily + " + flowFamily + " to user " + user);
			long start = System.currentTimeMillis();
			
			try {
				writer.append("{\"rows\":[");
				
				List<FlowInstance> flowInstances = getFlowInstances(getArchivedFlowInstanceIDs(setting), setting);
				
				if (!CollectionUtils.isEmpty(flowInstances)) {
					
					JsonArray row = new JsonArray(8);
					
					for (Iterator<FlowInstance> instanceIterator = flowInstances.iterator(); instanceIterator.hasNext();) {
						
						FlowInstance flowInstance = instanceIterator.next();
						
						row.addNode(flowInstance.getFlowInstanceID());
						row.addNode(flowInstance.getUserDescription());

						if(setting.isAdditionalAttributes()) {
							
							if(!StringUtils.isEmpty(setting.getExtraInfoAttribute1()) && !setting.isHideInList1()) {
								
								String attributedString1 = AttributeTagUtils.replaceTags(setting.getExtraInfoAttribute1(), flowInstance.getAttributeHandler());
								
								row.addNode(attributedString1);
							}
							if(!StringUtils.isEmpty(setting.getExtraInfoAttribute2()) && !setting.isHideInList2()) {
								
								String attributedString2 = AttributeTagUtils.replaceTags(setting.getExtraInfoAttribute2(), flowInstance.getAttributeHandler());
								
								row.addNode(attributedString2);
							}
							if(!StringUtils.isEmpty(setting.getExtraInfoAttribute3()) && !setting.isHideInList3()) {
								
								String attributedString3 = AttributeTagUtils.replaceTags(setting.getExtraInfoAttribute3(), flowInstance.getAttributeHandler());
								
								row.addNode(attributedString3);
							}
						}
						
						row.addNode(DateUtils.DATE_FORMATTER.format(flowInstance.getFirstSubmitted()));
						row.addNode(flowInstance.getStatus().getName());
						
						String descriptionFragment = StringUtils.toLogFormat(flowInstance.getAttributeHandler().getString(FLOW_INSTANCE_ATTRIBUTE_DESCRIPTION), 50);
						
						if(!StringUtils.isEmpty(descriptionFragment)) {
							
							row.addNode(descriptionFragment);
							
						} else {
							
							row.addNode("");
						}
						
						writer.append(row.toJson());
						
						row.clearNodes();
						
						if (instanceIterator.hasNext()) {
							writer.append(",");
						}
					}
				}
				
				writer.append("]}");
				writer.flush();
				
				start = System.currentTimeMillis() - start;
				log.info("Took " + TimeUtils.millisecondsToString(start));
				return null;
				
			} catch (Exception e) {
				
				writer.append("{\"rows\": [], \"error\": \"Internal error\"}");
				writer.flush();
				throw e;
			}
			
		} else {
			
			writer.append("{\"rows\": [], \"error\": \"No parameter\"}");
			writer.flush();
			return null;
		}
	}
	
	@Override
	public void run() {
		
		checkForEndingVotings();
	}
	
	protected Status getStatus(FlowInstance flowInstance, String statusName) {
		
		for (Status status : flowInstance.getFlow().getStatuses()) {
			
			if (status.getName().equalsIgnoreCase(statusName)) {
				return status;
			}
		}
		
		return null;
	}
	
	private void checkForEndingVotings() {
		
		log.info("Looking for ending votings..");
		
		try {
			List<FlowFamilyVoteSettings> settings = settingsDAO.getAll();
			
			if (settings == null) {
				return;
			}
			
			for (FlowFamilyVoteSettings setting : settings) {
				
				List<FlowInstance> flowInstances = getFlowInstancesWithRelations(getActiveFlowInstanceIDs(setting), FlowInstance.STATUS_RELATION, FlowInstance.EVENTS_RELATION, FlowInstance.FLOW_RELATION, Flow.STATUSES_RELATION, Flow.FLOW_FAMILY_RELATION, FlowFamily.MANAGER_USERS_RELATION, FlowFamily.MANAGER_GROUPS_RELATION);

				if (!CollectionUtils.isEmpty(flowInstances)) {
					for (FlowInstance flowInstance : flowInstances) {

						Date voteEnding = getVoteEnding(flowInstance, setting);

						if (voteEnding != null) {

							boolean active = new Date().before(voteEnding);

							if (!active) {

								log.info("Ending voting for flow instance " + flowInstance);
								int votes = getVoteCount(flowInstance);

								Status newStatus;

								if (votes >= setting.getRequiredVotes()) {

									newStatus = getStatus(flowInstance, setting.getVotePassedStatus());

								} else {

									newStatus = getStatus(flowInstance, setting.getVoteFailedStatus());
								}

								if (newStatus == null) {

									log.warn("Found no matching new status for " + flowInstance);

								} else {

									Status previousStatus = flowInstance.getStatus();

									flowInstance.setStatus(newStatus);
									flowInstance.setLastStatusChange(TimeUtils.getCurrentTimestamp());

									HighLevelQuery<FlowInstance> query = new HighLevelQuery<FlowInstance>();
									flowDAOFactory.getFlowInstanceDAO().update(flowInstance, query);

									flowAdminModule.getFlowInstanceEventGenerator().addFlowInstanceEvent(flowInstance, EventType.OTHER_EVENT, votingEndedEventDetails + votes, null);
									FlowInstanceEvent flowInstanceEvent = flowAdminModule.getFlowInstanceEventGenerator().addFlowInstanceEvent(flowInstance, EventType.STATUS_UPDATED, null, null);

									systemInterface.getEventHandler().sendEvent(FlowInstance.class, new CRUDEvent<FlowInstance>(CRUDAction.UPDATE, flowInstance), EventTarget.ALL);
									systemInterface.getEventHandler().sendEvent(FlowInstance.class, new StatusChangedByManagerEvent(flowInstance, flowInstanceEvent, flowAdminModule.getSiteProfile(flowInstance), previousStatus, null), EventTarget.ALL);

									if (standardFlowNotificationHandler != null) {

										Collection<Contact> contacts = standardFlowNotificationHandler.getContactsFromDB(flowInstance);

										if (contacts != null) {

											for (Contact contact : contacts) {

												standardFlowNotificationHandler.sendContactEmail(flowInstance, contact, votingCompletedEmailSubject, votingCompletedEmailMessage, null);
												standardFlowNotificationHandler.sendContactSMS(flowInstance, contact, votingCompletedSMS);
											}
										}
									}
								}

								log.info("Anonymizing votes for " + flowInstance);
								UpdateQuery anonymizeQuery = new UpdateQuery(dataSource, "UPDATE " + votesDAO.getTableName() + " SET userID = NULL WHERE flowInstanceID = ?");
								anonymizeQuery.setInt(1, flowInstance.getFlowInstanceID());
								anonymizeQuery.executeUpdate();
							}
						}
					}
				}
			}
			
		} catch (Exception e) {
			log.error("Error checking for ending votings", e);
		}
	}
	
	@WebPublic(requireLogin = true)
	public ForegroundModuleResponse manualCheckVoteEndings(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws URINotFoundException {
		
		if (user.isAdmin()) {
			
			checkForEndingVotings();
			return null;
		}
		
		throw new URINotFoundException(uriParser);
	}
	
	public boolean sendContactEmail(ImmutableFlowInstance flowInstance, Contact contact, String subject, String message, FlowFamilyVoteSettings settings) {
		
		TagReplacer tagReplacer = new TagReplacer();
		
		SiteProfile profile = siteProfileHandler.getProfile(settings.getSiteProfileID());
		
		if (profile != null && !CollectionUtils.isEmpty(profile.getDomains())) {
			
			tagReplacer.addTagSource(new SingleTagSource("$votingURL", "https://" + profile.getDomains().get(0) + systemInterface.getContextPath() + getFullAlias() + "/show/" + flowInstance.getFlowInstanceID()));
		}
		
		return standardFlowNotificationHandler.sendContactEmail(flowInstance, contact, tagReplacer.replace(subject), tagReplacer.replace(message), null);
	}
	
	public boolean sendContactSMS(ImmutableFlowInstance flowInstance, Contact contact, String message, FlowFamilyVoteSettings settings) {
		
		TagReplacer tagReplacer = new TagReplacer();
		
		SiteProfile profile = siteProfileHandler.getProfile(settings.getSiteProfileID());
		
		if (profile != null && !CollectionUtils.isEmpty(profile.getDomains())) {
			
			tagReplacer.addTagSource(new SingleTagSource("$votingURL", "https://" + profile.getDomains().get(0) + systemInterface.getContextPath() + getFullAlias() + "/show/" + flowInstance.getFlowInstanceID()));
		}
		
		return standardFlowNotificationHandler.sendContactSMS(flowInstance, contact, tagReplacer.replace(message));
	}

	//For backward compability
	@WebPublic
	public SimpleForegroundModuleResponse feed(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Exception {

		return getRSS(req, res, user, uriParser);
	}
	
	@WebPublic(alias="rss")
	public SimpleForegroundModuleResponse getRSS(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Exception {

		FlowFamily flowFamily = null;
		FlowFamilyVoteSettings setting;

		String alias = null;
		
		if (uriParser.size() == 3 && (alias = uriParser.get(2)) != null && (setting = getSetting(alias)) != null) {
	
			if (setting.getSiteProfileID() != null) {
				
				SiteProfile profile = flowAdminModule.getCurrentSiteProfile(req, user, uriParser, flowFamily);
				
				if (profile == null || !profile.getProfileID().equals(setting.getSiteProfileID())) {
					
					throw new URINotFoundException(uriParser.getFormattedURI() + ", User is using wrong siteprofile, ");
				}
			}

			if (setting.isRssFeedActive()) {
	
				List<FlowInstance> flowInstances = getFlowInstances(getActiveFlowInstanceIDs(setting), setting);
				
				List<RSSItem> rssItems = null;
				
				rssItems = getRSSItems(flowInstances, req);
	
				log.info("User " + user + " requesting RSS feed for flowFamily " + setting.getFlowFamilyID() + " from adress " + req.getRemoteAddr());

				RSSGenerator rssGenerator = new RSSGenerator(new FlowFamilyVoteRSSChannel(setting, this, req));
				
				String rssFeedString = "";
				
				if(rssGenerator != null) {
					
					rssFeedString = rssGenerator.getStringRss(rssItems, systemInterface.getEncoding());
				}
				
				HTTPUtils.sendReponse(rssFeedString, "application/xml", res);
				return null;
			}
		}
		
		throw new URINotFoundException(uriParser);
	}
	
	
	private List<RSSItem> getRSSItems(List<FlowInstance> flowInstances, HttpServletRequest req) {

		List<RSSItem> rssItems = null;
		
		if(flowInstances != null) {
		
			rssItems = new ArrayList<RSSItem>(flowInstances.size());
			
			for(FlowInstance flowInstance : flowInstances) {
				
				SimpleRSSItem rssItem = new SimpleRSSItem();
				
				rssItem.setTitle(flowInstance.getUserDescription());

				rssItem.setDescription(StringUtils.toLogFormat(flowInstance.getAttributeHandler().getString(FLOW_INSTANCE_ATTRIBUTE_DESCRIPTION), feedItemDescriptionMaxLength));

				rssItem.setPubDate(flowInstance.getFirstSubmitted());
				
				rssItem.setLink(RequestUtils.getFullContextPathURL(req) + "/" + moduleDescriptor.getAlias() + "/show/" + flowInstance.getFlowInstanceID());
				
				rssItem.setGuid(rssItem.getLink());
				
				rssItems.add(rssItem);
			}
		}
		
		return rssItems;
	}
	
	public String getFeedLanguage() {
		return feedLanguage;
	}

	public Integer getFeedTTL() {
		return feedTTL;
	}
	
	@Override
	public int getModuleID() {

		return moduleDescriptor.getModuleID();
	}
}
