package com.nordicpeak.flowengine.evaluators.groupquerystateevaluator;

import javax.servlet.http.HttpServletRequest;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.xml.XMLUtils;
import se.unlogic.webutils.http.BeanRequestPopulator;
import se.unlogic.webutils.http.URIParser;
import se.unlogic.webutils.populators.annotated.AnnotatedRequestPopulator;

import com.nordicpeak.flowengine.evaluators.baseevaluator.BaseEvaluatorCRUD;

public class GroupQueryStateEvaluatorCRUD extends BaseEvaluatorCRUD<GroupQueryStateEvaluator, GroupQueryStateEvaluationProviderModule> {
	
	private static final BeanRequestPopulator<GroupQueryStateEvaluator> POPULATOR = new AnnotatedRequestPopulator<GroupQueryStateEvaluator>(GroupQueryStateEvaluator.class);
	
	public GroupQueryStateEvaluatorCRUD(Class<GroupQueryStateEvaluator> beanClass, AnnotatedDAOWrapper<GroupQueryStateEvaluator, Integer> evaluatorDAO, GroupQueryStateEvaluationProviderModule callback) {
		
		super(beanClass, evaluatorDAO, POPULATOR, "GroupQueryStateEvaluator", "group query state evaluator", null, callback);
	}
	
	@Override
	protected void appendUpdateFormData(GroupQueryStateEvaluator query, Document doc, Element updateTypeElement, User user, HttpServletRequest req, URIParser uriParser) throws Exception {
		super.appendUpdateFormData(query, doc, updateTypeElement, user, req, uriParser);
		
		if (query.getGroupIDs() != null) {
			XMLUtils.append(doc, updateTypeElement, "Groups", callback.getGroupHandler().getGroups(query.getGroupIDs(), true));
		}
	}
}
