package com.nordicpeak.flowengine.internalalternativelist.beans;

import java.io.Serializable;
import java.util.List;

import se.unlogic.hierarchy.core.interfaces.attributes.AttributeHandler;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

import com.nordicpeak.flowengine.alternativelist.beans.AlternativeListDescriptor;
import com.nordicpeak.flowengine.alternativelist.interfaces.AlternativeListInstance;
import com.nordicpeak.flowengine.interfaces.ImmutableAlternative;

public class InternalAlternativeListInstance extends GeneratedElementable implements AlternativeListInstance, Serializable {

	private static final long serialVersionUID = -2907579471281781085L;

	@XMLElement
	private final AlternativeListDescriptor descriptor;

	private final List<? extends ImmutableAlternative> alternatives;

	public InternalAlternativeListInstance(AlternativeListDescriptor descriptor, List<? extends ImmutableAlternative> alternatives) {
		super();

		this.descriptor = descriptor;
		this.alternatives = alternatives;
	}

	@Override
	public AlternativeListDescriptor getDescriptor() {

		return descriptor;
	}

	@Override
	public List<? extends ImmutableAlternative> getAlternatives() {

		return alternatives;
	}

	@Override
	public boolean requiresReload(AttributeHandler attributeHandler) {

		return false;
	}

}
