$(function() {

	setQueryRequiredFunctions["InternalUserQueryInstance"] = makeInternalUserQueryRequired;
});

function initInternalUserQuery(queryID) {

	var query = $("#query_" + queryID);
	var searchInput = $( "#" + queryID + "-search");
	
	if (searchInput.data('ui-autocomplete') != undefined) {
		return;
	}
	
	
	searchInput.autocomplete({
		source: function(request, response) {
			return internalUserQuerySearchUsers(request, response, searchInput.parent().data("url"), searchInput);
		},
		
		select: function(event, ui) {
			
			$("#query_" + queryID + "-validationerrors").remove();
			query.find("article.error").removeClass("error");
			
			var user = ui.item
			$("#q" + queryID + "_user").val(user.ID)
			query.find("span:not(.html-description)").text("");
			
			$("#q" + queryID + "-name").text(user.Name)
			$("#q" + queryID + "-username").text(user.Username)
			$("#q" + queryID + "-email").text(user.Email)
			
			if (user.Attributes != undefined) {
				$.each(user.Attributes, function(name, value) {
					$("#q" + queryID + "-" + name).text(value)
				})
			}
			
			query.find("fieldset").show();
			
			var managerInfo = query.find(".manager-info");

			if (managerInfo.length > 0) {
				
				if (user.Manager != undefined) {
					
					var manager = user.Manager;
					
					$("#q" + queryID + "-manager-name").text(manager.Name)
					$("#q" + queryID + "-manager-username").text(manager.Username)
					$("#q" + queryID + "-manager-email").text(manager.Email)
	
					if (manager.Attributes != undefined) {
						$.each(manager.Attributes, function(name, value) {
							$("#q" + queryID + "-manager-" + name).text(value)
						})
					}
					
					managerInfo.show();
					
				} else {
					
					managerInfo.hide();
				}
			}
			
			$(this).val("");
			
			if(query.hasClass("enableAjaxPosting")) {
				postRequest($(this), queryID);
			}
			
			return false;
		},
		
		focus: function(event, ui) {
			event.preventDefault();
		}
	});
}

function internalUserQuerySearchUsers(request, response, searchURL, searchInput) {
	
	searchInput.addClass("ui-autocomplete-loading");
	
	$.ajax({
		url : searchURL,
		dataType : "json",
		contentType: "application/x-www-form-urlencoded;charset=UTF-8",
		data : {
			q : encodeURIComponent(request.term)
		},
		success : function(data) {
			
			if (data.hits != undefined && data.hits.length > 0) {
				
				response($.map(data.hits, function(item) {
					
					return {
						label : item.Label,
						value : item.ID,
						Enabled : item.Enabled,
						Name  : item.Name,
						ID : item.ID,
						Email : item.Email,
						Username : item.Username,
						Attributes : item.Attributes,
						Manager: item.Manager
					}
				}));
			} else {
				response(null);
			}
			
			searchInput.removeClass("ui-autocomplete-loading");
		},
		error : function() {
			searchInput.removeClass("ui-autocomplete-loading");
		}
	});
}

function makeInternalUserQueryRequired(queryID) {

	$("#query_" + queryID).find(".heading-wrapper h2").addClass("required");
}

function postRequest($this, queryID) {
	
	var parameters = {};
	
	parameters["q" + queryID + "_user"] = $("#q" + queryID + "_user").val();
	
	runQueryEvaluators(queryID, parameters);
	
}
