
package se.lantmateriet.namespace.distribution.produkter.inskrivning.v2;

import javax.xml.bind.annotation.XmlEnum;
import javax.xml.bind.annotation.XmlEnumValue;
import javax.xml.bind.annotation.XmlType;


/**
 * <p>Java class for FangeskodType.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * <p>
 * <pre>
 * &lt;simpleType name="FangeskodType">
 *   &lt;restriction base="{http://www.w3.org/2001/XMLSchema}string">
 *     &lt;enumeration value="Kp normalfall"/>
 *     &lt;enumeration value="Kp specialfall, Gva som kp (vanligt)"/>
 *     &lt;enumeration value="Slktkp, annan fastighet"/>
 *     &lt;enumeration value="Slktkp, jordbruksfastighet, normalfall"/>
 *     &lt;enumeration value="Slktkp, jordbruksfastighet, specialfall. Gva som kp (slkt)"/>
 *     &lt;enumeration value="Frkp, normalfall"/>
 *     &lt;enumeration value="Frkp, specialfall"/>
 *     &lt;enumeration value="Byte"/>
 *     &lt;enumeration value="Gva"/>
 *     &lt;enumeration value="Arv, bouppteckning, bodelning, ktenskapsfrord mm"/>
 *     &lt;enumeration value="Testamente"/>
 *     &lt;enumeration value="Exekutive auktion"/>
 *     &lt;enumeration value="Expropriation och annan inlsen enligt lag"/>
 *     &lt;enumeration value="vrigt fng"/>
 *   &lt;/restriction>
 * &lt;/simpleType>
 * </pre>
 * 
 */
@XmlType(name = "FangeskodType")
@XmlEnum
public enum FangeskodType {

    @XmlEnumValue("K\u00f6p normalfall")
    KP_NORMALFALL("K\u00f6p normalfall"),
    @XmlEnumValue("K\u00f6p specialfall, G\u00e5va som k\u00f6p (vanligt)")
    KP_SPECIALFALL_GVA_SOM_KP_VANLIGT("K\u00f6p specialfall, G\u00e5va som k\u00f6p (vanligt)"),
    @XmlEnumValue("Sl\u00e4ktk\u00f6p, annan fastighet")
    SLKTKP_ANNAN_FASTIGHET("Sl\u00e4ktk\u00f6p, annan fastighet"),
    @XmlEnumValue("Sl\u00e4ktk\u00f6p, jordbruksfastighet, normalfall")
    SLKTKP_JORDBRUKSFASTIGHET_NORMALFALL("Sl\u00e4ktk\u00f6p, jordbruksfastighet, normalfall"),
    @XmlEnumValue("Sl\u00e4ktk\u00f6p, jordbruksfastighet, specialfall. G\u00e5va som k\u00f6p (sl\u00e4kt)")
    SLKTKP_JORDBRUKSFASTIGHET_SPECIALFALL_GVA_SOM_KP_SLKT("Sl\u00e4ktk\u00f6p, jordbruksfastighet, specialfall. G\u00e5va som k\u00f6p (sl\u00e4kt)"),
    @XmlEnumValue("F\u00f6rk\u00f6p, normalfall")
    FRKP_NORMALFALL("F\u00f6rk\u00f6p, normalfall"),
    @XmlEnumValue("F\u00f6rk\u00f6p, specialfall")
    FRKP_SPECIALFALL("F\u00f6rk\u00f6p, specialfall"),
    @XmlEnumValue("Byte")
    BYTE("Byte"),
    @XmlEnumValue("G\u00e5va")
    GVA("G\u00e5va"),
    @XmlEnumValue("Arv, bouppteckning, bodelning, \u00e4ktenskapsf\u00f6rord mm")
    ARV_BOUPPTECKNING_BODELNING_KTENSKAPSFRORD_MM("Arv, bouppteckning, bodelning, \u00e4ktenskapsf\u00f6rord mm"),
    @XmlEnumValue("Testamente")
    TESTAMENTE("Testamente"),
    @XmlEnumValue("Exekutive auktion")
    EXEKUTIVE_AUKTION("Exekutive auktion"),
    @XmlEnumValue("Expropriation och annan inl\u00f6sen enligt lag")
    EXPROPRIATION_OCH_ANNAN_INLSEN_ENLIGT_LAG("Expropriation och annan inl\u00f6sen enligt lag"),
    @XmlEnumValue("\u00d6vrigt f\u00e5ng")
    VRIGT_FNG("\u00d6vrigt f\u00e5ng");
    private final String value;

    FangeskodType(String v) {
        value = v;
    }

    public String value() {
        return value;
    }

    public static FangeskodType fromValue(String v) {
        for (FangeskodType c: FangeskodType.values()) {
            if (c.value.equals(v)) {
                return c;
            }
        }
        throw new IllegalArgumentException(v);
    }

}
