
package se.lantmateriet.namespace.distribution.produkter.ortnamn.v2;

import java.util.ArrayList;
import java.util.List;

import se.unlogic.standardutils.populators.EnumPopulator;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.standardutils.xml.XMLParser;
import se.unlogic.standardutils.xml.XMLParserPopulateable;
import se.unlogic.standardutils.xml.XMLPopulationUtils;
import se.unlogic.standardutils.xml.XMLValidationUtils;

public class Ortnamn implements XMLParserPopulateable {

	protected String glmID;
//	protected BoundingShapeType boundedBy;
	
	protected Long ortnamnID;
	
	protected String namn;

	protected OrtnamnLanguage language;

	protected OrtnamnsPlacering placering;

	public Long getID() {
		return ortnamnID;
	}

	public String getOrtnamn() {
		return namn;
	}

	public OrtnamnLanguage getLanguage() {
		return language;
	}

	public OrtnamnsPlacering getPlacering() {
		return placering;
	}

	@Override
	public void populate(XMLParser xmlParser) throws ValidationException {

		List<ValidationError> errors = new ArrayList<ValidationError>();
		
		glmID = xmlParser.getString("@id");
		ortnamnID = xmlParser.getLong("id");
		namn = xmlParser.getString("namn");
		
		language = XMLValidationUtils.validateParameter("sprak", xmlParser, true, new EnumPopulator<>(OrtnamnLanguage.class), errors);

		placering = XMLPopulationUtils.populateBean(xmlParser, "Placering", OrtnamnsPlacering.class, errors);

		if (!errors.isEmpty()) {
			throw new ValidationException(errors);
		}
	}
}
