
package se.lantmateriet.namespace.distribution.produkter.ortnamn.v2;

import java.util.ArrayList;
import java.util.List;

import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.standardutils.xml.XMLParser;
import se.unlogic.standardutils.xml.XMLParserPopulateable;

import net.opengis.gml.DirectPositionType;
import net.opengis.gml.PointType;

public class OrtnamnsPlacering implements XMLParserPopulateable {

	protected Integer lankod;
	protected String lannamn;
	
	protected Integer kommunkod;
	protected String kommunnamn;
	
	protected Integer sockenstadkod;
	protected String sockenstadnamn;
	
	protected String namntyp;
	
	protected PointType point;

	public Integer getLankod() {
		return lankod;
	}

	public Integer getKommunkod() {
		return kommunkod;
	}

	public String getNamntyp() {
		return namntyp;
	}

	public PointType getPoint() {
		return point;
	}

	public String getLannamn() {
		return lannamn;
	}

	public String getKommunnamn() {
		return kommunnamn;
	}

	public Integer getSockenstadkod() {
		return sockenstadkod;
	}

	public String getSockenstadnamn() {
		return sockenstadnamn;
	}

	@Override
	public void populate(XMLParser xmlParser) throws ValidationException {

		List<ValidationError> errors = new ArrayList<ValidationError>();
		
		lankod = xmlParser.getInt("lankod");
		lannamn = xmlParser.getString("lannamn");
		
		kommunkod = xmlParser.getInt("kommunkod");
		kommunnamn = xmlParser.getString("kommunnamn");
		
		sockenstadkod = xmlParser.getInt("sockenstadkod");
		sockenstadnamn = xmlParser.getString("sockenstadnamn");
		
		namntyp = xmlParser.getString("namntyp");
		
		point = new PointType();
		point.setSrsName(xmlParser.getString("Punkt/Point/@srsName"));
		DirectPositionType pos = new DirectPositionType();
		String[] posStr = xmlParser.getString("Punkt/Point/pos").split(" ");
		pos.getValue().add(Double.parseDouble(posStr[0]));
		pos.getValue().add(Double.parseDouble(posStr[1]));
		point.setPos(pos);

		if (!errors.isEmpty()) {
			throw new ValidationException(errors);
		}
	}
}
