package com.nordicpeak.lmsearch.utils;

import com.nordicpeak.lmsearch.beans.ParsedAddress;

import se.unlogic.standardutils.string.StringUtils;

public class AddressUtils {

	public static ParsedAddress getAddressNumber(String address) {

		if(address.contains(" LGH ")){
			
			address = StringUtils.substringBefore(address, " LGH ");
		}
		
		Integer firstDigitPos = getFirstDigit(address);
		
		if(firstDigitPos != null && firstDigitPos > 0 && address.length() > 1){
			
			String number = address.substring(firstDigitPos, address.length());
			
			return new ParsedAddress(address.substring(0, firstDigitPos), number.replace(" ", ""));
			
		}else if(address.contains(" ")){
				
			String number = StringUtils.substringAfter(address, " ");
			
			return new ParsedAddress(StringUtils.substringBefore(address, " "), number.replace(" ", ""));
		}
		
		return new ParsedAddress(address, null);
	}

	protected static Integer getFirstDigit(String address) {

		int index = 0;
		
		while(index < address.length()){
			
			if(Character.isDigit(address.charAt(index))){
				
				return index;
			}
			
			index++;
		}
		
		return null;
	}
	
}
