<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:exsl="http://exslt.org/common">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
		/ckeditor/ckeditor.js
		/ckeditor/adapters/jquery.js
		/ckeditor/init.js
	</xsl:variable>
	
	<xsl:variable name="links">
		/css/listsearchquery.css?v=1
	</xsl:variable>

	<xsl:variable name="scripts">
		/common/js/queryadmin.js
		/js/listsearchqueryadmin.js
	</xsl:variable>


	<xsl:template match="Document">

		<div id="ListSearchQueryProvider" class="contentitem">

			<xsl:apply-templates select="validationError" />
			<xsl:apply-templates select="UpdateListSearchQuery" />

		</div>

	</xsl:template>

	<xsl:template match="UpdateListSearchQuery">

		<h1>
			<xsl:value-of select="$i18n.UpdateQuery" />
			<xsl:text>:&#160;</xsl:text>
			<xsl:value-of select="ListSearchQuery/QueryDescriptor/name" />
		</h1>

		<xsl:apply-templates select="validationException/validationError" />

		<form id="updateListSearchQueryForm" name="queryAdminForm" method="post" action="{/Document/requestinfo/uri}">

			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="ListSearchQuery" />
			</xsl:call-template>
			
			<div class="floatleft full bigmarginbottom">
			
				<div class="floatleft full bigmarginbottom" id="exportform" style="display:none">
					<div class="floatleft full">
						<xsl:call-template name="createCheckbox">
							<xsl:with-param name="id" select="'exportAlternativeID'" />
							<xsl:with-param name="name" select="'exportAlternativeID'" />
							<xsl:with-param name="element" select="ListSearchQuery" />
						</xsl:call-template>
							
						<label for="exportAlternativeID">
							<xsl:value-of select="$i18n.exportAlternativeID" />
						</label>
				    </div>
				    <div class="floatleft fifty">
						<span class="tiny"><xsl:value-of select="$i18n.exportAlternativeIDInformation" /></span>
					</div>
				</div>

				<label for="alternativeListName">
					<xsl:value-of select="$i18n.AlternativeListName" />
				</label>

				<div class="floatleft full">
				
					<xsl:call-template name="createDropdown">
						<xsl:with-param name="id" select="'alternativeListName'"/>
						<xsl:with-param name="name" select="'alternativeListName'"/>
						<xsl:with-param name="element" select="Lists/List"/>
						<xsl:with-param name="labelElementName" select="'Name'"/>
						<xsl:with-param name="valueElementName" select="'ID'"/>
						<xsl:with-param name="selectedValue" select="CurrentList"/>
						<xsl:with-param name="class" select="'full'"/>
					</xsl:call-template>
				
				</div>
			</div>

			<div class="floatleft full bigmarginbottom">
				<label for="placeholderText" class="floatleft"><xsl:value-of select="$i18n.PlaceholderText" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'placeholderText'"/>
						<xsl:with-param name="name" select="'placeholderText'"/>
						<xsl:with-param name="title" select="$i18n.PlaceholderText"/>
						<xsl:with-param name="size" select="'89%'"/>
						<xsl:with-param name="element" select="ListSearchQuery" />
					</xsl:call-template>
				</div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="minChecked" class="floatleft"><xsl:value-of select="$i18n.MinSelected" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'minChecked'"/>
						<xsl:with-param name="name" select="'minChecked'"/>
						<xsl:with-param name="title" select="$i18n.MinSelected"/>
						<xsl:with-param name="size" select="'30'"/>
						<xsl:with-param name="element" select="ListSearchQuery" />
					</xsl:call-template>
				</div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="maxChecked" class="floatleft"><xsl:value-of select="$i18n.MaxSelected" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'maxChecked'"/>
						<xsl:with-param name="name" select="'maxChecked'"/>
						<xsl:with-param name="title" select="$i18n.MaxSelected"/>
						<xsl:with-param name="size" select="'30'"/>
						<xsl:with-param name="element" select="ListSearchQuery" />
					</xsl:call-template>
				</div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="maxChecked" class="floatleft"><xsl:value-of select="$i18n.MaxHits" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'maxHits'"/>
						<xsl:with-param name="name" select="'maxHits'"/>
						<xsl:with-param name="title" select="$i18n.MaxHits"/>
						<xsl:with-param name="size" select="'30'"/>
						<xsl:with-param name="element" select="ListSearchQuery" />
					</xsl:call-template>
				</div>
			</div>			
			
			<div class="floatleft full bigmarginbottom">
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'showAlternativesOnEmptySearch'" />
						<xsl:with-param name="name" select="'showAlternativesOnEmptySearch'" />
						<xsl:with-param name="element" select="ListSearchQuery" /> 
						<xsl:with-param name="class" select="'vertical-align-middle'" />
					</xsl:call-template>
						
					<label for="showAlternativesOnEmptySearch">
						<xsl:value-of select="$i18n.showAlternativesOnEmptySearch" />
					</label>
				</div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'showExactMatchesFirst'" />
						<xsl:with-param name="name" select="'showExactMatchesFirst'" />
						<xsl:with-param name="element" select="ListSearchQuery" /> 
					</xsl:call-template>
						
					<label for="showExactMatchesFirst">
						<xsl:value-of select="$i18.showExactMatchesFirst" />
					</label>
				</div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'setAsAttribute'" />
						<xsl:with-param name="name" select="'setAsAttribute'" />
						<xsl:with-param name="element" select="ListSearchQuery" /> 
						<xsl:with-param name="class" select="'vertical-align-middle'" />
					</xsl:call-template>
						
					<label for="setAsAttribute">
						<xsl:value-of select="$i18n.setAsAttribute" />
					</label>
				</div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="attributeName" class="floatleft clearboth"><xsl:value-of select="$i18n.attributeName" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'attributeName'"/>
						<xsl:with-param name="name" select="'attributeName'"/>
						<xsl:with-param name="title" select="$i18n.attributeName"/>
						<xsl:with-param name="element" select="ListSearchQuery" />
						<xsl:with-param name="maxlength" select="'255'"/>
					</xsl:call-template>
				</div>
			</div>

			
			<div class="floatright margintop clearboth">
				<input type="submit" value="{$i18n.SaveChanges}" />
			</div>

		</form>

	</xsl:template>

	<xsl:template match="validationError[messageKey = 'UpdateFailedListSearchQueryNotFound']">

		<p class="error">
			<xsl:value-of select="$i18n.ListSearchQueryNotFound" />
		</p>

	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'MinSelectedBiggerThanMaxSelected']">
		
		<p class="error">
			<xsl:value-of select="$i18n.MinSelectedBiggerThanMaxSelected" />
		</p>
		
	</xsl:template>
	
	<xsl:template match="fieldName">

		<xsl:variable name="fieldName" select="." />

		<xsl:choose>
			<xsl:when test="$fieldName = 'providerIdentifier'">
				<xsl:value-of select="$i18n.ProviderIdentifier" />
			</xsl:when>
			<xsl:when test="$fieldName = 'minChecked'">
				<xsl:value-of select="$i18n.minSelectedAlternatives" />
			</xsl:when>
			<xsl:when test="$fieldName = 'maxChecked'">
				<xsl:value-of select="$i18n.maxSelectedAlternatives" />
			</xsl:when>
			<xsl:when test="$fieldName = 'maxHits'">
				<xsl:value-of select="$i18n.MaxHits" />
			</xsl:when>
			<xsl:when test="$fieldName = 'attributeName'">
				<xsl:value-of select="$i18n.attributeName" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>

</xsl:stylesheet>