package com.nordicpeak.flowengine.queries.manualtextareaquery;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.webutils.http.BeanRequestPopulator;
import se.unlogic.webutils.http.URIParser;

import com.nordicpeak.flowengine.beans.QueryDescriptor;
import com.nordicpeak.flowengine.queries.basequery.BaseQueryCRUD;

public class ManualTextAreaQueryCRUD extends BaseQueryCRUD<ManualTextAreaQuery, ManualTextAreaQueryProviderModule> {

	protected AnnotatedDAOWrapper<ManualTextAreaQuery, Integer> queryDAO;
	
	public ManualTextAreaQueryCRUD(AnnotatedDAOWrapper<ManualTextAreaQuery, Integer> queryDAO, BeanRequestPopulator<ManualTextAreaQuery> populator, String typeElementName, String typeLogName, String listMethodAlias, ManualTextAreaQueryProviderModule callback) {
		
		super(ManualTextAreaQuery.class, queryDAO, populator, typeElementName, typeLogName, listMethodAlias, callback);
		
		this.queryDAO = queryDAO;
	}

	@Override
	protected ManualTextAreaQuery populateFromUpdateRequest(ManualTextAreaQuery bean, HttpServletRequest req, User user, URIParser uriParser) throws ValidationException, Exception {
		
		ManualTextAreaQuery query = super.populateFromUpdateRequest(bean, req, user, uriParser);
		
		List<ValidationError> validationErrors = new ArrayList<ValidationError>();

		this.populateQueryDescriptor((QueryDescriptor) query.getQueryDescriptor(), req, validationErrors);
		
		if(query.getRows() != null) {
			
			if(query.getRows() > 255) {
				validationErrors.add(new ValidationError("RowCountTooHigh"));
			}
		}
		
		if(!validationErrors.isEmpty()) {
			throw new ValidationException(validationErrors);
		}

		return query;
	}

}
