<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/CKEditor.xsl"/>

	<xsl:variable name="globalscripts">
		/jquery/jquery.js
		/jquery/jquery-migrate.js
		/ckeditor/ckeditor.js
		/ckeditor/adapters/jquery.js
		/ckeditor/init.js
	</xsl:variable>
	
	<xsl:template match="Document">

		<div class="contentitem">

			<xsl:apply-templates select="UpdateMultipartSigningMailEvaluatorEvaluator" />
		</div>

	</xsl:template>

	<xsl:template match="UpdateMultipartSigningMailEvaluatorEvaluator">

		<h1>
			<xsl:value-of select="$i18n.UpdateEvaluatorDescriptor.title" />
			<xsl:text>&#x20;</xsl:text>
			<xsl:value-of select="MultipartSigningMailEvaluatorEvaluator/EvaluatorDescriptor/name" />
		</h1>

		<xsl:apply-templates select="validationException/validationError" />

		<form method="post" action="{/Document/requestinfo/uri}">

			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="MultipartSigningMailEvaluatorEvaluator" />
			</xsl:call-template>

			<h2 class="floatleft full bigmargintop">
				<xsl:value-of select="$i18n.EmailHeader" />
			</h2>

			<div class="clearboth floatleft">
				<xsl:value-of select="$i18n.EmailHeaderDescription" />
				<xsl:text>&#x20;</xsl:text>
				<xsl:value-of select="AvailableTags" />
			</div>

			<label class="floatleft full" for="emailRecipients">
				<xsl:value-of select="$i18n.EmailRecipients" />
			</label>

			<div class="clearboth floatleft">
				<xsl:value-of select="$i18n.EmailRecipientsDescription" />
			</div>

			<div class="floatleft full marginbottom">
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'emailRecipients'" />
						<xsl:with-param name="name" select="'emailRecipients'" />
						<xsl:with-param name="title" select="$i18n.EmailRecipients"/>
						<xsl:with-param name="value" select="EmailRecipients" />
					</xsl:call-template>
				</div>
			</div>
	
			<label class="floatleft" for="emailSubject">
				<xsl:value-of select="$i18n.EmailSubject" />
			</label>

			<div class="floatleft full marginbottom">

				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'emailSubject'" />
						<xsl:with-param name="name" select="'emailSubject'" />
						<xsl:with-param name="title" select="$i18n.EmailSubject"/>
						<xsl:with-param name="element" select="MultipartSigningMailEvaluatorEvaluator" />
					</xsl:call-template>
				</div>
			</div>
			
			<label class="floatleft" for="emailMessage">
				<xsl:value-of select="$i18n.EmailMessage" />
			</label>

			<div class="floatleft full marginbottom">

				<div class="floatleft full">
					<xsl:call-template name="createTextArea">
						<xsl:with-param name="id" select="'emailMessage'" />
						<xsl:with-param name="name" select="'emailMessage'" />
						<xsl:with-param name="title" select="$i18n.EmailMessage"/>
						<xsl:with-param name="class" select="'message-ckeditor'" />
						<xsl:with-param name="element" select="MultipartSigningMailEvaluatorEvaluator" />
					</xsl:call-template>
				</div>
			</div>

			<xsl:call-template name="initializeFCKEditor">
				<xsl:with-param name="basePath"><xsl:value-of select="/Document/requestinfo/contextpath"/>/static/f/<xsl:value-of select="/Document/module/sectionID"/>/<xsl:value-of select="/Document/module/moduleID"/>/ckeditor/</xsl:with-param>
				<xsl:with-param name="customConfig">config.js</xsl:with-param>
				<xsl:with-param name="editorContainerClass">message-ckeditor</xsl:with-param>
				<xsl:with-param name="editorHeight">150</xsl:with-param>
				<xsl:with-param name="contentsCss">
					<xsl:if test="/Document/cssPath">
						<xsl:value-of select="/Document/cssPath"/>
					</xsl:if>
				</xsl:with-param>
			</xsl:call-template>
			
			<xsl:if test="allowPosterContactAsSender">
				
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'usePosterContactAsSender'" />
						<xsl:with-param name="name" select="'usePosterContactAsSender'" />
						<xsl:with-param name="value" select="'true'" />
						<xsl:with-param name="element" select="MultipartSigningMailEvaluatorEvaluator" />
					</xsl:call-template>
	
					<label for="usePosterContactAsSender">
						<xsl:value-of select="$i18n.UsePosterContactAsSender" />
					</label>
				</div>
				
			</xsl:if>

			<div class="floatright clearboth">
				<input type="submit" value="{$i18n.Submit}" />
			</div>

		</form>

	</xsl:template>

	<xsl:template match="fieldName">

		<xsl:variable name="fieldName" select="." />

		<xsl:choose>
			<xsl:when test="$fieldName = 'emailSubject'">
				<xsl:value-of select="$i18n.emailSubject" />
			</xsl:when>
			<xsl:when test="$fieldName = 'emailMessage'">
				<xsl:value-of select="$i18n.emailMessage" />
			</xsl:when>
			<xsl:when test="$fieldName = 'emailRecipients'">
				<xsl:value-of select="$i18n.emailRecipients" />
				<xsl:text>&#x20;(</xsl:text>
				<xsl:value-of select="../displayName" />
				<xsl:text>)</xsl:text>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>

</xsl:stylesheet>