<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	
	<xsl:template match="Document">	
		
		<xsl:apply-templates select="ShowQueryValues"/>
		
	</xsl:template>
		
	<xsl:template match="ShowQueryValues">
		
		<div class="query">
			<xsl:attribute name="class">
				<xsl:text>query</xsl:text>
				<xsl:if test="PUDQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>
			
			<a name="query{CheckboxQueryInstance/QueryInstanceDescriptor/QueryDescriptor/queryID}"/>
			
			<h2>
				<xsl:value-of select="PUDQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
			</h2>
			
			<xsl:if test="Description">
				
				<div class="query-description">
					<xsl:choose>
						<xsl:when test="isHTMLDescription = 'true'">
							<xsl:value-of select="Description" disable-output-escaping="yes"/>
						</xsl:when>
						<xsl:otherwise>
							<p>
								<xsl:value-of select="Description" disable-output-escaping="yes"/>
							</p>
						</xsl:otherwise>
					</xsl:choose>
				</div>
								
			</xsl:if>
			
			<p>
				<xsl:choose>
					<xsl:when test="PUDQueryInstance/PUDQuery/useAsResult = 'USE_ADDRESS_AS_RESULT'">
						<xsl:value-of select="PUDQueryInstance/address" />
					</xsl:when>
					<xsl:when test="PUDQueryInstance/PUDQuery/useAsResult = 'USE_ALL_AS_RESULT'">
						<xsl:value-of select="PUDQueryInstance/address" />
						<br/>
						<xsl:value-of select="PUDQueryInstance/propertyUnitDesignation" />
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="PUDQueryInstance/propertyUnitDesignation" />
					</xsl:otherwise>
				</xsl:choose>
			</p>	
			
		</div>
		
	</xsl:template>		

</xsl:stylesheet>