<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />

	<xsl:template match="Document">

		<div class="contentitem">

			<xsl:apply-templates select="UpdateWeightCalculatedParagraphEvaluator" />
		</div>

	</xsl:template>

	<xsl:template match="UpdateWeightCalculatedParagraphEvaluator">

		<h1>
			<xsl:value-of select="$i18n.UpdateEvaluatorDescriptor.title" />
			<xsl:text>&#x20;</xsl:text>
			<xsl:value-of select="WeightCalculatedParagraphEvaluator/EvaluatorDescriptor/name" />
		</h1>

		<xsl:apply-templates select="validationException/validationError" />

		<form method="post" action="{/Document/requestinfo/uri}">

			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="WeightCalculatedParagraphEvaluator" />
			</xsl:call-template>

			<div class="floatleft full bigmarginbottom">

			<label for="weightType" class="floatleft full">
				<xsl:value-of select="$i18n.expression" />
				<span class="required">*</span>
			</label>
			
			<p><xsl:value-of select="$i18n.expressionDescription" /><br/><xsl:value-of select="$i18n.expressionDescription2" /></p>

			<div class="floatleft full">
				<xsl:call-template name="createTextArea">
					<xsl:with-param name="id" select="'expression'" />
					<xsl:with-param name="name" select="'expression'" />
					<xsl:with-param name="element" select="WeightCalculatedParagraphEvaluator" />
				</xsl:call-template>
			</div>
		</div>
				
			<label class="floatleft full">
				<xsl:value-of select="$i18n.weight.title" />
			</label>
			
			<div class="clearboth floatleft marginbottom">
				<xsl:value-of select="$i18n.weight.description" />
			</div>
			
			<div class="clearboth floatleft marginbottom twenty">
				<xsl:value-of select="$i18n.from" />
				<span class="required">*</span>
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'fromValue'" />
					<xsl:with-param name="name" select="'fromValue'" />
					<xsl:with-param name="element" select="WeightCalculatedParagraphEvaluator" />
				</xsl:call-template>
			</div>
		
			<div class="clearboth floatleft marginbottom twenty">
				<xsl:value-of select="$i18n.to" />
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'toValue'" />
					<xsl:with-param name="name" select="'toValue'" />
					<xsl:with-param name="element" select="WeightCalculatedParagraphEvaluator" />
				</xsl:call-template>
			</div>	
		
			<label class="floatleft full">
				<xsl:value-of select="$i18n.mode.title" />
			</label>		
		
			<div class="clearboth floatleft marginbottom">
				<xsl:value-of select="$i18n.mode.description" />
			</div>		
		
			<div class="floatleft full marginbottom">

				<div class="floatleft full">
					<xsl:call-template name="createRadio">
						<xsl:with-param name="id" select="'hide'" />
						<xsl:with-param name="name" select="'showParagraphs'" />
						<xsl:with-param name="value" select="'false'" />
						<xsl:with-param name="element" select="WeightCalculatedParagraphEvaluator" />
					</xsl:call-template>

					<label for="hide">
						<xsl:value-of select="$i18n.mode.hide" />
					</label>
				</div>
			</div>

			<div class="floatleft full marginbottom">

				<div class="floatleft full">
					<xsl:call-template name="createRadio">
						<xsl:with-param name="id" select="'show'" />
						<xsl:with-param name="name" select="'showParagraphs'" />
						<xsl:with-param name="value" select="'true'" />
						<xsl:with-param name="element" select="WeightCalculatedParagraphEvaluator" />
					</xsl:call-template>

					<label for="show">
						<xsl:value-of select="$i18n.mode.show" />
					</label>
				</div>
			</div>			
		
			<label class="floatleft">
				<xsl:value-of select="$i18n.paragraphs.title" />
			</label>

			<div class="clearboth floatleft marginbottom">
				<xsl:value-of select="$i18n.paragraphs.description" />

				<xsl:choose>
					<xsl:when test="Paragraphs/Paragraph">
					
						<xsl:apply-templates select="Paragraphs/Paragraph"/>
					
					</xsl:when>
					<xsl:otherwise>
						<p>
							<xsl:value-of select="$i18n.QueryHasNoParagraphs" />
						</p>
					</xsl:otherwise>
				</xsl:choose>
			</div>

			<div class="floatright clearboth">
				<input type="submit" value="{$i18n.UpdateWeightCalculatedParagraphEvaluator.submit}" />
			</div>

		</form>

	</xsl:template>

	<xsl:template match="Paragraph">

		<div class="floatleft full">
		
			<xsl:variable name="paragraphID" select="paragraphID"/>
	
			<xsl:call-template name="createCheckbox">
				<xsl:with-param name="id" select="concat('paragraph', paragraphID)"/>
				<xsl:with-param name="name" select="'paragraphID'"/>
				<xsl:with-param name="value" select="paragraphID"/>
				<xsl:with-param name="requestparameters" select="../../requestparameters"/>
				<xsl:with-param name="checked">
					<xsl:if test="../../WeightCalculatedParagraphEvaluator/TargetParagraphIDs[paragraphID = $paragraphID]/paragraphID">true</xsl:if>
				</xsl:with-param>
			</xsl:call-template>
	
			<label for="paragraph{paragraphID}">
				<xsl:value-of select="name" />
		
				<xsl:if test="visible = 'false'">
					<xsl:text>&#160;(</xsl:text>
					<xsl:value-of select="$i18n.Hidden"></xsl:value-of>
					<xsl:text>)</xsl:text>
				</xsl:if>			
			</label>
		
		</div>


	</xsl:template>

	<xsl:template match="validationError">
		
		<xsl:if test="fieldName and validationErrorType and not(messageKey)">
			<p class="error">
				<xsl:choose>
					<xsl:when test="validationErrorType='RequiredField'">
						<xsl:value-of select="$i18n.validation.requiredField" />
					</xsl:when>
					<xsl:when test="validationErrorType='InvalidFormat'">
						<xsl:value-of select="$i18n.validation.invalidFormat" />
					</xsl:when>
					<xsl:when test="validationErrorType='TooShort'">
						<xsl:value-of select="$i18n.validation.tooShort" />
					</xsl:when>
					<xsl:when test="validationErrorType='TooLong'">
						<xsl:value-of select="$i18n.validation.tooLong" />
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$i18n.validation.unknownError" />
					</xsl:otherwise>
				</xsl:choose>

				<xsl:text>&#x20;</xsl:text>

				<xsl:choose>
					<xsl:when test="fieldName = 'name'">
						<xsl:value-of select="$i18n.name" />
					</xsl:when>
					<xsl:when test="fieldName = 'toValue'">
						<xsl:value-of select="$i18n.to" />
					</xsl:when>
					<xsl:when test="fieldName = 'fromValue'">
						<xsl:value-of select="$i18n.from" />
					</xsl:when>
					<xsl:when test="fieldName = 'expression'">
						<xsl:value-of select="$i18n.expression" />
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="fieldName" />
					</xsl:otherwise>
				</xsl:choose>
			</p>
			
		</xsl:if>

		<xsl:if test="messageKey">
			<p class="error">
				<xsl:choose>
					<xsl:when test="messageKey = 'FromValueBiggerThanToValue'">
						<xsl:value-of select="$i18n.FromValueBiggerThanToValue" />
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$i18n.validation.unknownFault" />
					</xsl:otherwise>
				</xsl:choose>
			</p>
		</xsl:if>

	</xsl:template>

</xsl:stylesheet>