package com.nordicpeak.flowengine.paymentlog.beans;

import java.lang.reflect.Field;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.reflection.ReflectionUtils;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@XMLElement
@Table(name = "payment_account_number_parts")
public class AccountNumberPart extends GeneratedElementable {
	
	public static final Field ACCOUNT_NUMBER_PART_DEFINITION_RELATION = ReflectionUtils.getField(AccountNumberPart.class, "accountNumberPartDefinition");
	
	@DAOManaged(columnName = "accountID")
	@Key
	@ManyToOne
	private Account account;
	
	@DAOManaged(columnName = "accountPartDefinitionID")
	@Key
	@ManyToOne
	@XMLElement(fixCase = true)
	private AccountNumberPartDefinition accountNumberPartDefinition;
	
	@DAOManaged
	@XMLElement
	private Integer value;
	
	public Account getAccount() {
		return account;
	}
	
	public void setAccount(Account account) {
		this.account = account;
	}
	
	public AccountNumberPartDefinition getAccountNumberPartDefinition() {
		return accountNumberPartDefinition;
	}
	
	public void setAccountNumberPartDefinition(AccountNumberPartDefinition accountNumberPartDefinition) {
		this.accountNumberPartDefinition = accountNumberPartDefinition;
	}
	
	public Integer getValue() {
		return value;
	}
	
	public void setValue(Integer value) {
		this.value = value;
	}
	
}
