package com.nordicpeak.flowengine.paymentlog.beans;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@XMLElement
@Table(name = "payment_flow_family_settings_per_product")
public class PaymentProductTransactionSettings extends GeneratedElementable {

	@DAOManaged
	@Key
	@XMLElement
	private String description;

	@DAOManaged(columnName = "flowFamilyID")
	@ManyToOne
	private FlowFamilyTransactionSettings flowFamilySettings;

	@DAOManaged(columnName = "accountID")
	@ManyToOne(autoGet = true)
	@XMLElement
	private Account account;

	@DAOManaged(columnName = "vatAccountID")
	@ManyToOne(autoGet = true)
	@XMLElement
	private Account vatAccount;

	public PaymentProductTransactionSettings() {}

	public PaymentProductTransactionSettings(String description, Account account, Account vatAccount) {

		this.description = description;
		this.account = account;
		this.vatAccount = vatAccount;
	}

	public String getDescription() {

		return description;
	}

	public void setDescription(String Description) {

		this.description = Description;
	}

	public FlowFamilyTransactionSettings getFlowFamilySettings() {

		return flowFamilySettings;
	}

	public void setFlowFamilySettings(FlowFamilyTransactionSettings flowFamilySettings) {

		this.flowFamilySettings = flowFamilySettings;
	}

	public Account getAccount() {

		return account;
	}

	public void setAccount(Account account) {

		this.account = account;
	}

	public Account getVatAccount() {

		return vatAccount;
	}

	public void setVatAccount(Account vatAccount) {

		this.vatAccount = vatAccount;
	}

}
