package com.nordicpeak.flowengine.paymentlog.beans;

import java.lang.reflect.Field;
import java.math.BigDecimal;
import java.sql.Timestamp;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.reflection.ReflectionUtils;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@XMLElement
@Table(name = "payment_transactions")
public class Transaction extends GeneratedElementable {
	
	public static final Field ACCOUNT_RELATION = ReflectionUtils.getField(Transaction.class, "account");
	
	@DAOManaged(autoGenerated = true)
	@Key
	@XMLElement
	private Integer transactionID;
	
	@DAOManaged
	@XMLElement
	private Timestamp added;
	
	@DAOManaged
	@XMLElement
	private BigDecimal amount;
	
	@DAOManaged(columnName = "accountID")
	@ManyToOne
	@XMLElement
	private Account account;
	
	@DAOManaged
	@XMLElement
	private String description;
	
	@DAOManaged
	@XMLElement
	private String sourceType;
	
	@DAOManaged
	@XMLElement
	private Integer sourceID;
	
	@DAOManaged(columnName = "userID", dontUpdateIfNull = true)
	@XMLElement
	private User user;
	
	@DAOManaged
	@XMLElement
	private String userString;
	
	public Integer getTransactionID() {
		return transactionID;
	}
	
	public void setTransactionID(Integer transactionID) {
		this.transactionID = transactionID;
	}
	
	public Timestamp getAdded() {
		return added;
	}
	
	public void setAdded(Timestamp added) {
		this.added = added;
	}
	
	public BigDecimal getAmount() {
		return amount;
	}
	
	public void setAmount(BigDecimal amount) {
		this.amount = amount;
	}
	
	public Account getAccount() {
		return account;
	}
	
	public void setAccount(Account account) {
		this.account = account;
	}
	
	public String getDescription() {
		return description;
	}
	
	public void setDescription(String description) {
		this.description = description;
	}
	
	public String getSourceType() {
		return sourceType;
	}
	
	public void setSourceType(String sourceType) {
		this.sourceType = sourceType;
	}
	
	public Integer getSourceID() {
		return sourceID;
	}
	
	public void setSourceID(Integer sourceID) {
		this.sourceID = sourceID;
	}
	
	public User getUser() {
		return user;
	}
	
	public void setUser(User user) {
		this.user = user;
	}
	
	public String getUserString() {
		return userString;
	}
	
	public void setUserString(String userString) {
		this.userString = userString;
	}
	
}
