<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:exsl="http://exslt.org/common">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1"/>

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
		/jquery/jquery-migrate.js?v=1
		/ckeditor/ckeditor.js
		/ckeditor/adapters/jquery.js
		/ckeditor/init.js
	</xsl:variable>	
	<!-- 
	<xsl:variable name="links">
		/css/personqueryadmin.css
	</xsl:variable>
	
	<xsl:variable name="scripts">
		/js/personqueryadmin.js
	</xsl:variable>
	-->
	
	<xsl:template match="Document">	
		
		<div id="PersonQueryProvider" class="contentitem">
		
			<xsl:apply-templates select="validationError"/>
			<xsl:apply-templates select="UpdatePersonQuery"/>
		
		</div>
		
	</xsl:template>
		
	<xsl:template match="UpdatePersonQuery">
	
		<h1><xsl:value-of select="$i18n.UpdateQuery" /><xsl:text>:&#160;</xsl:text><xsl:value-of select="PersonQuery/QueryDescriptor/name" /></h1>
		
		<xsl:apply-templates select="validationException/validationError" />
		
		<form id="updatePersonQueryForm" name="queryAdminForm" method="post" action="{/Document/requestinfo/uri}">
		
			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="PersonQuery" />
			</xsl:call-template>
			
			<div class="floatleft full bigmarginbottom">
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'allowNoPersonFound'" />
						<xsl:with-param name="name" select="'allowNoPersonFound'" />
						<xsl:with-param name="element" select="PersonQuery" /> 
						<xsl:with-param name="class" select="'vertical-align-middle'" />
					</xsl:call-template>
						
					<label for="allowNoPersonFound">
						<xsl:value-of select="$i18n.Query.allowNoPersonFound" />
					</label>
				</div>
			</div>
			
			<div class="floatleft full bigmarginbottom">

				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'useForMultipartSigning'" />
					<xsl:with-param name="name" select="'useForMultipartSigning'" />
					<xsl:with-param name="element" select="PersonQuery" />
				</xsl:call-template>
				
				<label for="useForMultipartSigning">
					<xsl:value-of select="$i18n.Query.UseForMultipartSigning" />
				</label>
			</div>
			
			<div class="floatleft full bigmarginbottom">
			
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'setMultipartsAsOwners'" />
					<xsl:with-param name="name" select="'setMultipartsAsOwners'" />
					<xsl:with-param name="element" select="PersonQuery" /> 
				</xsl:call-template>
					
				<label for="setMultipartsAsOwners">
					<xsl:value-of select="$i18n.Query.SetMultipartsAsOwners" />
				</label>
			</div>
			
			<div class="floatleft full bigmarginbottom">
			
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'blockPosterSelection'" />
					<xsl:with-param name="name" select="'blockPosterSelection'" />
					<xsl:with-param name="element" select="PersonQuery" /> 
				</xsl:call-template>
					
				<label for="blockPosterSelection">
					<xsl:value-of select="$i18n.Query.BlockPosterSelection" />
				</label>
			</div>
			
			<div class="floatleft full bigmargintop">
				<h2><xsl:value-of select="$i18n.AdvancedSettings" /></h2>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'setAsAttribute'" />
						<xsl:with-param name="name" select="'setAsAttribute'" />
						<xsl:with-param name="element" select="PersonQuery" /> 
						<xsl:with-param name="class" select="'vertical-align-middle'" />
					</xsl:call-template>
						
					<label for="setAsAttribute">
						<xsl:value-of select="$i18n.Query.setAsAttribute" />
					</label>
				</div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="{attributeName}" class="floatleft clearboth"><xsl:value-of select="$i18n.Query.attributeName" /></label>
				
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'attributeName'"/>
						<xsl:with-param name="name" select="'attributeName'"/>
						<xsl:with-param name="title" select="$i18n.Query.attributeName"/>
						<xsl:with-param name="element" select="PersonQuery" />
						<xsl:with-param name="maxlength" select="'255'"/>
					</xsl:call-template>
			  </div>
			</div>
			
			<p class="floatleft clearboth"><xsl:value-of select="$i18n.attributeDescription" /></p>
			
			<table class="floatleft clearboth border">
				<thead>
					<th><xsl:value-of select="$i18n.attributes.name" /></th>
					<th><xsl:value-of select="$i18n.attributes.value" /></th>
				</thead>
				<tbody>
					<tr>
						<td>prefix.firstname</td>
						<td><xsl:value-of select="$java.exportFirstName" /></td>
					</tr>
					<tr>
						<td>prefix.lastname</td>
						<td><xsl:value-of select="$java.exportLastName" /></td>
					</tr>
					<tr>
						<td>prefix.careOf</td>
						<td><xsl:value-of select="$java.exportCareOf" /></td>
					</tr>
					<tr>
						<td>prefix.address</td>
						<td><xsl:value-of select="$java.exportAddress" /></td>
					</tr>
					<tr>
						<td>prefix.postalCode</td>
						<td><xsl:value-of select="$java.exportZipCode" /></td>
					</tr>
					<tr>
						<td>prefix.postalAddress</td>
						<td><xsl:value-of select="$java.exportPostalAddress" /></td>
					</tr>
					<tr>
						<td>prefix.citizenID</td>
						<td><xsl:value-of select="$java.exportCitizenID" /></td>
					</tr>
					<tr>
						<td>prefix.email</td>
						<td><xsl:value-of select="$java.exportEmail" /><xsl:value-of select="$i18n.attributes.OnlyForMultiSign" /></td>
					</tr>
					<tr>
						<td>prefix.phone</td>
						<td><xsl:value-of select="$java.exportPhone" /><xsl:value-of select="$i18n.attributes.OnlyForMultiSign" /></td>
					</tr>
				</tbody>
			</table>
			
			<div class="floatright margintop clearboth">
				<input type="submit" value="{$i18n.SaveChanges}" />
			</div>
		
		</form>
		
	</xsl:template>

	<xsl:template match="validationError[messageKey = 'UpdateFailedPersonQueryNotFound']">
		
		<p class="error">
			<xsl:value-of select="$i18n.ValidationError.PersonQueryNotFound" />
		</p>
		
	</xsl:template>

	<xsl:template match="fieldName">

		<xsl:variable name="fieldName" select="." />
	
		<xsl:choose>
			<xsl:when test="$fieldName = 'attributeName'">
				<xsl:value-of select="$i18n.Query.attributeName" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>
		
	</xsl:template>

</xsl:stylesheet>