package com.nordicpeak.flowengine.queries.plotquery;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.hierarchy.core.interfaces.FilterChain;
import se.unlogic.hierarchy.filtermodules.AnnotatedFilterModule;
import se.unlogic.standardutils.numbers.NumberUtils;
import se.unlogic.webutils.http.SessionUtils;
import se.unlogic.webutils.http.URIParser;

public class PlotQueryFilterModule extends AnnotatedFilterModule {

	@Override
	public void processFilterRequest(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser, FilterChain filterChain) throws Exception {

		Integer objectID = NumberUtils.toInt(req.getParameter(PlotIntegrationConstants.QUERY_PARAM_OBJECT_ID));
		String guid = req.getParameter(PlotIntegrationConstants.QUERY_PARAM_GUID);

		if (objectID != null) {

			SessionUtils.setAttribute(PlotIntegrationConstants.QUERY_PARAM_OBJECT_ID, objectID, req);
		}

		if (guid != null) {

			SessionUtils.setAttribute(PlotIntegrationConstants.QUERY_PARAM_GUID, guid, req);
		}

		filterChain.doFilter(req, res, user, uriParser);
	}
}