<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
		/jquery/jquery-migrate.js?v=1
		/jquery/jquery-ui.js?v=1
		/js/confirmpost.js
	</xsl:variable>
	
	<xsl:variable name="globallinks">
		/css/openhierarchy-jquery-ui.css
	</xsl:variable>
	
	<xsl:variable name="scripts">
		/js/datatables.min.js
		/js/ploteventmodule.js?v=2
	</xsl:variable>
	
	<xsl:variable name="links">
		/css/datatables.css
		/css/ploteventmodule.css?v=1
	</xsl:variable>
	
	<xsl:template match="Document">
	
		<xsl:apply-templates select="ListPlotEvents"/>
			
	</xsl:template>
	
	<xsl:template match="ListPlotEvents">
	
		<script>
			i18nPlotEventModule.eventType.LOCKED = '<xsl:value-of select="$i18n.EventType.Locked"/>';
			i18nPlotEventModule.eventType.LOCK_REFRESHED = '<xsl:value-of select="$i18n.EventType.LockRefreshed"/>';
			i18nPlotEventModule.eventType.LOCK_FAILED = '<xsl:value-of select="$i18n.EventType.LockFailed"/>';
			i18nPlotEventModule.eventType.SUBMITTED = '<xsl:value-of select="$i18n.EventType.Submitted"/>';
			i18nPlotEventModule.eventType.UNKNOWN_ERROR = '<xsl:value-of select="$i18n.EventType.UnknownError"/>';
			
			i18nPlotEventModule.dataTables.EMPTY_TABLE = '<xsl:value-of select="$i18n.EmptyTable"/>';
			i18nPlotEventModule.dataTables.NEXT = '<xsl:value-of select="$i18n.Next"/>';
			i18nPlotEventModule.dataTables.PREVIOUS =  '<xsl:value-of select="$i18n.Previous"/>';
			i18nPlotEventModule.dataTables.DELETE =  '<xsl:value-of select="$i18n.Delete"/>';
			i18nPlotEventModule.dataTables.SEARCH =  '<xsl:value-of select="$i18n.Search"/>';
			i18nPlotEventModule.dataTables.ZERO_RECORDS =  '<xsl:value-of select="$i18n.ZeroRecords"/>';
			i18nPlotEventModule.dataTables.LENGTH_MENU = '<xsl:value-of select="$i18n.LengthMenu"/>';
			i18nPlotEventModule.dataTables.INFO = '<xsl:value-of select="$i18n.DataTable.info"/>';
			i18nPlotEventModule.dataTables.INFO_EMPTY = '<xsl:value-of select="$i18n.DataTable.infoEmpty"/>';
			i18nPlotEventModule.dataTables.INFO_FILTERED = '<xsl:value-of select="$i18n.DataTable.infoFiltered"/>';
			i18nPlotEventModule.dataTables.FETCH_ERROR = '<xsl:value-of select="$i18n.DataTable.fetchError"/>';
			i18nPlotEventModule.dataTables.LOADING_RECORDS = '<xsl:value-of select="$i18n.DataTable.loadingRecords"/>';

			i18nPlotEventModule.filter.FROM_DATE = '<xsl:value-of select="$i18n.Filter.FromDate"/>';
			i18nPlotEventModule.filter.TO_DATE = '<xsl:value-of select="$i18n.Filter.ToDate"/>';
		</script>
	
		<div id="PlotEventModule">
			<div class="contentitem">
				<h1>
					<xsl:value-of select="$i18n.ListPlotEvents"/>
				</h1>
				
				<table id="plotEvents" class="full stripe display" data-plot-events-url="{/Document/ModuleURI}/plotevents">
					<thead>
						<tr class="nowrap">
							<th><xsl:value-of select="$i18n.ObjectID"/></th>
							<th><xsl:value-of select="$i18n.PropertyUnitDesignation"/></th>
							<th><xsl:value-of select="$i18n.EventType"/></th>
							<th><xsl:value-of select="$i18n.Details"/></th>
							<th><xsl:value-of select="$i18n.Added"/></th>
							<th><xsl:value-of select="$i18n.User"/></th>
						</tr>
					</thead>
				</table>
			</div>
		</div>
		
	</xsl:template>
	
</xsl:stylesheet>