<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	
	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>
	
	<xsl:template match="Document">
		
		<xsl:apply-templates select="ShowQueryValues"/>
		
	</xsl:template>
		
	<xsl:template match="ShowQueryValues">
		
		<div class="query">

			<xsl:attribute name="class">
				<xsl:text>query</xsl:text>
				<xsl:if test="PredefinedUserQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>
			
			<a name="query{PredefinedUserQueryInstance/QueryInstanceDescriptor/QueryDescriptor/queryID}"/>
			
			<h2>
				<xsl:value-of select="PredefinedUserQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
			</h2>
			
			<xsl:if test="Description">
				
				<div class="query-description">
					<xsl:choose>
						<xsl:when test="isHTMLDescription = 'true'">
							<xsl:value-of select="Description" disable-output-escaping="yes"/>
						</xsl:when>
						<xsl:otherwise>
							<p>
								<xsl:value-of select="Description" disable-output-escaping="yes"/>
							</p>
						</xsl:otherwise>
					</xsl:choose>
				</div>
			
			</xsl:if>
			
			<xsl:variable name="query" select="PredefinedUserQueryInstance/PredefinedUserQuery" />
			
			<div class="full display-table bigmarginbottom">
				
				<xsl:if test="$query/showName = 'true'">
					
					<div class="floatleft fifty bigmarginbottom">
						<strong>
							<xsl:value-of select="$i18n.Column.Firstname"/>
						</strong>
						<br/>
						<xsl:value-of select="PredefinedUserQueryInstance/firstname" />
					</div>
					
					<div class="floatleft fifty bigmarginbottom">
						<strong>
							<xsl:value-of select="$i18n.Column.Lastname"/>
						</strong>
						<br/>
						<xsl:value-of select="PredefinedUserQueryInstance/lastname" />
					</div>
					
				</xsl:if>
				<xsl:if test="$query/showUsername = 'true'">
				
					<div class="floatleft fifty bigmarginbottom">
						<strong>
							<xsl:value-of select="$i18n.Column.Username" />
						</strong>
						<br/>
						<xsl:value-of select="PredefinedUserQueryInstance/username" />
					</div>
				
				</xsl:if>
				
				<xsl:if test="$query/showCitizenIdentifier = 'true'">
					<div class="floatleft fifty bigmarginbottom">
						<strong>
							<xsl:value-of select="$i18n.Column.CitizenID"/>
						</strong>
						<br/>
						<xsl:value-of select="PredefinedUserQueryInstance/citizenIdentifier" />
					</div>
				</xsl:if>
				
				<xsl:if test="$query/showEmail = 'true'">
					<div class="floatleft fifty bigmarginbottom">
						<strong>
							<xsl:value-of select="$i18n.Column.Email"/>
						</strong>
						<br/>
						<xsl:value-of select="PredefinedUserQueryInstance/email" />
					</div>
				</xsl:if>
				
				<xsl:for-each select="$query/SelectedUserAttributes/SelectedUserAttribute">
				
					<div class="floatleft fifty bigmarginbottom">
						<strong>
							<xsl:value-of select="displayName" />
						</strong>
						<br/>
						
						<xsl:call-template name="printValue">
							<xsl:with-param name="value" select="../../../UserAttributeValues/UserAttributeValue[Name = current()/name]/Value" />
						</xsl:call-template>
					</div>
				
				</xsl:for-each>
					
			</div>
			
			<xsl:if test="$query/showManagerInfo = 'true'">
				
				<div class="full display-table bigmarginbottom">
				
				<div class="floatleft full bigmarginbottom">
					<strong><xsl:value-of select="$i18n.ManagerInfo" /></strong>
				</div>
					
					<xsl:if test="$query/showManagerName = 'true'">
						
						<div class="floatleft fifty bigmarginbottom">
							<strong>
								<xsl:value-of select="$i18n.Column.Firstname"/>
							</strong>
							<br/>
							<xsl:value-of select="PredefinedUserQueryInstance/managerFirstname" />
						</div>
						
						<div class="floatleft fifty bigmarginbottom">
							<strong>
								<xsl:value-of select="$i18n.Column.Lastname"/>
							</strong>
							<br/>
							<xsl:value-of select="PredefinedUserQueryInstance/managerLastname" />
						</div>
						
					</xsl:if>
					
					<xsl:if test="$query/showManagerUsername = 'true'">
					
						<div class="floatleft fifty bigmarginbottom">
							<strong><xsl:value-of select="$i18n.Column.Username" /></strong>
							<br/>
							
							<xsl:call-template name="printValue">
								<xsl:with-param name="value" select="PredefinedUserQueryInstance/managerUsername" />
							</xsl:call-template>
						</div>
					
					</xsl:if>
					
					<xsl:if test="$query/showManagerEmail = 'true'">
					
						<div class="floatleft fifty bigmarginbottom">
							<strong><xsl:value-of select="$i18n.Column.Email" /></strong>
							<br/>
							
							<xsl:call-template name="printValue">
								<xsl:with-param name="value" select="PredefinedUserQueryInstance/managerEmail" />
							</xsl:call-template>
						</div>
						
					</xsl:if>
					
					<xsl:for-each select="$query/SelectedManagerAttributes/SelectedManagerAttribute">
						
						<div class="floatleft fifty bigmarginbottom">
							<strong><xsl:value-of select="displayName" /></strong>
							<br/>
							
							<xsl:call-template name="printValue">
								<xsl:with-param name="value" select="../../../ManagerAttributeValues/ManagerAttributeValue[Name = current()/name]/Value" />
							</xsl:call-template>
						</div>
						
					</xsl:for-each>
					
				</div>
				
			</xsl:if>
			
		</div>
		
	</xsl:template>
	
	<xsl:template name="printValue">
		
		<xsl:param name="value" />
		
		<xsl:choose>
			<xsl:when test="$value">
				<xsl:value-of select="$value"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:text>-</xsl:text>
			</xsl:otherwise>
		</xsl:choose>
		
	</xsl:template>
	
</xsl:stylesheet>