package com.nordicpeak.flowengine.queries.predefineduserquery.beans;

import se.unlogic.hierarchy.core.beans.SimpleAttribute;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "predefined_user_query_instance_manager_attributes")
@XMLElement
public class ManagerAttributeValue extends SimpleAttribute {
	
	private static final long serialVersionUID = -768332256555066476L;
	
	@DAOManaged(columnName = "queryInstanceID")
	@Key
	@ManyToOne
	private PredefinedUserQueryInstance queryInstance;
	
	public ManagerAttributeValue() {}
	
	public ManagerAttributeValue(String name, String value) {
		
		super(name, value);
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((queryInstance == null) ? 0 : queryInstance.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ManagerAttributeValue other = (ManagerAttributeValue) obj;
		if (name == null) {
			if (other.name != null)
				return false;
		} else if (!name.equals(other.name))
			return false;
		return true;
	}
	
	
}
