package com.nordicpeak.flowengine.queue;

import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;

import se.unlogic.standardutils.csv.CSVRow;

import com.nordicpeak.flowengine.beans.Contact;

public class SpreadSheetUtils {

	public static void addCell(CSVRow row, int columnIndex, Object value) {

		if (value == null) {

			return;
		}

		row.setCellValue(columnIndex, value.toString());
	}

	public static void addCell(Row row, int columnIndex, Object value) {

		if (value == null) {

			return;
		}

		Cell cell = row.createCell(columnIndex);

		cell.setCellValue(value.toString());
	}

	public static void addNumericCell(Row row, int columnIndex, Number value) {

		if (value == null) {

			return;
		}

		Cell cell = row.createCell(columnIndex);

		cell.setCellValue(value.doubleValue());
	}

	public static int addContactTitleCells(Row row, int startIndex) {

		addCell(row, startIndex++, "Personnummer");
		addCell(row, startIndex++, "Frnamn");
		addCell(row, startIndex++, "Efternamn");
		addCell(row, startIndex++, "E-post");
		addCell(row, startIndex++, "Telefon");
		addCell(row, startIndex++, "Mobiltelefon");
		addCell(row, startIndex++, "Adress");
		addCell(row, startIndex++, "Postnummer");
		addCell(row, startIndex++, "Ort");

		return startIndex;
	}

	public static int addContactCells(Contact contact, Row row, int startIndex) {

		addCell(row, startIndex++, contact.getCitizenIdentifier());
		addCell(row, startIndex++, contact.getFirstname());
		addCell(row, startIndex++, contact.getLastname());
		addCell(row, startIndex++, contact.getEmail());
		addCell(row, startIndex++, contact.getPhone());
		addCell(row, startIndex++, contact.getMobilePhone());
		addCell(row, startIndex++, contact.getAddress());
		addCell(row, startIndex++, contact.getZipCode());
		addCell(row, startIndex++, contact.getPostalAddress());

		return startIndex;
	}

}
