package com.nordicpeak.flowengine.queue.beans;

import java.lang.reflect.Field;
import java.util.List;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.OneToMany;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.reflection.ReflectionUtils;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "queue_slot_internal_messages")
@XMLElement
public class InternalMessage extends BaseMessage {

	private static final long serialVersionUID = -934750439780152020L;

	public static final Field ATTACHMENTS_RELATION = ReflectionUtils.getField(InternalMessage.class, "attachments");
	public static final Field QUEUE_SLOT_RELATION = ReflectionUtils.getField(InternalMessage.class, "queueSlot");

	@DAOManaged(columnName = "queueSlotID")
	@ManyToOne
	@XMLElement
	private QueueSlot queueSlot;

	@DAOManaged
	@OneToMany(autoAdd = true)
	@XMLElement
	private List<InternalMessageAttachment> attachments;

	public InternalMessage() {}

	public InternalMessage(QueueSlot queueSlot, String message, User poster) {

		super();

		this.queueSlot = queueSlot;
		setMessage(message);
		setPoster(poster);
	}

	@Override
	public List<InternalMessageAttachment> getAttachments() {

		return attachments;
	}

	public void setAttachments(List<InternalMessageAttachment> attachments) {

		this.attachments = attachments;
	}

	@Override
	public QueueSlot getQueueSlot() {

		return queueSlot;
	}

	public void setQueueSlot(QueueSlot flowInstance) {

		this.queueSlot = flowInstance;
	}

}
