package com.nordicpeak.flowengine.queue.beans;

import java.lang.reflect.Field;

import se.unlogic.hierarchy.core.beans.SimpleAttribute;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.reflection.ReflectionUtils;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "queue_slot_attributes")
@XMLElement(name = "Attribute")
public class QueueSlotAttribute extends SimpleAttribute {

	private static final long serialVersionUID = 8352980246886449952L;

	public static final Field QUEUE_SLOT_RELATION = ReflectionUtils.getField(QueueSlotAttribute.class, "queueSlot");

	@DAOManaged(columnName = "queueSlotID")
	@Key
	@ManyToOne
	protected QueueSlot queueSlot;

	public QueueSlotAttribute() {}

	public QueueSlotAttribute(String name, String value) {

		super(name, value);
	}

	public QueueSlot getQueueSlot() {

		return queueSlot;
	}

	public void setQueueSlot(QueueSlot queueSlot) {

		this.queueSlot = queueSlot;
	}
}
