package com.nordicpeak.flowengine.queue.beans;

import se.unlogic.hierarchy.core.beans.SimpleAttribute;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "queue_slot_events_attributes")
@XMLElement(name = "Attribute")
public class QueueSlotEventAttribute extends SimpleAttribute {

	private static final long serialVersionUID = 8352980246886449952L;

	@DAOManaged(columnName = "eventID")
	@Key
	@ManyToOne
	protected QueueSlotEvent event;

	public QueueSlotEventAttribute() {}

	public QueueSlotEventAttribute(String name, String value) {

		super(name, value);
	}

	public QueueSlotEvent getEvent() {

		return event;
	}

	public void setEvent(QueueSlotEvent event) {

		this.event = event;
	}
}
