package com.nordicpeak.flowengine.randombookingnumber.beans;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.util.List;
import java.util.Objects;

import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.OneToMany;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.reflection.ReflectionUtils;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@Table(name = "random_booking_intervals")
@XMLElement
public class RandomBookingInterval extends GeneratedElementable implements Serializable {

	private static final long serialVersionUID = 2777392029697911335L;

	public static final Field FIELD_INTERVAL_ID = ReflectionUtils.getField(RandomBookingInterval.class, "intervalID");
	public static final Field FIELD_ENABLED = ReflectionUtils.getField(RandomBookingInterval.class, "enabled");
	public static final Field FIELD_NUMBERS = ReflectionUtils.getField(RandomBookingInterval.class, "numbers");
	public static final Field FIELD_MAPPINGS = ReflectionUtils.getField(RandomBookingInterval.class, "mappings");

	@DAOManaged(autoGenerated = true)
	@Key
	@XMLElement
	private Integer intervalID;

	@DAOManaged
	@WebPopulate(maxLength = 255)
	@XMLElement
	private String name;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private boolean enabled;

	@DAOManaged
	@OneToMany
	@XMLElement(fixCase = true)
	private List<RandomBookingNumber> numbers;

	@DAOManaged
	@OneToMany
	private List<RandomBookingIntervalMapping> mappings;

	@Override
	public String toString() {

		return "(intervalID=" + intervalID + ", name=" + name + ")";
	}

	public Integer getIntervalID() {

		return intervalID;
	}

	public void setIntervalID(Integer intervalID) {

		this.intervalID = intervalID;
	}

	public String getName() {

		return name;
	}

	public void setName(String name) {

		this.name = name;
	}

	public boolean isEnabled() {

		return enabled;
	}

	public void setEnabled(boolean enabled) {

		this.enabled = enabled;
	}

	public List<RandomBookingNumber> getNumbers() {

		return numbers;
	}

	public void setNumbers(List<RandomBookingNumber> numbers) {

		this.numbers = numbers;
	}

	public List<RandomBookingIntervalMapping> getMappings() {

		return mappings;
	}

	public void setMappings(List<RandomBookingIntervalMapping> mappings) {

		this.mappings = mappings;
	}

	@Override
	public int hashCode() {

		return Objects.hash(intervalID);
	}

	@Override
	public boolean equals(Object obj) {

		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		RandomBookingInterval other = (RandomBookingInterval) obj;
		return Objects.equals(intervalID, other.intervalID);
	}

}
