<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:exsl="http://exslt.org/common">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/CKEditor.xsl"/>

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
		/jquery/jquery-migrate.js?v=1
		/ckeditor/ckeditor.js
		/ckeditor/adapters/jquery.js
		/ckeditor/init.js
	</xsl:variable>

	<xsl:template match="Document">
	
		<xsl:apply-templates select="ShowRandomEventSettings" />
		<xsl:apply-templates select="UpdateRandomEventSettings" />
			
	</xsl:template>
	
	<xsl:template match="ShowRandomEventSettings">
	
		<a name="randomeventsettings" />
		
		<xsl:choose>
			<xsl:when test="RandomEventSettings">
					
				<xsl:value-of select="$i18n.RandomEventsEnabled"/>
				<xsl:text>:&#x20;</xsl:text>
				
				<xsl:choose>
					<xsl:when test="RandomEventSettings/enabled = 'true'">
						<xsl:value-of select="$i18n.Yes"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$i18n.No"/>
					</xsl:otherwise>
				</xsl:choose>
				
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$i18n.NoRandomEventSettings" />
			</xsl:otherwise>
		</xsl:choose>
		
		<a href="{/Document/ModuleURI}/update/{Flow/flowID}" class="floatright">
			<xsl:value-of select="$i18n.UpdateRandomEventSettings" />
			<img class="alignbottom" src="{/Document/StaticContentURL}/pics/pen.png" alt="" />
		</a>
		
		<xsl:if test="RandomEventSettings">
			<a href="{/Document/ModuleURI}/delete/{Flow/flowID}" class="floatright clearboth" onclick="return confirm('{$i18n.DeleteRandomEventSettings.Confirm}');">
				<xsl:value-of select="$i18n.DeleteRandomEventSettings" />
				<img class="alignbottom" src="{/Document/StaticContentURL}/pics/delete.png" alt="" />
			</a>		
		</xsl:if>
	
	</xsl:template>
	
	<xsl:template match="UpdateRandomEventSettings">
		
		<div id="RandomEventGenerator" class="contentitem errands-wrapper border-box">
		
			<h1>
				<xsl:value-of select="$i18n.UpdateRandomEventSettingsTitle"/>
				<xsl:text>:&#x20;</xsl:text>
				<xsl:value-of select="Flow/name"/>
				<xsl:text>&#x20;(</xsl:text>
				<xsl:value-of select="$i18n.flowVersion"/>
				<xsl:text>&#x20;</xsl:text>
				<xsl:value-of select="Flow/version"/>
				<xsl:text>)</xsl:text>
			</h1>
	
			<xsl:apply-templates select="validationException/validationError"/>
	
			<form method="post" action="{/Document/ModuleURI}/update/{Flow/flowID}">
			
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="name" select="'enabled'" />
						<xsl:with-param name="id" select="'enabled'" />
						<xsl:with-param name="element" select="RandomEventSettings" />       
					</xsl:call-template>
					
					<label for="enabled">
						<xsl:value-of select="$i18n.Enabled" />
					</label>
				</div>
				
				<label for="chance" class="floatleft full">
					<xsl:value-of select="$i18n.Chance" />
				</label>				
				
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'chance'"/>
						<xsl:with-param name="name" select="'chance'"/>
						<xsl:with-param name="element" select="RandomEventSettings" />          
					</xsl:call-template>
				</div>
				
				<label for="eventDescription" class="floatleft full">
					<xsl:value-of select="$i18n.EventDescription" />
				</label>				
				
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'eventDescription'"/>
						<xsl:with-param name="name" select="'eventDescription'"/>
						<xsl:with-param name="element" select="RandomEventSettings" />          
					</xsl:call-template>
				</div>	
			
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="name" select="'addExternalMessage'" />
						<xsl:with-param name="id" select="'addExternalMessage'" />
						<xsl:with-param name="element" select="RandomEventSettings" />       
					</xsl:call-template>
					
					<label for="addExternalMessage">
						<xsl:value-of select="$i18n.AddExternalMessage" />
					</label>
				</div>			
			
				<label for="externalMessageText" class="floatleft full">
					<xsl:value-of select="$i18n.ExternalMessageText" />
				</label>				
				
				<div class="floatleft full">
					<xsl:call-template name="createTextArea">
						<xsl:with-param name="id" select="'externalMessageText'"/>
						<xsl:with-param name="name" select="'externalMessageText'"/>
						<xsl:with-param name="element" select="RandomEventSettings" />          
					</xsl:call-template>
				</div>			
			
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="name" select="'overrideSubmittedMessage'" />
						<xsl:with-param name="id" select="'overrideSubmittedMessage'" />
						<xsl:with-param name="element" select="RandomEventSettings" />       
					</xsl:call-template>
					
					<label for="overrideSubmittedMessage">
						<xsl:value-of select="$i18n.OverrideSubmittedMessage" />
					</label>
				</div>			

				<label for="submittedMessageHeading" class="floatleft full">
					<xsl:value-of select="$i18n.SubmittedMessageHeading" />
				</label>				
				
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'submittedMessageHeading'"/>
						<xsl:with-param name="name" select="'submittedMessageHeading'"/>
						<xsl:with-param name="element" select="RandomEventSettings" />          
					</xsl:call-template>
				</div>	
			
				<label for="submittedMessageText" class="floatleft full">
					<xsl:value-of select="$i18n.SubmittedMessageText" />
				</label>				
				
				<div class="floatleft full">
					<xsl:call-template name="createTextArea">
						<xsl:with-param name="id" select="'submittedMessageText'"/>
						<xsl:with-param name="name" select="'submittedMessageText'"/>
						<xsl:with-param name="class" select="'flow-ckeditor'"/>
						<xsl:with-param name="element" select="RandomEventSettings" />          
					</xsl:call-template>
				</div>			

				<xsl:call-template name="initializeFCKEditor">
					<xsl:with-param name="basePath"><xsl:value-of select="/Document/requestinfo/contextpath"/>/static/f/<xsl:value-of select="/Document/module/sectionID"/>/<xsl:value-of select="/Document/module/moduleID"/>/ckeditor/</xsl:with-param>
					<xsl:with-param name="customConfig">config.js</xsl:with-param>
					<xsl:with-param name="editorContainerClass">flow-ckeditor</xsl:with-param>
					<xsl:with-param name="editorHeight">150</xsl:with-param>
					
					<xsl:with-param name="contentsCss">
						<xsl:if test="cssPath">
							<xsl:value-of select="cssPath"/>
						</xsl:if>
					</xsl:with-param>
					
				</xsl:call-template>




				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="name" select="'setAsAttribute'" />
						<xsl:with-param name="id" select="'setAsAttribute'" />
						<xsl:with-param name="element" select="RandomEventSettings" />       
					</xsl:call-template>
					
					<label for="setAsAttribute">
						<xsl:value-of select="$i18n.SetAsAttribute" />
					</label>
				</div>			
			
				<label for="attributeName" class="floatleft full">
					<xsl:value-of select="$i18n.AttributeName" />
				</label>				
				
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'attributeName'"/>
						<xsl:with-param name="name" select="'attributeName'"/>
						<xsl:with-param name="element" select="RandomEventSettings" />          
					</xsl:call-template>
				</div>		
			
				<label for="attributeValue" class="floatleft full">
					<xsl:value-of select="$i18n.AttributeValue" />
				</label>				
				
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'attributeValue'"/>
						<xsl:with-param name="name" select="'attributeValue'"/>
						<xsl:with-param name="element" select="RandomEventSettings" />          
					</xsl:call-template>
				</div>
				
				<div class="floatright clearboth bigmargintop">
					<input type="submit" value="{$i18n.SaveChanges}" />
				</div>
			
			</form>
		
		</div>

	</xsl:template>
	
	<xsl:template match="validationError">
		<xsl:if test="fieldName and validationErrorType and not(messageKey)">
			<p class="error">
				<xsl:choose>
					<xsl:when test="validationErrorType='RequiredField'">
						<xsl:value-of select="$i18n.validation.requiredField" />
					</xsl:when>
					<xsl:when test="validationErrorType='InvalidFormat'">
						<xsl:value-of select="$i18n.validation.invalidFormat" />
					</xsl:when>
					<xsl:when test="validationErrorType='TooShort'">
						<xsl:value-of select="$i18n.validation.tooShort" />
					</xsl:when>
					<xsl:when test="validationErrorType='TooLong'">
						<xsl:value-of select="$i18n.validation.tooLong" />
					</xsl:when>														
					<xsl:otherwise>
						<xsl:value-of select="$i18n.validation.unknownError" />
					</xsl:otherwise>
				</xsl:choose>
				
				<xsl:text>&#x20;</xsl:text>
				
				<xsl:choose>
					<xsl:when test="displayName">
						<xsl:value-of select="displayName"/>
					</xsl:when>
					<xsl:when test="fieldName = 'chance'">
						<xsl:value-of select="$i18n.Chance"/>
					</xsl:when>
					<xsl:when test="fieldName = 'eventDescription'">
						<xsl:value-of select="$i18n.EventDescription"/>
					</xsl:when>
					<xsl:when test="fieldName = 'addExternalMessage'">
						<xsl:value-of select="$i18n.AddExternalMessage"/>
					</xsl:when>
					<xsl:when test="fieldName = 'externalMessageText'">
						<xsl:value-of select="$i18n.ExternalMessageText"/>
					</xsl:when>
					<xsl:when test="fieldName = 'overrideSubmittedMessage'">
						<xsl:value-of select="$i18n.OverrideSubmittedMessage"/>
					</xsl:when>
					<xsl:when test="fieldName = 'submittedMessageHeading'">
						<xsl:value-of select="$i18n.SubmittedMessageHeading"/>
					</xsl:when>
					<xsl:when test="fieldName = 'submittedMessageText'">
						<xsl:value-of select="$i18n.SubmittedMessageText"/>
					</xsl:when>
					<xsl:when test="fieldName = 'setAsAttribute'">
						<xsl:value-of select="$i18n.SetAsAttribute"/>
					</xsl:when>
					<xsl:when test="fieldName = 'attributeName'">
						<xsl:value-of select="$i18n.AttributeName"/>
					</xsl:when>
					<xsl:when test="fieldName = 'attributeValue'">
						<xsl:value-of select="$i18n.AttributeValue"/>
					</xsl:when>								
					<xsl:otherwise>
						<xsl:value-of select="fieldName"/>
					</xsl:otherwise>
				</xsl:choose>			
			</p>
		</xsl:if>
		
		<xsl:if test="messageKey">
			<p class="error">
				<xsl:value-of select="$i18n.validation.unknownFault" />
			</p>
		</xsl:if>
		
	</xsl:template>	
	
</xsl:stylesheet>