<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:exsl="http://exslt.org/common">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1"/>

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
		/jquery/jquery-migrate.js?v=1
		/jquery/jquery-ui.js?v=1
		/ckeditor/ckeditor.js
		/ckeditor/adapters/jquery.js
		/ckeditor/init.js
		/featherlight/js/featherlight.min.js
	</xsl:variable>	

	<xsl:variable name="globallinks">
		/featherlight/css/featherlight.min.css?v=1
	</xsl:variable>	

	<xsl:variable name="scripts">
		/js/ratingscalequeryadmin.js
		/common/js/queryadmin.js
	</xsl:variable>
	
	<xsl:template match="Document">	
		
		<div id="RatingScaleQueryProvider" class="contentitem">
		
			<xsl:apply-templates select="validationError"/>
			<xsl:apply-templates select="UpdateRatingScaleQuery"/>
		
		</div>
		
	</xsl:template>
		
	<xsl:template match="UpdateRatingScaleQuery">
	
		<h1><xsl:value-of select="$i18n.UpdateQuery" /><xsl:text>:&#160;</xsl:text><xsl:value-of select="RatingScaleQuery/QueryDescriptor/name" /></h1>
		
		<xsl:apply-templates select="validationException/validationError" />
		
		<form id="updateRatingScaleQueryForm" name="queryAdminForm" method="post" action="{/Document/requestinfo/uri}">
		
			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="RatingScaleQuery" />
			</xsl:call-template>
			
			<xsl:call-template name="createAlternativesForm">
				<xsl:with-param name="alternatives" select="RatingScaleQuery/Alternatives/RatingScaleAlternative" />
				<xsl:with-param name="editExtraValues" select="'true'" />
				<xsl:with-param name="allowFreeTextAlternative" select="'false'" />
			</xsl:call-template>
			
			<div class="floatleft full bigmarginbottom">
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'hideAlternativeLabels'" />
						<xsl:with-param name="name" select="'hideAlternativeLabels'" />
						<xsl:with-param name="element" select="RatingScaleQuery" /> 
						<xsl:with-param name="class" select="'vertical-align-middle'" />
					</xsl:call-template>
						
					<label for="hideAlternativeLabels">
						<xsl:value-of select="$i18n.HideAlternativeLabels" />
					</label>
			    </div>
			</div>			
			
			<div class="floatleft full bigmarginbottom">
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'hideEdgeLabels'" />
						<xsl:with-param name="name" select="'hideEdgeLabels'" />
						<xsl:with-param name="element" select="RatingScaleQuery" /> 
						<xsl:with-param name="class" select="'vertical-align-middle'" />
					</xsl:call-template>
						
					<label for="hideEdgeLabels">
						<xsl:value-of select="$i18n.HideEdgeLabels" />
					</label>
			    </div>
			</div>
						
			<div id="edgeLabels" class="floatleft full bigmarginbottom">
				<label for="smallestValueLabel" class="floatleft clearboth"><xsl:value-of select="$i18n.SmallestValueLabel" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'smallestValueLabel'"/>
						<xsl:with-param name="name" select="'smallestValueLabel'"/>
						<xsl:with-param name="title" select="$i18n.SmallestValueLabel"/>
						<xsl:with-param name="element" select="RatingScaleQuery" />
						<xsl:with-param name="maxlength" select="'50'"/>
					</xsl:call-template>
			    </div>
			    
				<label for="largestValueLabel" class="floatleft clearboth"><xsl:value-of select="$i18n.LargestValueLabel" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'largestValueLabel'"/>
						<xsl:with-param name="name" select="'largestValueLabel'"/>
						<xsl:with-param name="title" select="$i18n.LargestValueLabel"/>
						<xsl:with-param name="element" select="RatingScaleQuery" />
						<xsl:with-param name="maxlength" select="'50'"/>
					</xsl:call-template>
			    </div>
			</div>
			
			<div class="floatleft full bigmargintop bigmarginbottom">
				<h2><xsl:value-of select="$i18n.AdvancedSettings" /></h2>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'setAsAttribute'" />
						<xsl:with-param name="name" select="'setAsAttribute'" />
						<xsl:with-param name="element" select="RatingScaleQuery" /> 
						<xsl:with-param name="class" select="'vertical-align-middle'" />
					</xsl:call-template>
						
					<label for="setAsAttribute">
						<xsl:value-of select="$i18n.setAsAttribute" />
					</label>
			    </div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="attributeName" class="floatleft clearboth"><xsl:value-of select="$i18n.attributeName" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'attributeName'"/>
						<xsl:with-param name="name" select="'attributeName'"/>
						<xsl:with-param name="title" select="$i18n.attributeName"/>
						<xsl:with-param name="element" select="RatingScaleQuery" />
						<xsl:with-param name="maxlength" select="'255'"/>
					</xsl:call-template>
			    </div>
			</div>
				
			<div class="floatleft full bigmarginbottom">

				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'hideTitle'" />
						<xsl:with-param name="name" select="'hideTitle'" />
						<xsl:with-param name="value" select="'true'" />
						<xsl:with-param name="element" select="RatingScaleQuery" />
					</xsl:call-template>
					
					<label for="hideTitle">
						<xsl:value-of select="$i18n.HideTitle" />
					</label>
				</div>

			</div>				
				
			<div class="floatright margintop clearboth">
				<input type="submit" value="{$i18n.SaveChanges}" />
			</div>
		
		</form>
		
	</xsl:template>
	
	<xsl:template match="RatingScaleAlternative">
		
		<xsl:call-template name="createAlternative">
			<xsl:with-param name="alternativeID" select="alternativeID" />
			<xsl:with-param name="sortOrder" select="sortIndex" />
			<xsl:with-param name="value" select="name" />
			<xsl:with-param name="xmlValue" select="xmlValue" />
			<xsl:with-param name="attributeValue" select="attributeValue" />
			<xsl:with-param name="editExtraValues" select="'true'" />
		</xsl:call-template>
			
	</xsl:template>

	<xsl:template match="validationError[messageKey = 'UpdateFailedRatingScaleQueryNotFound']">
		
		<p class="error">
			<xsl:value-of select="$i18n.RatingScaleQueryNotFound" />
		</p>
		
	</xsl:template>

	<xsl:template match="fieldName">
	
		<xsl:variable name="fieldName" select="." />
	
		<xsl:choose>
			<xsl:when test="$fieldName = 'attributeName'">
				<xsl:value-of select="$i18n.attributeName" />
			</xsl:when>
			<xsl:when test="$fieldName = 'smallestValueLabel'">
				<xsl:value-of select="$i18n.SmallestValueLabel" />
			</xsl:when>
			<xsl:when test="$fieldName = 'largestValueLabel'">
				<xsl:value-of select="$i18n.LargestValueLabel" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>
		
	</xsl:template>

</xsl:stylesheet>