<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
		/jquery/jquery-migrate.js?v=1
		/jquery/jquery-ui.js?v=1
		/js/confirmpost.js
	</xsl:variable>
	
	<xsl:variable name="globallinks">
		/css/openhierarchy-jquery-ui.css
	</xsl:variable>
	
	<xsl:variable name="scripts">
		/js/datatables.min.js
		/js/reservationmodule.js
	</xsl:variable>
	
	<xsl:variable name="links">
		/css/datatables.css
		/css/reservationmodule.css
	</xsl:variable>
	
	<xsl:template match="Document">
	
		<xsl:apply-templates select="ListReservations"/>
			
	</xsl:template>
	
	<xsl:template match="ListReservations">
	
		<script>
			i18nReservationModule.EMPTY_TABLE = '<xsl:value-of select="$i18n.EmptyTable"/>';
			i18nReservationModule.NEXT = '<xsl:value-of select="$i18n.Next"/>';
			i18nReservationModule.PREVIOUS =  '<xsl:value-of select="$i18n.Previous"/>';
			i18nReservationModule.DELETE =  '<xsl:value-of select="$i18n.Delete"/>';
			i18nReservationModule.CONFIRM_DELETE =  '<xsl:value-of select="$i18n.ConfirmDelete"/>';
			i18nReservationModule.SEARCH =  '<xsl:value-of select="$i18n.Search"/>';
			i18nReservationModule.ZERO_RECORDS =  '<xsl:value-of select="$i18n.ZeroRecords"/>';
			i18nReservationModule.LENGTH_MENU = '<xsl:value-of select="$i18n.LengthMenu"/>';
			i18nReservationModule.INFO = '<xsl:value-of select="$i18n.DataTable.info"/>';
			i18nReservationModule.INFO_EMPTY = '<xsl:value-of select="$i18n.DataTable.infoEmpty"/>';
			i18nReservationModule.INFO_FILTERED = '<xsl:value-of select="$i18n.DataTable.infoFiltered"/>';
			i18nReservationModule.FETCH_ERROR = '<xsl:value-of select="$i18n.DataTable.fetchError"/>';
			i18nReservationModule.LOADING_RECORDS = '<xsl:value-of select="$i18n.DataTable.loadingRecords"/>';
		</script>
	
		<div id="ReservationModule">
			<div class="contentitem">
				<h1>
					<xsl:value-of select="$i18n.ListReservations"/>
				</h1>
				
				<table id="reservations" class="full stripe display" data-reservations-url="{/Document/ModuleURI}/reservations" data-delete-url="{/Document/ModuleURI}/reservation/$reservationID/delete/">
					<thead>
						<tr class="nowrap">
							<th><xsl:value-of select="$i18n.ReservationID"/></th>
							<th><xsl:value-of select="$i18n.ObjectID"/></th>
							<th><xsl:value-of select="$i18n.FlowFamilyID"/></th>
							<th><xsl:value-of select="$i18n.FlowInstanceID"/></th>
							<th><xsl:value-of select="$i18n.Added"/></th>
							<th><xsl:value-of select="$i18n.Expires"/></th>
							<th><!-- delete --></th>
						</tr>
					</thead>
				</table>
			</div>
		</div>
		
	</xsl:template>
	
<!-- 	<xsl:template match="validationError"> -->
<!-- 		<xsl:if test="fieldName and validationErrorType and not(messageKey)"> -->
<!-- 			<p class="error"> -->
<!-- 				<xsl:choose> -->
<!-- 					<xsl:when test="validationErrorType='RequiredField'"> -->
<!-- 						<xsl:value-of select="$i18n.validation.requiredField" /> -->
<!-- 					</xsl:when> -->
<!-- 					<xsl:when test="validationErrorType='InvalidFormat'"> -->
<!-- 						<xsl:value-of select="$i18n.validation.invalidFormat" /> -->
<!-- 					</xsl:when> -->
<!-- 					<xsl:when test="validationErrorType='TooShort'"> -->
<!-- 						<xsl:value-of select="$i18n.validation.tooShort" /> -->
<!-- 					</xsl:when> -->
<!-- 					<xsl:when test="validationErrorType='TooLong'"> -->
<!-- 						<xsl:value-of select="$i18n.validation.tooLong" /> -->
<!-- 					</xsl:when> -->
<!-- 					<xsl:otherwise> -->
<!-- 						<xsl:value-of select="$i18n.validation.unknownError" /> -->
<!-- 					</xsl:otherwise> -->
<!-- 				</xsl:choose> -->
				
<!-- 				<xsl:text>&#x20;</xsl:text> -->
				
<!-- 				<xsl:choose> -->
<!-- 					<xsl:when test="fieldName = 'confirm'"> -->
<!-- 						<xsl:value-of select="$i18n.AutomaticReservation.confirm" /> -->
<!-- 					</xsl:when> -->
<!-- 					<xsl:otherwise> -->
<!-- 						<xsl:value-of select="fieldName"/> -->
<!-- 					</xsl:otherwise> -->
<!-- 				</xsl:choose> -->
<!-- 			</p> -->
<!-- 		</xsl:if> -->
		
<!-- 		<xsl:if test="messageKey"> -->
<!-- 			<p class="error"> -->
<!-- 				<xsl:choose> -->
<!-- 					<xsl:when test="messageKey='DummyKey'"> -->
<!-- 					</xsl:when> -->
<!-- 					<xsl:otherwise> -->
<!-- 							<xsl:value-of select="$i18n.validation.unknownFault" /> -->
<!-- 					</xsl:otherwise> -->
<!-- 				</xsl:choose> -->
<!-- 			</p> -->
<!-- 		</xsl:if> -->
		
<!-- 	</xsl:template> -->
	
</xsl:stylesheet>