package com.nordicpeak.flowengine.restrictedflowadmin;

import java.sql.SQLException;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.sql.DataSource;

import se.unlogic.hierarchy.core.annotations.InstanceManagerDependency;
import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.hierarchy.core.exceptions.ModuleConfigurationException;
import se.unlogic.hierarchy.core.interfaces.ForegroundModuleResponse;
import se.unlogic.hierarchy.core.interfaces.SectionInterface;
import se.unlogic.hierarchy.core.interfaces.modules.descriptors.ForegroundModuleDescriptor;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.webutils.http.URIParser;

import com.nordicpeak.flowengine.FlowInstanceAdminModule;
import com.nordicpeak.flowengine.beans.Flow;
import com.nordicpeak.flowengine.interfaces.FlowInstanceAccessController;
import com.nordicpeak.flowengine.interfaces.ImmutableFlowFamily;
import com.nordicpeak.flowengine.managerflowtest.ManagerFlowTestModule;

public class RestrictedFlowAdminFlowTestModule extends ManagerFlowTestModule {
	
	@InstanceManagerDependency(required = true)
	protected RestrictedFlowAdminModule restrictedFlowAdminModule;
	
	@Override
	public void init(ForegroundModuleDescriptor moduleDescriptor, SectionInterface sectionInterface, DataSource dataSource) throws Exception {
		super.init(moduleDescriptor, sectionInterface, dataSource);
		
		if (!systemInterface.getInstanceHandler().addInstance(RestrictedFlowAdminFlowTestModule.class, this)) {
			
			throw new RuntimeException("Unable to register module in global instance handler using key " + RestrictedFlowAdminFlowTestModule.class.getSimpleName() + ", another instance is already registered using this key.");
		}
	}
	
	@Override
	public void unload() throws Exception {
		
		systemInterface.getInstanceHandler().removeInstance(RestrictedFlowAdminFlowTestModule.class, this);
		
		super.unload();
	}
	
	@Override
	@InstanceManagerDependency
	public void setFlowInstanceAdminModule(FlowInstanceAdminModule flowInstanceAdminModule) {
		
	}
	
	@Override
	public ForegroundModuleResponse list(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser, List<ValidationError> validationErrors) throws ModuleConfigurationException, SQLException {
		
		return restrictedFlowAdminModule.list(req, res, user, uriParser, validationErrors);
	}
	
	@Override
	public ForegroundModuleResponse showFlowFamily(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser, ValidationError validationError) throws Throwable {
		
		return restrictedFlowAdminModule.list(req, res, user, uriParser, validationError);
	}
	
	@Override
	protected boolean hasAccess(User user, ImmutableFlowFamily flowFamily) {
		
		if (!super.hasAccess(user, flowFamily)) {

			for (Flow flow : flowAdminModule.getCachedFlows()) {

				if (flow.getFlowFamily().getFlowFamilyID().equals(flowFamily.getFlowFamilyID())) {
					
					if (restrictedFlowAdminModule.hasFlowAccess(user, flow)) {
						return true;
					}
				}
			}
			
			return false;
		}
		
		return true;
	}
	
	@Override
	protected FlowInstanceAccessController getAccessController(User user) {
		
		return new RestrictedFlowAdminAccessController(true, restrictedFlowAdminModule);
	}
	
	@Override
	protected FlowInstanceAccessController getSubmittedAccessController(User user) {
		
		return new RestrictedFlowAdminAccessController(true, restrictedFlowAdminModule);
	}
}
