<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1"/>

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
		/jquery/jquery-migrate.js?v=1
		/ckeditor/ckeditor.js
		/ckeditor/adapters/jquery.js
		/ckeditor/init.js
	</xsl:variable>	

	<xsl:template match="Document">	
		
		<div id="CompanyDetailsQueryProvider" class="contentitem">
		
			<xsl:apply-templates select="validationError"/>
			<xsl:apply-templates select="UpdateCompanyDetailsQuery"/>
		
		</div>
		
	</xsl:template>
		
	<xsl:template match="UpdateCompanyDetailsQuery">
	
		<h1><xsl:value-of select="$i18n.UpdateQuery" /><xsl:text>:&#160;</xsl:text><xsl:value-of select="CompanyDetailsQuery/QueryDescriptor/name" /></h1>
		
		<xsl:apply-templates select="validationException/validationError" />
		
		<form id="updateCompanyDetailsQueryForm" name="queryAdminForm" method="post" action="{/Document/requestinfo/uri}">
		
			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="CompanyDetailsQuery" />
			</xsl:call-template>
			
			<div class="floatleft clearboth bigmargintop">
				<h2><xsl:value-of select="$i18n.TargetEnvironment.Title" /></h2>
				<p class="nomargin marginbottom"><xsl:value-of select="$i18n.TargetEnvironment.Description" /></p>
			</div>
			
			<div class="floatleft full">
				<xsl:call-template name="createRadio">
					<xsl:with-param name="id" select="'TEST'"/>
					<xsl:with-param name="name" select="'targetEnvironment'"/>
					<xsl:with-param name="value" select="'TEST'"/>
					<xsl:with-param name="element" select="CompanyDetailsQuery" />
				</xsl:call-template>
				
				<label for="TEST">
					<xsl:value-of select="$i18n.TEST" />
				</label>
			</div>
			
			<div class="floatleft full">
				<xsl:call-template name="createRadio">
					<xsl:with-param name="id" select="'ACCEPTANCE'"/>
					<xsl:with-param name="name" select="'targetEnvironment'"/>
					<xsl:with-param name="value" select="'ACCEPTANCE'"/>
					<xsl:with-param name="element" select="CompanyDetailsQuery" />
				</xsl:call-template>
				
				<label for="ACCEPTANCE">
					<xsl:value-of select="$i18n.ACCEPTANCE" />
				</label>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<xsl:call-template name="createRadio">
					<xsl:with-param name="id" select="'PRODUCTION'"/>
					<xsl:with-param name="name" select="'targetEnvironment'"/>
					<xsl:with-param name="value" select="'PRODUCTION'"/>
					<xsl:with-param name="element" select="CompanyDetailsQuery" />
				</xsl:call-template>
				
				<label for="PRODUCTION">
					<xsl:value-of select="$i18n.PRODUCTION" />
				</label>
			</div>

			<div class="floatleft clearboth bigmargintop">
				<h2><xsl:value-of select="$i18n.ServiceName.Title" /></h2>
				<p class="nomargin marginbottom"><xsl:value-of select="$i18n.ServiceName.Description" /></p>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="name" class="floatleft clearboth"><xsl:value-of select="$i18n.ServiceName" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'serviceName'"/>
						<xsl:with-param name="name" select="'serviceName'"/>
						<xsl:with-param name="title" select="$i18n.ServiceName"/>
						<xsl:with-param name="element" select="CompanyDetailsQuery" />
					</xsl:call-template>
				</div>
			</div>
			
			<div class="floatleft clearboth bigmargintop">
				<h2><xsl:value-of select="$i18n.CompanyTypeSelection.Title" /></h2>
				<p class="nomargin marginbottom"><xsl:value-of select="$i18n.CompanyTypeSelection.Description" /></p>
			</div>
			
			<div class="floatleft full">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'AB'"/>
					<xsl:with-param name="name" select="'companyTypes'"/>
					<xsl:with-param name="value" select="'AB'"/>
					<xsl:with-param name="element" select="CompanyDetailsQuery/companyTypes" />
					<xsl:with-param name="elementName" select="'value'" />
				</xsl:call-template>
				
				<label for="AB">
					<xsl:value-of select="$i18n.AB" />
				</label>
			</div>
			
			<div class="floatleft full">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'BRF'"/>
					<xsl:with-param name="name" select="'companyTypes'"/>
					<xsl:with-param name="value" select="'BRF'"/>
					<xsl:with-param name="element" select="CompanyDetailsQuery/companyTypes" />
					<xsl:with-param name="elementName" select="'value'" />
				</xsl:call-template>
				
				<label for="BRF">
					<xsl:value-of select="$i18n.BRF" />
				</label>
			</div>
			
			<div class="floatleft full">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'E'"/>
					<xsl:with-param name="name" select="'companyTypes'"/>
					<xsl:with-param name="value" select="'E'"/>
					<xsl:with-param name="element" select="CompanyDetailsQuery/companyTypes" />
					<xsl:with-param name="elementName" select="'value'" />
				</xsl:call-template>
				
				<label for="E">
					<xsl:value-of select="$i18n.E" />
				</label>
			</div>
			
			<div class="floatleft full">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'EK'"/>
					<xsl:with-param name="name" select="'companyTypes'"/>
					<xsl:with-param name="value" select="'EK'"/>
					<xsl:with-param name="element" select="CompanyDetailsQuery/companyTypes" />
					<xsl:with-param name="elementName" select="'value'" />
				</xsl:call-template>
				
				<label for="EK">
					<xsl:value-of select="$i18n.EK" />
				</label>
			</div>
			
			<div class="floatleft full">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'HB'"/>
					<xsl:with-param name="name" select="'companyTypes'"/>
					<xsl:with-param name="value" select="'HB'"/>
					<xsl:with-param name="element" select="CompanyDetailsQuery/companyTypes" />
					<xsl:with-param name="elementName" select="'value'" />
				</xsl:call-template>
				
				<label for="HB">
					<xsl:value-of select="$i18n.HB" />
				</label>
			</div>
			
			<div class="floatleft full  bigmarginbottom">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'KB'"/>
					<xsl:with-param name="name" select="'companyTypes'"/>
					<xsl:with-param name="value" select="'KB'"/>
					<xsl:with-param name="element" select="CompanyDetailsQuery/companyTypes" />
					<xsl:with-param name="elementName" select="'value'" />
				</xsl:call-template>
				
				<label for="KB">
					<xsl:value-of select="$i18n.KB" />
				</label>
			</div>
			
			<div class="floatleft clearboth bigmargintop">
				<h2><xsl:value-of select="$i18n.CompanyTypeDescription.Title" /></h2>
			</div>
			
			<div class="floatleft full">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'showCompanyTypeDescription'"/>
					<xsl:with-param name="name" select="'showCompanyTypeDescription'"/>
					<xsl:with-param name="value" select="'true'"/>
					<xsl:with-param name="element" select="CompanyDetailsQuery" />
				</xsl:call-template>
				
				<label for="showCompanyTypeDescription">
					<xsl:value-of select="$i18n.ShowCompanyTypeDescription" />
				</label>
			</div>
			
			<div class="floatleft full">
				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'showCompaniesAsRadiosAndKeepShowing'"/>
					<xsl:with-param name="name" select="'showCompaniesAsRadiosAndKeepShowing'"/>
					<xsl:with-param name="value" select="'true'"/>
					<xsl:with-param name="element" select="CompanyDetailsQuery" />
				</xsl:call-template>
				
				<label for="showCompaniesAsRadiosAndKeepShowing">
					<xsl:value-of select="$i18n.showCompaniesAsRadiosAndKeepShowing" />
				</label>
				
				<p class="nomargin marginbottom">
					<xsl:value-of select="$i18n.showCompaniesAsRadiosAndKeepShowing.description" />
				</p>
			</div>
			
			<div class="floatleft clearboth bigmargintop">
				<h2><xsl:value-of select="$i18n.UDSelection.Title" /></h2>
				<p class="nomargin marginbottom"><xsl:value-of select="$i18n.UDSelection.Description" /></p>
			</div>
			
			<table class="full floatleft coloredtable oep-table">
				<thead>
					<tr>
						<th><xsl:value-of select="$i18n.UDName"/></th>
						<th><xsl:value-of select="$i18n.UDSource"/></th>
					</tr>
				</thead>
			
				<tbody>
<!-- 					<tr>
						<td class="nowrap">
							<xsl:call-template name="createCheckbox">
								<xsl:with-param name="id" select="'useUD0001'" />
								<xsl:with-param name="name" select="'useUD0001'" />
								<xsl:with-param name="value" select="'true'" />
								<xsl:with-param name="element" select="CompanyDetailsQuery" />
							</xsl:call-template>
							<label for="useUD0001"><xsl:value-of select="$i18n.UseUD0001" /></label>
						</td>
						<td>
							<xsl:value-of select="$i18n.Source.Bolagsverket" />
						</td>
					</tr> -->
				
					<tr>
						<td class="nowrap">
							<xsl:call-template name="createCheckbox">
								<xsl:with-param name="id" select="'useUD0003'" />
								<xsl:with-param name="name" select="'useUD0003'" />
								<xsl:with-param name="value" select="'true'" />
								<xsl:with-param name="element" select="CompanyDetailsQuery" />
							</xsl:call-template>
							<label for="useUD0003"><xsl:value-of select="$i18n.UseUD0003" /></label>
						</td>
						<td>
							<xsl:value-of select="$i18n.Source.Bolagsverket" />
						</td>
					</tr>
					
					<tr>
						<td class="nowrap">
							<xsl:call-template name="createCheckbox">
								<xsl:with-param name="id" select="'useUD0004'" />
								<xsl:with-param name="name" select="'useUD0004'" />
								<xsl:with-param name="value" select="'true'" />
								<xsl:with-param name="element" select="CompanyDetailsQuery" />
							</xsl:call-template>
							<label for="useUD0004"><xsl:value-of select="$i18n.UseUD0004" /></label>
						</td>
						<td>
							<xsl:value-of select="$i18n.Source.Bolagsverket" />
						</td>
					</tr>
					
					<tr>
						<td class="nowrap">
							<xsl:call-template name="createCheckbox">
								<xsl:with-param name="id" select="'useUD0006'" />
								<xsl:with-param name="name" select="'useUD0006'" />
								<xsl:with-param name="value" select="'true'" />
								<xsl:with-param name="element" select="CompanyDetailsQuery" />
							</xsl:call-template>
							<label for="useUD0006"><xsl:value-of select="$i18n.UseUD0006" /></label>
						</td>
						<td>
							<xsl:value-of select="$i18n.Source.Bolagsverket" />
						</td>
					</tr>
					
					<tr>
						<td class="nowrap">
							<xsl:call-template name="createCheckbox">
								<xsl:with-param name="id" select="'useUD0023'" />
								<xsl:with-param name="name" select="'useUD0023'" />
								<xsl:with-param name="value" select="'true'" />
								<xsl:with-param name="element" select="CompanyDetailsQuery" />
							</xsl:call-template>
							<label for="useUD0023"><xsl:value-of select="$i18n.UseUD0023" /></label>
						</td>
						<td>
							<xsl:value-of select="$i18n.Source.Skatteverket" />
						</td>
					</tr>
					
<!--  					<tr>
						<td class="nowrap">
							<xsl:call-template name="createCheckbox">
								<xsl:with-param name="id" select="'useUD0025'" />
								<xsl:with-param name="name" select="'useUD0025'" />
								<xsl:with-param name="value" select="'true'" />
								<xsl:with-param name="element" select="CompanyDetailsQuery" />
							</xsl:call-template>
							<label for="useUD0025"><xsl:value-of select="$i18n.UseUD0025" /></label>
						</td>
						<td>
							<xsl:value-of select="$i18n.Source.Bolagsverket" />
						</td>
					</tr> -->					
					
					<tr>
						<td class="nowrap">
							<xsl:call-template name="createCheckbox">
								<xsl:with-param name="id" select="'useUD0045'" />
								<xsl:with-param name="name" select="'useUD0045'" />
								<xsl:with-param name="value" select="'true'" />
								<xsl:with-param name="element" select="CompanyDetailsQuery" />
							</xsl:call-template>
							<label for="useUD0045"><xsl:value-of select="$i18n.UseUD0045" /></label>
						</td>
						<td>
							<xsl:value-of select="$i18n.Source.Bolagsverket" />
						</td>
					</tr>
					
					<tr>
						<td class="nowrap">
							<xsl:call-template name="createCheckbox">
								<xsl:with-param name="id" select="'useUD0046'" />
								<xsl:with-param name="name" select="'useUD0046'" />
								<xsl:with-param name="value" select="'true'" />
								<xsl:with-param name="element" select="CompanyDetailsQuery" />
							</xsl:call-template>
							<label for="useUD0046"><xsl:value-of select="$i18n.UseUD0046" /></label>
						</td>
						<td>
							<xsl:value-of select="$i18n.Source.Bolagsverket" />
						</td>
					</tr>
					
					<tr>
						<td class="nowrap">
							<xsl:call-template name="createCheckbox">
								<xsl:with-param name="id" select="'useUD0047'" />
								<xsl:with-param name="name" select="'useUD0047'" />
								<xsl:with-param name="value" select="'true'" />
								<xsl:with-param name="element" select="CompanyDetailsQuery" />
							</xsl:call-template>
							<label for="useUD0047"><xsl:value-of select="$i18n.UseUD0047" /></label>
						</td>
						<td>
							<xsl:value-of select="$i18n.Source.Bolagsverket" />
						</td>
					</tr>
					
					<tr>
						<td class="nowrap">
							<xsl:call-template name="createCheckbox">
								<xsl:with-param name="id" select="'useUD0048'" />
								<xsl:with-param name="name" select="'useUD0048'" />
								<xsl:with-param name="value" select="'true'" />
								<xsl:with-param name="element" select="CompanyDetailsQuery" />
							</xsl:call-template>
							<label for="useUD0048"><xsl:value-of select="$i18n.UseUD0048" /></label>
						</td>
						<td>
							<xsl:value-of select="$i18n.Source.Bolagsverket" />
						</td>
					</tr>
				</tbody>
			</table>
			
			<div class="floatleft clearboth bigmargintop">
				<h2><xsl:value-of select="$i18n.UDSelectionExtension.Title" /></h2>
				<p class="nomargin marginbottom"><xsl:value-of select="$i18n.UDSelectionExtension.Description" /></p>
			</div>
			
			<table class="full floatleft coloredtable oep-table">
				<thead>
					<tr>
						<th><xsl:value-of select="$i18n.UDName"/></th>
						<th><xsl:value-of select="$i18n.UDSource"/></th>
					</tr>
				</thead>
			
				<tbody>
				
					<tr>
						<td class="nowrap">
							<xsl:call-template name="createCheckbox">
								<xsl:with-param name="id" select="'useUD0029'" />
								<xsl:with-param name="name" select="'useUD0029'" />
								<xsl:with-param name="value" select="'true'" />
								<xsl:with-param name="element" select="CompanyDetailsQuery" />
							</xsl:call-template>
							<label for="useUD0029"><xsl:value-of select="$i18n.UseUD0029" /></label>
						</td>
						<td>
							<xsl:value-of select="$i18n.Source.Skatteverket" />
						</td>
					</tr>
					
					<tr>
						<td class="nowrap">
							<xsl:call-template name="createCheckbox">
								<xsl:with-param name="id" select="'useUD0031'" />
								<xsl:with-param name="name" select="'useUD0031'" />
								<xsl:with-param name="value" select="'true'" />
								<xsl:with-param name="element" select="CompanyDetailsQuery" />
							</xsl:call-template>
							<label for="useUD0031"><xsl:value-of select="$i18n.UseUD0031" /></label>
						</td>
						<td>
							<xsl:value-of select="$i18n.Source.Skatteverket" />
						</td>
					</tr>
					
					<tr>
						<td class="nowrap">
							<xsl:call-template name="createCheckbox">
								<xsl:with-param name="id" select="'useUD0033'" />
								<xsl:with-param name="name" select="'useUD0033'" />
								<xsl:with-param name="value" select="'true'" />
								<xsl:with-param name="element" select="CompanyDetailsQuery" />
							</xsl:call-template>
							<label for="useUD0033"><xsl:value-of select="$i18n.UseUD0033" /></label>
						</td>
						<td>
							<xsl:value-of select="$i18n.Source.Skatteverket" />
						</td>
					</tr>					

				</tbody>
			</table>			
			
			<div class="floatleft full bigmargintop bigmarginbottom">
				<h2><xsl:value-of select="$i18n.AdvancedSettings" /></h2>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'setAsAttribute'" />
						<xsl:with-param name="name" select="'setAsAttribute'" />
						<xsl:with-param name="element" select="CompanyDetailsQuery" /> 
						<xsl:with-param name="class" select="'vertical-align-middle'" />
					</xsl:call-template>
						
					<label for="setAsAttribute">
						<xsl:value-of select="$i18n.setAsAttribute" />
					</label>
				</div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<label for="attributeName" class="floatleft clearboth"><xsl:value-of select="$i18n.attributeName" /></label>
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'attributeName'"/>
						<xsl:with-param name="name" select="'attributeName'"/>
						<xsl:with-param name="title" select="$i18n.attributeName"/>
						<xsl:with-param name="element" select="CompanyDetailsQuery" />
					</xsl:call-template>
				</div>
			</div>
			
			<p class="floatleft clearboth"><xsl:value-of select="$i18n.attributeDescription" /></p>
			
			<table class="floatleft clearboth border">
				<thead>
					<th><xsl:value-of select="$i18n.attributes.name" /></th>
					<th><xsl:value-of select="$i18n.attributes.value" /></th>
				</thead>
				<tbody>
					<tr>
						<td>prefix.organizationNumber</td>
						<td><xsl:value-of select="$i18n.Attribute.organizationNumber" /></td>
					</tr>
					<tr>
						<td>prefix.companyName</td>
						<td><xsl:value-of select="$i18n.Attribute.companyName" /></td>
					</tr>
					<tr>
						<td>prefix.companyType</td>
						<td><xsl:value-of select="$i18n.Attribute.companyType" /></td>
					</tr>
					<tr>
						<td>prefix.companyTypeDescription</td>
						<td><xsl:value-of select="$i18n.Attribute.companyTypeDescription" /></td>
					</tr>
				</tbody>
			</table>
			
			<div class="floatright margintop clearboth">
				<input type="submit" value="{$i18n.SaveChanges}" />
			</div>
		
		</form>
		
	</xsl:template>

	<xsl:template match="validationError[messageKey = 'UpdateFailedCompanyDetailsQueryNotFound']">
		
		<p class="error">
			<xsl:value-of select="$i18n.CompanyDetailsQueryNotFound" />
		</p>
		
	</xsl:template>

	<xsl:template match="fieldName">

		<xsl:variable name="fieldName" select="." />
	
		<xsl:choose>
			<xsl:when test="$fieldName = 'companyTypes'">
				<xsl:value-of select="$i18n.CompanyTypes.ValidationError" />
			</xsl:when>
			<xsl:when test="$fieldName = 'serviceName'">
				<xsl:value-of select="$i18n.ServiceName.Title" />
			</xsl:when>
			<xsl:when test="$fieldName = 'targetEnvironment'">
				<xsl:value-of select="$i18n.TargetEnvironment.Title" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>
		
	</xsl:template>

</xsl:stylesheet>