<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	
	<xsl:template match="Document">	
		
		<xsl:apply-templates select="ShowQueryValues"/>
		
	</xsl:template>
		
	<xsl:template match="ShowQueryValues">
		
		<div>
			<xsl:attribute name="class">
				<xsl:text>query</xsl:text>
				<xsl:if test="CompanyDetailsQueryInstance/QueryInstanceDescriptor/QueryDescriptor/mergeWithPreviousQuery = 'true'"> mergewithpreviousquery</xsl:if>
			</xsl:attribute>

			
			<a name="query{CompanyDetailsQueryInstance/QueryInstanceDescriptor/QueryDescriptor/queryID}"/>
			
			<h2>
				<xsl:value-of select="CompanyDetailsQueryInstance/QueryInstanceDescriptor/QueryDescriptor/name"/>
			</h2>
			
			<xsl:if test="Description">
				
				<div class="query-description">
					<xsl:choose>
						<xsl:when test="isHTMLDescription = 'true'">
							<xsl:value-of select="Description" disable-output-escaping="yes"/>
						</xsl:when>
						<xsl:otherwise>
							<p>
								<xsl:value-of select="Description" disable-output-escaping="yes"/>
							</p>
						</xsl:otherwise>
					</xsl:choose>
				</div>
								
			</xsl:if>
			
			<xsl:if test="CompanyDetailsQueryInstance/CompanyDetailsQuery/showCompaniesAsRadiosAndKeepShowing = 'true'">
				
				<xsl:variable name="selectedAlternativeID" select="CompanyDetailsQueryInstance/organizationNumber" />
				
				<strong>
					<xsl:value-of select="$i18n.SelectCompany" />
				</strong>
				
				<ul class="bigmarginbottom">
					<xsl:for-each select="CompanyDetailsQueryInstance/SavedCompanies/SavedCompany">
						
						<li>
							
							<xsl:choose>
								<xsl:when test="$selectedAlternativeID = organizationNumber">
									
									<strong>
										<xsl:value-of select="companyName" />
										<xsl:text> (</xsl:text>
										<xsl:value-of select="organizationNumber" />
										<xsl:text>)</xsl:text>
									</strong>
									
								</xsl:when>
								<xsl:otherwise>
								
									<xsl:value-of select="companyName" />
									<xsl:text> (</xsl:text>
									<xsl:value-of select="organizationNumber" />
									<xsl:text>)</xsl:text>
									
								</xsl:otherwise>
							</xsl:choose>
							
						</li>
						
					</xsl:for-each>
				</ul>
				
			</xsl:if>

			<xsl:apply-templates select="CompanyDetailsQueryInstance" mode="preview"/>
			
			<div class="full clearboth"><xsl:text>&#160;</xsl:text></div>
				
		</div>
		
	</xsl:template>	
	
	<xsl:template match="CompanyDetailsQueryInstance" mode="preview">

		<xsl:choose>

			<xsl:when test="companyType = 'E'">

				<xsl:if test="companyName">
					<div class="full floatleft bigmarginbottom">
						
						<strong>
							<xsl:choose>
								<xsl:when test="nameProtectionNumber">
									<!-- Registrerat fretagsnamn -->
									Fretagets namn
								</xsl:when>
								<xsl:otherwise>
									Fretagets namn
								</xsl:otherwise>
							</xsl:choose>
						</strong><br/>
						
						<xsl:value-of select="companyName"/>
					</div>
				</xsl:if>


				<div class="fifty floatleft">
					<strong>Organisationsnummer</strong><br/>
					<xsl:value-of select="organizationNumber"/>
				</div>

				<xsl:if test="companyTypeDescription">
					<div class="fifty floatleft">
						<strong>Fretagsform</strong><br/>
						<xsl:value-of select="companyTypeDescription"/>
					</div>
				</xsl:if>

				<div class="full clearboth"/>
	
				<xsl:if test="businessDescription">
					<strong>Verksamhetsbeskrivning</strong><br/>
					<pre>
						<xsl:value-of select="businessDescription"/>
					</pre>
				</xsl:if>

				<xsl:if test="civilRegistrationAddress">
					<h3>Folkbokfringsadress</h3>
	
					<xsl:if test="civilRegistrationCOAddress">
					
						<div class="full floatleft clearboth">
							<strong>C/O</strong><br/>
							<xsl:value-of select="civilRegistrationCOAddress"/>
						</div>					
					
					</xsl:if>
	
					<div class="fifty floatleft">
						<strong>Utdelningsadress</strong><br/>
						<xsl:value-of select="civilRegistrationAddress"/>
					</div>

					<div class="fifty floatleft">
						
						<div class="forty floatleft">
							<strong>Postnummer</strong><br/>
							<xsl:value-of select="civilRegistrationZip"/>
						</div>

						<div class="fifty floatleft">
							<strong>Postort</strong><br/>
							<xsl:value-of select="civilRegistrationPostalAddress"/>
						</div>
					</div>
					
					<div class="full clearboth"/>
				</xsl:if>

			</xsl:when>
			<xsl:otherwise>

				<xsl:if test="companyName">
					<div class="full floatleft bigmarginbottom">
						<strong>Fretagets namn</strong><br/>
						<xsl:value-of select="companyName"/>
					</div>
				</xsl:if>


				<div class="fifty floatleft">
					<strong>Organisationsnummer</strong><br/>
					<xsl:value-of select="organizationNumber"/>
				</div>

				<xsl:if test="companyTypeDescription">
					<div class="fifty floatleft">
						<strong>Fretagsform</strong><br/>
						<xsl:value-of select="companyTypeDescription"/>
					</div>
				</xsl:if>

				<div class="full clearboth"/>

				<xsl:if test="signing">
					<strong>Firmateckning</strong><br/>
					<pre>
						<xsl:value-of select="signing"/>
					</pre>
				</xsl:if>
				
				<xsl:if test="officers">
					<strong>Samlade funktionrer</strong><br/>
					<pre>
						<xsl:value-of select="officers"/>
					</pre>
				</xsl:if>
				
				<xsl:if test="shares">
					<strong>Sammanstllning av aktiekapital</strong><br/>
					<pre>
						<xsl:value-of select="shares"/>
					</pre>
				</xsl:if>
				
				<xsl:if test="businessDescription">
					<strong>Verksamhetsbeskrivning</strong><br/>
					<pre>
						<xsl:value-of select="businessDescription"/>
					</pre>
				</xsl:if>
				
				<xsl:if test="legalEntityAddress">

					<h3>Postadress</h3>
				
					<xsl:if test="legalEntityCOAddress">
					
						<div class="full floatleft clearboth">
							<strong>C/O Adress</strong><br/>
							<xsl:value-of select="legalEntityCOAddress"/>
						</div>
					
					</xsl:if>
	
					<div class="fifty floatleft">
						<strong>Utdelningsadress</strong><br/>
						<xsl:value-of select="legalEntityAddress"/>
					</div>

					<div class="fifty floatleft">
						<div class="forty floatleft">
							<strong>Postnummer</strong><br/>
							<xsl:value-of select="legalEntityZip"/>
						</div>

						<div class="fifty floatleft">
							<strong>Postort</strong><br/>
							<xsl:value-of select="legalEntityPostalAddress"/>
						</div>
					</div>
			
					<div class="full clearboth"/>
				</xsl:if>
				
			</xsl:otherwise>

		</xsl:choose>

		<xsl:if test="fTaxRegistered">
			<fieldset>
				<strong class="block">F-skatt eller FA-skatt</strong>
				<pre>
					<xsl:choose>
						<xsl:when test="fTaxRegistered = 'ROLE-ACCESS-DENIED'">
						
							<xsl:value-of select="$i18n.RoleAccessDenied"/>
						
						</xsl:when>
						<xsl:otherwise>
						
							<xsl:value-of select="fTaxRegistered"/>
							
						</xsl:otherwise>
					</xsl:choose>
				
				</pre>
			</fieldset>
		</xsl:if>
		
		<xsl:if test="vatRegistered">
			<fieldset>
				<strong class="block">Momsregistrering</strong>
				<pre>
					<xsl:choose>
						<xsl:when test="vatRegistered = 'ROLE-ACCESS-DENIED'">
						
							<xsl:value-of select="$i18n.RoleAccessDenied"/>
						
						</xsl:when>
						<xsl:otherwise>
						
							<xsl:value-of select="vatRegistered"/>
							
						</xsl:otherwise>
					</xsl:choose>
				
				</pre>
			</fieldset>
		</xsl:if>
		
		<xsl:if test="employerRegistration">
			<fieldset>
				<strong class="block">Arbetsgivarregistrering</strong>
				<pre>
					<xsl:choose>
						<xsl:when test="employerRegistration = 'ROLE-ACCESS-DENIED'">
						
							<xsl:value-of select="$i18n.RoleAccessDenied"/>
						
						</xsl:when>
						<xsl:otherwise>
						
							<xsl:value-of select="employerRegistration"/>
							
						</xsl:otherwise>
					</xsl:choose>
				
				</pre>
			</fieldset>
		</xsl:if>

		<xsl:if test="email or phone">
			<h3>Kontaktuppgifter</h3>

			<xsl:if test="email">
				<div class="floatleft fifty">
					<strong>Fretagets e-postadress</strong><br/>
					<xsl:value-of select="email"/>
				</div>
			</xsl:if>
			
			<xsl:if test="phone">
				<div class="floatleft fifty">
					<strong>Fretagets telefonnummer</strong><br/>
					<xsl:value-of select="phone"/>
				</div>
			</xsl:if>
			
			<div class="full clearboth"><xsl:text>&#160;</xsl:text></div>
			
		</xsl:if>
		
	</xsl:template>

</xsl:stylesheet>