package com.nordicpeak.flowengine.evaluators.setcontactdetailsevaluator;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.collections.CollectionUtils;
import se.unlogic.standardutils.dao.AnnotatedDAOWrapper;
import se.unlogic.standardutils.xml.XMLUtils;
import se.unlogic.webutils.http.BeanRequestPopulator;
import se.unlogic.webutils.http.URIParser;
import se.unlogic.webutils.populators.annotated.AnnotatedRequestPopulator;

import com.nordicpeak.flowengine.evaluators.baseevaluator.BaseEvaluatorCRUD;
import com.nordicpeak.flowengine.interfaces.MutableQueryDescriptor;
import com.nordicpeak.flowengine.queries.textfieldquery.TextField;
import com.nordicpeak.flowengine.queries.textfieldquery.TextFieldQuery;

public class SetContactDetailsEvaluatorCRUD extends BaseEvaluatorCRUD<SetContactDetailsEvaluator, SetContactDetailsEvaluationProviderModule> {

	private static final BeanRequestPopulator<SetContactDetailsEvaluator> POPULATOR = new AnnotatedRequestPopulator<SetContactDetailsEvaluator>(SetContactDetailsEvaluator.class);

	public SetContactDetailsEvaluatorCRUD(Class<SetContactDetailsEvaluator> beanClass, AnnotatedDAOWrapper<SetContactDetailsEvaluator, Integer> evaluatorDAO, SetContactDetailsEvaluationProviderModule callback) {

		super(beanClass, evaluatorDAO, POPULATOR, "SetContactDetailsEvaluator", "set contact details evaluator", null, callback);
	}

	@Override
	protected void appendUpdateFormData(SetContactDetailsEvaluator evaluator, Document doc, Element updateTypeElement, User user, HttpServletRequest req, URIParser uriParser) throws Exception {

		super.appendUpdateFormData(evaluator, doc, updateTypeElement, user, req, uriParser);

		TextFieldQuery query = (TextFieldQuery) callback.getQueryHandler().getQuery((MutableQueryDescriptor) evaluator.getEvaluatorDescriptor().getQueryDescriptor(), true);

		List<TextField> textFields = query.getFields();

		if (!CollectionUtils.isEmpty(textFields)) {

			Element textFieldsElement = doc.createElement("TextFields");
			updateTypeElement.appendChild(textFieldsElement);

			for (TextField textField : textFields) {

				Element textFieldElement = doc.createElement("TextField");
				textFieldsElement.appendChild(textFieldElement);

				XMLUtils.appendNewElement(doc, textFieldElement, "textFieldID", textField.getTextFieldID());
				XMLUtils.appendNewCDATAElement(doc, textFieldElement, "label", textField.getLabel());
			}
		}
	}

}
