package com.nordicpeak.flowengine.evaluators.statusoverrideevaluator;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.populators.IntegerPopulator;
import se.unlogic.standardutils.populators.PositiveStringIntegerPopulator;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLParser;
import se.unlogic.standardutils.xml.XMLParserPopulateable;
import se.unlogic.standardutils.xml.XMLValidationUtils;

@Table(name = "status_override_evaluator_alternative")
@XMLElement
public class AlternativeStatusOverride extends GeneratedElementable implements Serializable, XMLParserPopulateable {

	private static final long serialVersionUID = 6322279274170019554L;

	@DAOManaged(columnName = "evaluatorID")
	@ManyToOne
	@Key
	private StatusOverrideEvaluator evaluator;

	@DAOManaged
	@XMLElement
	@Key
	private Integer alternativeID;

	@DAOManaged
	@XMLElement
	private Integer statusID;

	public StatusOverrideEvaluator getEvaluator() {

		return evaluator;
	}

	public void setEvaluator(StatusOverrideEvaluator setWeightEvaluator) {

		this.evaluator = setWeightEvaluator;
	}

	public Integer getAlternativeID() {

		return alternativeID;
	}

	public void setAlternativeID(Integer alternativeID) {

		this.alternativeID = alternativeID;
	}

	public Integer getStatusID() {

		return statusID;
	}

	public void setStatusID(Integer weight) {

		this.statusID = weight;
	}

	@Override
	public void populate(XMLParser xmlParser) throws ValidationException {

		List<ValidationError> errors = new ArrayList<ValidationError>();
		
		alternativeID = XMLValidationUtils.validateParameter("alternativeID", xmlParser, true, PositiveStringIntegerPopulator.getPopulator(), errors);
		statusID = XMLValidationUtils.validateParameter("statusID", xmlParser, true, IntegerPopulator.getPopulator(), errors);

		if(!errors.isEmpty()){

			throw new ValidationException(errors);
		}
	}
}
