var targetGroupFlowBrowserListeners = new Array();
var searchAjaxFlow;
var defaultSorting;

$(function() {

	var $targetGroupFilter = $("section.filter-list.targetgroups");
	var $flowTypeFilter = $("section.filter-list.flowtypes");
	
	var targetGroupCount = $targetGroupFilter.find("ul li a").length;
	var flowTypeCount = $flowTypeFilter.find("ul li a").length;
	
	$(".views-wrapper section.flowtype ul li.disabled a.btn").on("click", function(e) {
		e.preventDefault();
		return false;
	});
	
	$("body").addClass("browsing");
	$(".main.container").before($(".search-wrapper"));
	//$(".search-wrapper").before($(".top-content"));
	
	
	if($(".search-wrapper.bg-search").length == 0) {
	
		$(".search-wrapper .search-btn").on("click", function(e) {
			e.preventDefault();
			searchAjaxFlow($('#search-field'));
			return false;
		});
		
		$(".search-wrapper .search-close-btn").on("click", function(e) {
			e.preventDefault();
			$(".search-result-wrapper").slideUp("fast").removeClass("active");
			var $searchField = $("#search-field");
			$searchField.parent().removeClass("search-active");
			$searchField.val("");

			resetLastSearch();
			
			return false;
		});
		
		$(".recommended-searches a").on("click", function(e) {
			e.preventDefault();
			$("#search-field").val($(this).html().replace("#", ""));
			searchAjaxFlow($('#search-field'));
			return false;
		});
	
	} else {
		
		$(".search-wrapper:not(.bg-search)").remove();
	}
	
	$(".view-toggler a.list").on("click", function(e) {
		e.preventDefault();
		var $this = $(this);
		if(!$this.hasClass("selected")) {
			$(".view-toggler a").removeClass("selected");
			$this.addClass("selected");
			$(".views-wrapper, .search-result-wrapper").addClass("list-view").removeClass("grid-view");
		}
		
		$.cookie("oep.selectedView", "list");
		
		return false;
	});
	
	$(".view-toggler a.grid").on("click", function(e) {
		e.preventDefault();
		var $this = $(this);
		if(!$this.hasClass("selected")) {
			$(".view-toggler a").removeClass("selected");
			$this.addClass("selected");
			$(".views-wrapper, .search-result-wrapper").addClass("grid-view").removeClass("list-view");
		}
		
		$.cookie("oep.selectedView", "grid");
		
		return false;
	});
	
	$(".sorter select").on("change", function(e) {
		
		var selectedValue = $(this).val();
		
		$(".sorter select").val(selectedValue);
		
		if(selectedValue == "FLOWTYPE") {
			
			$(".active-list").removeClass("active-list");
			$(".flowtype-list").addClass("active-list");
			
		} else if(selectedValue == "ALPHABETICAL") {
			
			var $clonedFlows = $(".views-wrapper section.flowtype.visible ul li.show").clone();
			$clonedFlows.removeAttr("id");
			
			var $flowList = $("<ul class='flow-list' />");
			
			$clonedFlows.sort(function(a, b) {
				
				return $(a).attr("data-flowname").toLowerCase().localeCompare($(b).attr("data-flowname").toLowerCase());
				
			}).appendTo($flowList);
			
			initDescriptionDialogs($flowList.find(".description-info a"));
			
			$(".active-list").removeClass("active-list");
			$(".alpabetical-list").html($flowList).addClass("active-list");
			
			
		} else if(selectedValue == "TARGETGROUPS") {
			
			var $targetGroupList = $(".targetgroup-list");
			
			$targetGroupList.html("");
			
			var $selectedTargetGroups = $targetGroupFilter.find("ul li a.selected");
			
			var $targetGroups = null;
			
			if($selectedTargetGroups.length == 0) {
				
				$targetGroups = $targetGroupFilter.find("ul li a");
				
			} else {
				
				$targetGroups = $selectedTargetGroups;
				
			}
			
			var $shownFlows = $(".views-wrapper section.flowtype.visible ul > li.show");
			
			$targetGroups.each(function() {
				
				var $this = $(this);
				
				var targetGroupID = $this.data("targetgroupid");
				
				var $clonedFlows = $shownFlows.filter(function() {
					return $(this).find("input[name='targetgroup'][value='" + targetGroupID + "']").length > 0;			
				}).clone();
				
				if($clonedFlows.length > 0) {
				
					appendTargetGroupFlows(targetGroupID, $this.find(".text").text(), $clonedFlows, $targetGroupList, $this.hasClass("selected"));
				}
			
			});
			
			var $noTargetGroupFlows = $shownFlows.filter(function() {
				return $(this).find("input[name='targetgroup']").length == 0;
			}).clone();
			
			if($noTargetGroupFlows.length > 0) {
			
				appendTargetGroupFlows(null, "Övriga tjänster", $noTargetGroupFlows, $targetGroupList, false);
			}
			
			$(".active-list").removeClass("active-list");
			$targetGroupList.addClass("active-list");
			
		}
		
		$.cookie("oep.selectedSorting", selectedValue);
		
	});
	
	$(".hide-filter-btn").on("click", function(e) {
		e.preventDefault();
		
		var $this = $(this);
		var $filtersWrapper = $(".filters-wrapper");
		
		if($filtersWrapper.is(":visible")) {
			$filtersWrapper.hide();
			$this.find(".text").text($this.data("show-text"));
			$this.addClass("collapsed");
			$.cookie("oep.hideFilter", "true");
		} else {
			$filtersWrapper.show();
			$this.find(".text").text($this.data("hide-text"));
			$this.removeClass("collapsed");
			$.cookie("oep.hideFilter", "false");
		}
		
		return false;
	});
	
	$(".filter-list a.toggle-list-btn").on("click", function(e) {
		e.preventDefault();
		
		var $this = $(this);
		
		var $filterList = $this.closest(".filter-list");
		var $filterUl = $filterList.find("ul");
		
		if($filterUl.is(":visible")) {
			$filterUl.hide();
			$filterList.addClass("collapsed");
			$filterList.find(".toggle-list-btn .text").text($this.data("show-text"));
			$.cookie("oep.hideFilter" + $filterList.data("cookiesuffix"), "true");
		} else {
			$filterUl.show();
			$filterList.removeClass("collapsed");
			$filterList.find(".toggle-list-btn .text").text($this.data("hide-text"));
			$.cookie("oep.hideFilter" + $filterList.data("cookiesuffix"), "false");
		}
		
		return false;
	});
	
	$flowTypeFilter.find("ul li a").on("click", function(e) {
		
		e.preventDefault();
		
		var $this = $(this);

		if($this.hasClass("disabled")) {
			return false;
		}
		
		if($this.hasClass("selected")) {
			$this.removeClass("selected");
		} else {
			$this.addClass("selected");
		}
		
		runTargetGroupFilter();
		
		runFlowTypeFilter();
		
		updateFlowCounts(false);
		
		updateFilterStates($this.closest(".filter-list"));
		
		storeFilterSettings();
		
		return false;
	});
	
	$targetGroupFilter.find("ul li a").on("click", function(e) {
		
		e.preventDefault();
		
		var $this = $(this);
		
		if($this.hasClass("disabled")) {
			return false;
		}
		
		if($this.hasClass("selected")) {
			$this.removeClass("selected");
		} else {
			$this.addClass("selected");
		}

		runTargetGroupFilter();
		
		runFlowTypeFilter();
		
		updateFlowCounts(false);
		
		updateFilterStates($this.closest(".filter-list"));
		
		storeFilterSettings();
		
		return false;
	});
	
	$(".filter-list a.clear-filter-btn").on("click", function(e) {
		
		e.preventDefault();
		
		var $this = $(this);
		
		if(!$this.hasClass("disabled")) {
		
			$this.closest("section.filter-list").find("ul li a").removeClass("selected");
			
			runFlowTypeFilter();
			
			runTargetGroupFilter();
			
			updateFlowCounts(false);
			
			updateFilterStates($this.closest(".filter-list"));
			
			storeFilterSettings();
			
			return false;
		
		}
	});
	
	$("section.flowtype .clear-filter-btn").on("click", function(e) {
		e.preventDefault();		
		
		var $this = $(this);
		
		var flowTypeID = $this.closest("section.flowtype").data("flowtypeid");
		
		$(".filter-list.flowtypes ul li a[data-flowtypeid='" + flowTypeID + "']").trigger("click");
		
		$this.hide();
		
		return false;
	});
	
	$(".clear-all-filter a, a.clear-all-filter-btn").on("click", function(e) {
		e.preventDefault();
		
		$(".filter-list ul li a.selected").removeClass("selected");
		
		runFlowTypeFilter();
		
		runTargetGroupFilter();
		
		updateFlowCounts(false);
		
		updateFilterStates($(".filter-list"));

		storeFilterSettings();
		
		var firstFlowTypePosition = $("section.flowtype:first").offset().top;
		
		if($(document).scrollTop() > firstFlowTypePosition) {
			$("html, body").animate({ scrollTop: firstFlowTypePosition - 60 }, "fast");
		}
		
		return false;
	});
	
	$(".show-all-btn").on("click", function(e) {
		
		e.preventDefault();
		
		var $this = $(this);

		$this.parent().parent().addClass("showall").find(".flow-list > li").addClass("show");
		
		return false;
		
	});
	
	$(".show-fewer-btn").on("click", function(e) {
		
		e.preventDefault();
		
		var $section = $(this).parent().parent();
		
		$section.removeClass("showall").find(".flow-list > li:not(.popular)").removeClass("show");
		
		var flowTypePosition = $section.offset().top;
		
		if($(document).scrollTop() > flowTypePosition) {
			$("html, body").animate({ scrollTop: flowTypePosition - 60 }, "fast");
		}
		
		return false;
		
	});
	
	var appendTargetGroupFlows = function(targetGroupID, name, $flows, $list, isFiltered) {
		
		$flows.removeAttr("id");
		
		var $flowList = $("<ul class='flow-list' />");
		$flowList.append($flows);
		
		initDescriptionDialogs($flowList.find(".description-info a"));
		
		var $header = $("<h2>" + name + "</h2>");
		
		if(isFiltered) {
			
			$filterBtn = $("<a class='clear-filter-btn' href='#' style='display: inline;'><i class='material-icons' /></a>");
			
			$filterBtn.on("click", function(e) {
				
				e.preventDefault();		
				
				var $this = $(this);
				
				$(".filter-list.targetgroups ul li a[data-targetgroupid='" + targetGroupID + "']").trigger("click");
				
				$this.hide();
				
				return false;
				
			});
			
			$header.append($filterBtn);
		}
		
		var $targetGroupWrapper = $("<section class='targetgroup' />");
		
		$targetGroupWrapper.append($header);
		$targetGroupWrapper.append($flowList);
		
		$list.append($targetGroupWrapper);
		
	};
	
	var initDescriptionDialogs = function($infoLinks) {
		
		$infoLinks.on("hover", function(e) {
			$(this).parent().addClass("hover");
		},
		function(e) {
			$(this).parent().removeClass("hover");
		}).on("click", function(e) {
			e.preventDefault();
			$(this).parent().addClass("hover");
		}).on("focus", function(e) {
			$(this).parent().addClass("hover");
		}).on("focusout", function(e) {
			$(this).parent().removeClass("hover");
		});
		
	};
	
	var runTargetGroupFilter = function() {

		var $selectedTargetGroups = $targetGroupFilter.find("ul li a.selected");
		
		if($selectedTargetGroups.length == 0) {

			$(".views-wrapper section.flowtype ul > li:not(.show)").addClass("show");
		
			$targetGroupFilter.find(".toggle-list-btn .count").text(targetGroupCount);
			
		} else {
			
			$(".views-wrapper section.flowtype ul li").removeClass("show");
			
			$selectedTargetGroups.each(function() {
				
				var $targetGroup = $(this);
				
				var targetGroupID = $targetGroup.data("targetgroupid");
				
				$(".views-wrapper section.flowtype ul > li input[name='targetgroup'][value='" + targetGroupID + "']").each(function() {
					
					var $flow = $(this).parent();
					$flow.addClass("show");
					
				});
				
			});
			
			$targetGroupFilter.find(".toggle-list-btn .count").text($selectedTargetGroups.length + "/" + targetGroupCount);
		
		}
		
		updateTotalFilterCount();
	};
	
	var runFlowTypeFilter = function() {
		
		var $selectedFlowTypes = $flowTypeFilter.find("ul > li a.selected");
		
		if($selectedFlowTypes.length == 0) {
			
			$(".views-wrapper section.flowtype").addClass("visible").removeClass("last").show();
			
			$flowTypeFilter.find(".toggle-list-btn .count").text(flowTypeCount);

			$flowTypeFilter.removeClass("filtered");
			
		} else {
			
			$flowTypeFilter.find("ul > li a").each(function() {
				
				var flowTypeID = $(this).data("flowtypeid");
				
				var $flowType = $("#flowtype_" + flowTypeID);
				
				if($(this).hasClass("selected")) {
					$flowType.addClass("visible").show();
					$flowType.find(".clear-filter-btn").show();
				} else {
					$flowType.removeClass("visible").hide();
					$flowType.find(".clear-filter-btn").hide();
				}
				
				$flowType.removeClass("last");
				
			});
		
			$flowTypeFilter.find(".toggle-list-btn .count").text($selectedFlowTypes.length + "/" + flowTypeCount);
			
			$flowTypeFilter.addClass("filtered");
			
		}
		
		$(".views-wrapper section.flowtype:visible:last").addClass("last");
		
		updateTotalFilterCount();
	};
	
	var updateTotalFilterCount = function() {
		
		var $hideFilterBtn = $(".hide-filter-btn");
		
		var currentCount = $targetGroupFilter.find("ul > li a.selected").length + $flowTypeFilter.find("ul > li a.selected").length;
		
		if(currentCount > 0) {
			$hideFilterBtn.find(".count").text("(" + currentCount + "/" + (targetGroupCount + flowTypeCount) + ")");
		} else {
			$hideFilterBtn.find(".count").text("");
		}
		
	};
	
	var updateFilterStates = function($filter) {
		
		var $ul = $filter.find("ul");
		
		$ul.each(function() {
			
			var $clearFilterBtn = $(this).parent().find("h2 a.clear-filter-btn");
			
			if($(this).find("> li a.selected").length > 0) {
				$clearFilterBtn.removeClass("disabled");
			} else {
				$clearFilterBtn.addClass("disabled");
			}
		});

		if($(".filter-list ul > li a.selected").length > 0) {
			$(".clear-all-filter, .clear-all-filter-btn").slideDown("fast", function() { $(this).removeClass("hidden"); });
			$(".views-wrapper section.flowtype").addClass("showall");
			
		} else {
			$(".clear-all-filter, .clear-all-filter-btn").slideUp("fast", function() { $(this).addClass("hidden"); })
			$(".views-wrapper section.flowtype").removeClass("showall").find(".clear-filter-btn").hide();
		}
		
	};
	
	var updateFlowCounts = function(countInvisible) {
		
		var targetGroupCounts = {};
		
		$(".views-wrapper section.flowtype.visible input[name='targetgroup']").each(function() {
			
			var targetGroupID = $(this).val();

			if(targetGroupCounts[targetGroupID] == undefined) {
				
				targetGroupCounts[targetGroupID] = 0;
			}
			
			targetGroupCounts[targetGroupID] += 1;
			
		});
		
		$(".views-wrapper section.flowtype").each(function() {
			
			var $this = $(this);
			
			var count;
			
			if(countInvisible) {
				count = $this.find("ul.flow-list > li").length;
			} else {
				count = $this.find("ul.flow-list > li.show").length;
			}
			
			var $flowTypeFilterBtn = $flowTypeFilter.find("ul > li a[data-flowtypeid='" + $this.data("flowtypeid") + "']");
			
			if(count == 0) {
				$flowTypeFilterBtn.addClass("disabled");
				$this.hide();
			} else {
				$flowTypeFilterBtn.removeClass("disabled");
			}
			
			$flowTypeFilterBtn.find(".count").text(count);
			
			$this.find("> .heading-wrapper h2 .count").text(count);
			
		});
		
		$targetGroupFilter.find("ul > li a").each(function() {
			
			var $this = $(this);
			
			var count = targetGroupCounts[$this.data("targetgroupid")];
			
			if(count == undefined) {
				count = 0;
				$this.addClass("disabled");
			} else {
				$this.removeClass("disabled");
			}
			
			$this.find(".count").text(count);
			
		});
		
		$(".sorter select").trigger("change");
		
	};
	
	var storeFilterSettings = function() {

		var targetGroupIDs = new Array();
		
		$targetGroupFilter.find("ul > li a.selected").each(function() {
			targetGroupIDs.push($(this).data("targetgroupid"));
		});
		
		$.cookie("oep.targetGroupIDs", JSON.stringify(targetGroupIDs));
		
		var flowTypeIDs = new Array();
		
		$flowTypeFilter.find("ul li a.selected").each(function() {
			flowTypeIDs.push($(this).data("flowtypeid"));
		});
		
		$.cookie("oep.flowTypeIDs", JSON.stringify(flowTypeIDs));
		
	};
		
		
	searchAjaxFlow = function($searchField) {
		
		$searchField.parent().addClass("search-active");
		
		var searchStr = $searchField.val().trim();
		

		var $searchResultWrapper = $(".search-result-wrapper");
		var $searchResultList = $searchResultWrapper.find("ul.flow-list");
		var $searchResultTitle = $searchResultWrapper.find(".search-results-title");
		
		if(searchStr != "") {
			
			$.ajax({
				
				cache: false,
				url: searchFlowURI,
				data : {
					q : encodeURIComponent(searchStr)
				},
				dataType: "json",
				contentType: "application/x-www-form-urlencoded;charset=UTF-8",
				error: function (xhr, ajaxOptions, thrownError) { },
				success: function(response) {

					var result = response;
					
					$searchResultList.html("");
					
					var filteredHits = 0;
					
					if(response.hitCount > 0) {
					
						$.each(result.hits, function( key, flowID) {
				        	
							var $flow = $("section.flowtype ul.flow-list li#flow_" + flowID);
							
							if($flow.length > 0){
							
				        		var $newFlow = $("<li>" + $flow.html() + "</li>")
				        	
				        		$newFlow.attr("id", $flow.attr("id"));
				        	
				        		if($flow.hasClass("disabled")) {
				        			$newFlow.addClass("disabled");
				        		}
				        	
				        		initDescriptionDialogs($newFlow.find(".description-info a"));
				        	
				        		$searchResultList.append($newFlow);
				        	
				        		filteredHits++;
							}
				        	
						});
					
					}
					
					$searchResultTitle.find(".title").text(searchStr);
			        $searchResultTitle.find(".hits").text(filteredHits);
			        
			        $searchResultWrapper.addClass("active");
			        $searchResultWrapper.show();
					
				}
				
			});
	        
	    } else {
	    	
	    	$searchField.parent().removeClass("search-active");
	    	$searchResultTitle.find(".title").text("");
	    	$searchResultTitle.find(".hits").text(0);
	    	$searchResultWrapper.removeClass("active");
	    	$searchResultWrapper.hide();
	    	$searchResultList.html("");
	 
	    	resetLastSearch();
	    }
		
	};
	
	$("#search-field").on("keyup", function () {
		$(this).parent().removeClass("searching");
		searchAjaxFlow($(this));
    }).on("keydown", function() {
    	$(this).parent().addClass("searching");
    }).on('focus blur', function() {
    	$(this).parent().toggleClass('focus');
	}).trigger("keyup");

	
	var isFiltered = false;
	
	var hashFilter = window.location.hash;
	var filterByHash = false;
	
	if(hashFilter != "") {
		
		hashFilter = hashFilter.split("-");
	
		if(hashFilter[0] == "#category" || hashFilter[0] == "#group") {
			filterByHash = true;
		}
		
	} else {
		hashFilter = [];
	}
	
	var flowTypeIDs;
	
	if(hashFilter[0] == "#category" && $.isNumeric(hashFilter[1])) {
		flowTypeIDs = "[" + hashFilter[1] + "]";
	} else if(!filterByHash) {
		flowTypeIDs = $.cookie("oep.flowTypeIDs");
	}
	
	if(flowTypeIDs != undefined) {
		
		var jsonArray = $.parseJSON(flowTypeIDs);
		
		$.each(jsonArray, function(index, flowTypeID){

			isFiltered = true;
			
			$flowTypeFilter.find("ul li a[data-flowtypeid = '" + flowTypeID + "']").addClass("selected");
			
		});
	}
	
	var targetGroupIDs;
	
	if(hashFilter[0] == "#group" && $.isNumeric(hashFilter[1])) {
		targetGroupIDs = "[" + hashFilter[1] + "]";
	} else if(!filterByHash) {
		targetGroupIDs = $.cookie("oep.targetGroupIDs");
	}
	
	if(targetGroupIDs != undefined) {
		
		var jsonArray = $.parseJSON(targetGroupIDs);
		
		$.each(jsonArray, function(index, targetGroupID){
		    
			isFiltered = true;
			
			$targetGroupFilter.find("ul li a[data-targetgroupid = '" + targetGroupID + "']").addClass("selected");
			
		});
	}
	
	if(filterByHash) {
		$("html, body").animate({ scrollTop: $(".flowtype-list").offset().top - 60 }, "fast");
	}
	
	var view = $.cookie("oep.selectedView");
	
	if(view != undefined) {

		$("	.view-toggler a." + view).removeClass("selected").trigger("click");
		
	} else {
		
		$("	.view-toggler a.selected").removeClass("selected").trigger("click");
	
	}
	
	var sorting = $.cookie("oep.selectedSorting");
	
	if(sorting != undefined) {
		
		$(".sorter select").val(sorting);		
	
	} else {
		
		$(".sorter select").val(defaultSorting);
	}
	
	if($.cookie("oep.hideFilter") == undefined || $.cookie("oep.hideFilter") == "true") {
		
		$(".filters-wrapper").hide();
		var $hideFilterBtn = $(".hide-filter-btn");
		$hideFilterBtn.find(".text").text($hideFilterBtn.data("show-text"));
		$hideFilterBtn.addClass("collapsed");
	
	} else {
		
		$(".filters-wrapper").show();
		var $hideFilterBtn = $(".hide-filter-btn");
		$hideFilterBtn.find(".text").text($hideFilterBtn.data("hide-text"));
		$hideFilterBtn.removeClass("collapsed");
		
	}
	
	$(".filter-list").each(function() {
		
		var $this = $(this);
		
		var state = $.cookie("oep.hideFilter" + $this.data("cookiesuffix"))
		
		if((state == undefined && !$this.hasClass("default-expanded")) || state == "true") {
			$this.addClass("collapsed");
			var showText = $this.find(".toggle-list-btn").data("show-text");
			$this.find(".toggle-list-btn .text").text(showText);
		} else if (state == "false"){
			$this.removeClass("collapsed");
			var hideText = $this.find(".toggle-list-btn").data("hide-text");
			$this.find(".toggle-list-btn .text").text(hideText);
		}
		
	});
	
	initDescriptionDialogs($(".description-info a"));
	
	$(document).on("click", function(e) {
		$(".description-info.hover").removeClass("hover");
	});
	
	runFlowTypeFilter();
	
	runTargetGroupFilter();
	
	updateFlowCounts(!isFiltered);
	
	updateFilterStates($(".filter-list"));
	
	if(targetGroupFlowBrowserListeners.length > 0) {
		
		$.each(targetGroupFlowBrowserListeners, function(index, listener) {
			
			if(typeof listener == "function") {
				
				listener();
			}
			
		});
		
	}
	
	$(".flow-wrapper").css("visibility", "visible");
	
});

function resetLastSearch() {

	$.ajax({
	    url: resetLastSearchURI,
	    cache: false
	});
}
