package com.nordicpeak.flowengine.evaluators.setbookingqueryslotparam;

import java.util.ArrayList;
import java.util.List;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.populators.StringPopulator;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLParser;
import se.unlogic.standardutils.xml.XMLValidationUtils;

import com.nordicpeak.flowengine.beans.QueryModification;
import com.nordicpeak.flowengine.evaluators.baseevaluator.BaseEvaluator;
import com.nordicpeak.flowengine.interfaces.EvaluationCallback;
import com.nordicpeak.flowengine.interfaces.EvaluationEventListener;
import com.nordicpeak.flowengine.interfaces.EvaluationHandler;
import com.nordicpeak.flowengine.interfaces.ParameterEvaluator;
import com.nordicpeak.flowengine.interfaces.QueryInstance;

@Table(name = "set_booking_query_slot_param_evaluators")
@XMLElement
public class SetBookingQuerySlotParamEvaluator extends BaseEvaluator implements EvaluationEventListener, ParameterEvaluator {
	
	private static final long serialVersionUID = 4660678625236716384L;
	
	@DAOManaged
	@WebPopulate(required = true, maxLength = 255)
	@XMLElement(cdata = true)
	private String paramName;
	
	private boolean initialized;
	
	@Override
	public void populate(XMLParser xmlParser) throws ValidationException {
		
		List<ValidationError> errors = new ArrayList<ValidationError>();
		
		paramName = XMLValidationUtils.validateParameter("attributeName", xmlParser, false, 1, 255, StringPopulator.getPopulator(), errors);
		
		if (!errors.isEmpty()) {
			
			throw new ValidationException(errors);
		}
	}
	
	@Override
	public String toString() {
		
		return evaluatorDescriptor.toString();
	}
	
	@Override
	public boolean forceAjaxPosting() {
		
		return true;
	}
	
	@Override
	public boolean requiresInitialization() {
		
		return true;
	}
	
	@Override
	public String getParamName() {
		
		return paramName;
	}
	
	public void setParamName(String attributeName) {
		
		this.paramName = attributeName;
	}
	
	@Override
	public boolean supportsEvent(Object event) {
		
		return false;
	}
	
	@Override
	public List<QueryModification> processEvent(Object event, QueryInstance queryInstance, User user, User poster, EvaluationCallback callback, EvaluationHandler evaluationHandler) {
		
		return null;
	}
	
	public boolean isInitialized() {
		
		return initialized;
	}
	
	public void setInitialized(boolean initialized) {
		
		this.initialized = initialized;
	}
}
