<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1"/>

		<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>

	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
		/jquery/jquery-migrate.js?v=1
		/ckeditor/ckeditor.js
		/ckeditor/adapters/jquery.js
		/ckeditor/init.js
	</xsl:variable>	

	<xsl:template match="Document">	
		
		<div id="UnsecureMultiSignQueryProvider" class="contentitem">
		
			<xsl:apply-templates select="validationError"/>
			<xsl:apply-templates select="UpdateUnsecureMultiSignQuery"/>
		
		</div>
		
	</xsl:template>
		
	<xsl:template match="UpdateUnsecureMultiSignQuery">
	
		<h1><xsl:value-of select="$i18n.UpdateQuery" /><xsl:text>:&#160;</xsl:text><xsl:value-of select="UnsecureMultiSignQuery/QueryDescriptor/name" /></h1>
		
		<xsl:apply-templates select="validationException/validationError" />
		
		<form id="updateUnsecureMultiSignQueryForm" name="queryAdminForm" method="post" action="{/Document/requestinfo/uri}">
		
			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="UnsecureMultiSignQuery" />
			</xsl:call-template>
			
			<div class="floatleft full bigmarginbottom">
				<h2><xsl:value-of select="$i18n.AdvancedSettings" /></h2>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'setMultipartsAsOwners'" />
						<xsl:with-param name="name" select="'setMultipartsAsOwners'" />
						<xsl:with-param name="element" select="UnsecureMultiSignQuery" /> 
					</xsl:call-template>
						
					<label for="setMultipartsAsOwners">
						<xsl:value-of select="$i18n.SetMultipartsAsOwners" />
					</label>
				</div>
			</div>
			
			<div class="floatleft full bigmarginbottom">

				<xsl:call-template name="createCheckbox">
					<xsl:with-param name="id" select="'requireContactInfoVerification'" />
					<xsl:with-param name="name" select="'requireContactInfoVerification'" />
					<xsl:with-param name="element" select="UnsecureMultiSignQuery" />
				</xsl:call-template>
				
				<label for="requireContactInfoVerification">
					<xsl:value-of select="$i18n.RequiredContactWayVerification" />
				</label>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'disabled'" />
						<xsl:with-param name="name" select="'disabled'" />
						<xsl:with-param name="element" select="UnsecureMultiSignQuery" /> 
					</xsl:call-template>
						
					<label for="disabled">
						<xsl:value-of select="$i18n.Disabled" />
					</label>
				</div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'lockOnOwnershipTransfer'" />
						<xsl:with-param name="name" select="'lockOnOwnershipTransfer'" />
						<xsl:with-param name="element" select="UnsecureMultiSignQuery" /> 
					</xsl:call-template>
					
					<label for="lockOnOwnershipTransfer">
						<xsl:value-of select="$i18n.lockOnOwnershipTransfer" />
					</label>
				</div>
			</div>
			
			<div class="floatleft full bigmarginbottom">
				<div class="floatleft full">
					<xsl:call-template name="createCheckbox">
						<xsl:with-param name="id" select="'setAsAttribute'" />
						<xsl:with-param name="name" select="'setAsAttribute'" />
						<xsl:with-param name="element" select="UnsecureMultiSignQuery" /> 
						<xsl:with-param name="class" select="'vertical-align-middle'" />
					</xsl:call-template>
						
					<label for="setAsAttribute">
						<xsl:value-of select="$i18n.setAsAttribute" />
					</label>
			    </div>
			</div>
			
			<div id="attribute-container" class="floatleft full bigmarginbottom">
				<label for="attributeName" class="floatleft clearboth"><xsl:value-of select="$i18n.attributeName" /></label>
				
				
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'attributeName'"/>
						<xsl:with-param name="name" select="'attributeName'"/>
						<xsl:with-param name="title" select="$i18n.attributeName"/>
						<xsl:with-param name="element" select="UnsecureMultiSignQuery" />
						<xsl:with-param name="maxlength" select="'255'"/>
					</xsl:call-template>
			  </div>
			    
				<p class="floatleft clearboth"><xsl:value-of select="$i18n.attributeDescription" /></p>
				
				<table class="floatleft clearboth">
					<thead>
						<th><xsl:value-of select="$i18n.attributes.name" /></th>
						<th><xsl:value-of select="$i18n.attributes.value" /></th>
					</thead>
					<tbody>
						<tr>
							<td>prefix.firstname</td>
							<td><xsl:value-of select="$i18n.Firstname" /></td>
						</tr>
						<tr>
							<td>prefix.lastname</td>
							<td><xsl:value-of select="$i18n.Lastname" /></td>
						</tr>
						<tr>
							<td>prefix.email</td>
							<td><xsl:value-of select="$i18n.Email" /></td>
						</tr>
						<tr>
							<td>prefix.mobilePhone</td>
							<td><xsl:value-of select="$i18n.MobilePhone" /></td>
						</tr>
					</tbody>
				</table>
			</div>
			
			<div class="floatright margintop clearboth">
				<input type="submit" value="{$i18n.SaveChanges}" />
			</div>
			
			<script type="text/javascript">
				var showHideAttributeName = function(){
					var checked = $("#setAsAttribute").prop("checked");
					$("#attribute-container").toggle(checked).find("input").prop("disabled", !checked);
				};
			
				showHideAttributeName();
				
				$("#setAsAttribute").on("change", function(){showHideAttributeName()});
			</script>
		
		</form>
		
	</xsl:template>

	<xsl:template match="validationError[messageKey = 'UpdateFailedUnsecureMultiSignQueryNotFound']">
		
		<p class="error">
			<xsl:value-of select="$i18n.UnsecureMultiSignQueryNotFound" />
		</p>
		
	</xsl:template>

	<xsl:template match="fieldName">

		<xsl:variable name="fieldName" select="." />
	
		<xsl:value-of select="$fieldName" />
		
	</xsl:template>

</xsl:stylesheet>