package com.nordicpeak.flowengine.userinvoices;

import java.util.Date;

import se.unlogic.standardutils.date.DateStringyfier;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;

@XMLElement
public class Invoice extends GeneratedElementable {
	
	@XMLElement
	private final String invoiceID;

	@XMLElement
	private final String amount;

	@XMLElement(valueFormatter = DateStringyfier.class)
	private final Date invoiceDate;

	@XMLElement(valueFormatter = DateStringyfier.class)
	private final Date dueDate;

	@XMLElement
	private final String status;

	@XMLElement
	private final boolean payed;

	@XMLElement
	private final String description;

	@XMLElement
	private final String longDescription;

	public Invoice(String invoiceID, String amount, Date invoiceDate, Date dueDate, String status, boolean payed, String description, String longDescription) {

		super();
		this.invoiceID = invoiceID;
		this.amount = amount;
		this.invoiceDate = invoiceDate;
		this.dueDate = dueDate;
		this.status = status;
		this.payed = payed;
		this.description = description;
		this.longDescription = longDescription;
	}

	public String getInvoiceID() {

		return invoiceID;
	}

	public String getAmount() {

		return amount;
	}

	public Date getInvoiceDate() {

		return invoiceDate;
	}

	public Date getDueDate() {

		return dueDate;
	}

	public boolean isPayed() {

		return payed;
	}

	public String getDescription() {

		return description;
	}

	@Override
	public String toString() {

		return "Invoice (invoiceID: " + invoiceID + ", description: " + description + ")";
	}

	public String getLongDescription() {

		return longDescription;
	}

	public String getStatus() {

		return status;
	}

}
