package com.nordicpeak.flowengine.queries.userlistquery.beans;

import java.io.Serializable;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;

import com.nordicpeak.listuserprovider.ListParameter;

@Table(name = "userlist_query_parameters")
public class UserListParameter implements Serializable, ListParameter{

	private static final long serialVersionUID = -172992991788104190L;

	@DAOManaged(columnName = "queryInstanceID")
	@Key
	@ManyToOne
	private UserListQueryInstance queryInstance;

	@DAOManaged
	@Key
	private String name;

	@DAOManaged
	private String value;

	public UserListParameter() {};

	public UserListParameter(String name, String value) {
		super();

		if (name == null || value == null) {
			throw new NullPointerException();
		}

		this.name = name;
		this.value = value;
	}

	public UserListQueryInstance getQueryInstance() {

		return queryInstance;
	}

	@Override
	public String getName() {

		return name;
	}

	@Override
	public String getValue() {

		return value;
	}

	@Override
	public int hashCode() {

		final int prime = 31;
		int result = 1;
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {

		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		UserListParameter other = (UserListParameter) obj;
		if (name == null) {
			if (other.name != null) {
				return false;
			}
		} else if (!name.equals(other.name)) {
			return false;
		}
		return true;
	}

}
