package com.nordicpeak.flowengine.queries.usertreequery;

import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;

import se.unlogic.hierarchy.core.beans.User;
import se.unlogic.standardutils.json.JsonArray;
import se.unlogic.standardutils.json.JsonObject;
import se.unlogic.standardutils.json.JsonUtils;
import se.unlogic.webutils.http.HTTPUtils;
import se.unlogic.webutils.http.URIParser;

import com.nordicpeak.flowengine.interfaces.QueryRequestProcessor;
import com.nordicpeak.flowengine.queries.usertreequery.beans.TreeUser;
import com.nordicpeak.flowengine.queries.usertreequery.interfaces.UserTreeQueryDataProvider;

public class UserTreeQueryRequestProcessor implements QueryRequestProcessor {

	protected final Logger log = Logger.getLogger(this.getClass());

	private final UserTreeQueryDataProvider provider;

	public UserTreeQueryRequestProcessor(UserTreeQueryDataProvider provider) {

		super();
		this.provider = provider;
	}

	@Override
	public void processRequest(HttpServletRequest req, HttpServletResponse res, User user, URIParser uriParser) throws Exception {

		String selectedNodeKey = req.getParameter("selectedNodeKey");

		List<TreeUser> users = provider.getUsers(selectedNodeKey);

		JsonObject jsonRoot = new JsonObject();

		if (users != null) {

			JsonArray jsonUserArray = new JsonArray(users.size());

			for (TreeUser treeUser : users) {

				JsonObject jsonUser = new JsonObject();

				jsonUser.putField("firstname", treeUser.getFirstname());
				jsonUser.putField("lastname", treeUser.getLastname());
//				jsonUser.putField("citizenIdentifier", treeUser.getCitizenIdentifier());
				jsonUser.putField("providerUserID", treeUser.getProviderUserID());
				jsonUser.putField("email", treeUser.getEmail());
//				jsonUser.putField("phone", treeUser.getPhone());

				jsonUserArray.addNode(jsonUser);
			}

			jsonRoot.putField("users", jsonUserArray);
		}

		HTTPUtils.sendReponse(jsonRoot.toJson(), JsonUtils.getContentType(), res);
	}

	@Override
	public void close() throws Exception {

	}
}
