<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />
	
	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
	</xsl:variable>	
	
	<xsl:variable name="scripts">
		/js/dynamicweight.js
	</xsl:variable>

	<xsl:template match="Document">

		<div class="contentitem">

			<xsl:apply-templates select="UpdateDynamicWeightQueryStateEvaluator" />
		</div>

	</xsl:template>

	<xsl:template name="createCustomFormFields">
		
		<xsl:param name="queryStateEvaluator" />
			
		<div class="floatleft full bigmarginbottom">

			<label for="weightType" class="floatleft full">
				<xsl:value-of select="$i18n.weightType" />
				<span class="required">*</span>
			</label>

			<div class="floatleft full">
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'weightType'" />
					<xsl:with-param name="name" select="'weightType'" />
					<xsl:with-param name="element" select="DynamicWeightQueryStateEvaluator" />
				</xsl:call-template>
			</div>
		</div>
		
		<div id="fromToDiv" class="floatleft sixty bigmarginbottom">
			<label class="floatleft full">
				<xsl:value-of select="$i18n.weight.title" />
			</label>
			
			<div class="clearboth full floatleft marginbottom">
				<xsl:value-of select="$i18n.weight.description" />
			</div>
			
			<p id="i18nDeleteRow" class="hidden">
				<xsl:value-of select="$i18n.deleteRow"/>
			</p>
			
			<table style="display: none;">
				<tbody id="dynamicTableRowTemplate">
				
				<xsl:call-template name="addWeightTableRow">
					<xsl:with-param name="rowID">template</xsl:with-param>
					<xsl:with-param name="disabled">true</xsl:with-param>
				</xsl:call-template>
				
				</tbody>
			</table>
			
			
			<table id="weightinterval" class="floatleft full">
				
					<thead>
					
						<tr>
							<th width="0"/>
							<th class="padding">
								<strong class="floatleft"><xsl:value-of select="$i18n.from" /></strong>
								<span class="required">*</span>
							</th>
							<th class="padding bigmarginleft">
								<strong class="floatleft"><xsl:value-of select="$i18n.to" /></strong>
								<span class="required">*</span>
							</th>
							<th width="85px"/>
							
						</tr>
						
					</thead>
					
					<tbody>
						<xsl:choose>
							<xsl:when test="requestparameters/parameter[name='rowID']">
								<xsl:for-each select="requestparameters/parameter[name='rowID']/value">
								
								<xsl:variable name="fromID" >fromValue<xsl:value-of select="."/></xsl:variable>
								<xsl:variable name="toID" >toValue<xsl:value-of select="."/></xsl:variable>
									
								
								<xsl:call-template name="addWeightTableRow">
									<xsl:with-param name="rowID"><xsl:value-of select="."/></xsl:with-param>
									<xsl:with-param name="fromValue"><xsl:value-of select="//parameter[name=$fromID]/value"/></xsl:with-param>
									<xsl:with-param name="toValue"><xsl:value-of select="//parameter[name=$toID]/value"/></xsl:with-param>
								</xsl:call-template>
								
								
								</xsl:for-each>
							</xsl:when>
							<xsl:when test="DynamicWeightQueryStateEvaluator/dynamicWeightQueryStateEvaluatorValueList">
						
							<xsl:for-each select="DynamicWeightQueryStateEvaluator/dynamicWeightQueryStateEvaluatorValueList/DynamicWeightQueryStateEvaluatorValues">
								<xsl:call-template name="addWeightTableRow">
									<xsl:with-param name="rowID"><xsl:value-of select="valueID"/></xsl:with-param>
									<xsl:with-param name="fromValue"><xsl:value-of select="fromValue"/></xsl:with-param>
									<xsl:with-param name="toValue"><xsl:value-of select="toValue"/></xsl:with-param>
								</xsl:call-template>
								
							</xsl:for-each>
							</xsl:when>
							<xsl:otherwise>
								<script>
									addTableRowForWeightInterval();
								</script>
						
							</xsl:otherwise>
					</xsl:choose>
					</tbody>
			</table>
			<div class="newDynamicTableRow">
					<a class="btn btn-green margintop floatright" href="#" onclick="addTableRowForWeightInterval();">
						<xsl:value-of select="$i18n.addRow"/>
					</a>
				</div>
			
			
		</div>
		
		
	</xsl:template>

	<xsl:template match="UpdateDynamicWeightQueryStateEvaluator">

		<xsl:call-template name="createQueryStateEvaluatorForm">
			<xsl:with-param name="queryStateEvaluator" select="DynamicWeightQueryStateEvaluator" />
		</xsl:call-template>

	</xsl:template>
	
	
	<xsl:template name="addWeightTableRow">
		<xsl:param name="rowID"/>
		<xsl:param name="fromValue" select="null"/>
		<xsl:param name="toValue" select="null"/>
		<xsl:param name="disabled" select="null"/>
			<tr>
				<xsl:choose>
					<xsl:when test="not($disabled)">
						<td><input name="rowID" hidden="true" value="{$rowID}"/></td>
						<td>
							
							<xsl:call-template name="createTextField">
								<xsl:with-param name="id" select="'fromValue'" />
								<xsl:with-param name="name">fromValue<xsl:value-of select="$rowID"/></xsl:with-param>
								<xsl:with-param name="value"><xsl:value-of select="$fromValue"/></xsl:with-param>
								<xsl:with-param name="type" select="'number'"/>
							</xsl:call-template>
						</td>
						<td>
							<xsl:call-template name="createTextField">
								<xsl:with-param name="id" select="'toValue'" />
								<xsl:with-param name="name">toValue<xsl:value-of select="$rowID"/></xsl:with-param>
								<xsl:with-param name="value"><xsl:value-of select="$toValue"/></xsl:with-param>
								<xsl:with-param name="type" select="'number'"/>
							</xsl:call-template>
						</td>
						<td>
							<a class="btn btn-red vertical-align-middle" href="#" onclick="removeTableRowForWeightInterval(this);">
								<xsl:value-of select="$i18n.deleteRow"/>
							</a>
						</td>
					</xsl:when>
					<xsl:otherwise>
						<td><input name="rowID" hidden="true" value="{$rowID}" disabled="true"/></td>
						<td>
							
							<xsl:call-template name="createTextField">
								<xsl:with-param name="id" select="'fromValue'" />
								<xsl:with-param name="name">fromValue<xsl:value-of select="$rowID"/></xsl:with-param>
								<xsl:with-param name="type" select="'number'"/>
								<xsl:with-param name="disabled" select="'true'"/>
							</xsl:call-template>
						</td>
						<td>
							<xsl:call-template name="createTextField">
								<xsl:with-param name="id" select="'toValue'" />
								<xsl:with-param name="name">toValue<xsl:value-of select="$rowID"/></xsl:with-param>
								<xsl:with-param name="type" select="'number'"/>
								<xsl:with-param name="disabled" select="'true'"/>
							</xsl:call-template>
						</td>
						<td>
							<a class="btn btn-red vertical-align-middle" href="#" onclick="removeTableRowForWeightInterval(this);">
								<xsl:value-of select="$i18n.deleteRow"/>
							</a>
						</td>
					</xsl:otherwise>
				</xsl:choose>
				
			</tr>
		
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'MissingIntervalValues']">
	
		<p class="error">
			<xsl:value-of select="$i18n.MissingIntervalValues" />
		</p>
		
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'WeightNameMissing']">
	
		<p class="error">
			<xsl:value-of select="$i18n.WeightNameMissing" />
		</p>
		
	</xsl:template>
	
	
	
	<xsl:template match="validationError[messageKey = 'FromValueBiggerThanToValue']">
	
		<p class="error">
			<xsl:value-of select="$i18n.FromValueBiggerThanToValue" />
		</p>
		
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'IntevalOverlapping']">
	
		<p class="error">
			<xsl:value-of select="$i18n.IntervalOverlapping" />
		</p>
		
	</xsl:template>
	
	
	
	<xsl:template match="fieldName">

		<xsl:variable name="fieldName" select="." />

		<xsl:choose>
			<xsl:when test="$fieldName = 'queryState'">
				<xsl:value-of select="$i18n.queryState" />
			</xsl:when>
			<xsl:when test="$fieldName = 'toValue'">
				<xsl:value-of select="$i18n.to" />
			</xsl:when>
			<xsl:when test="$fieldName = 'fromValue'">
				<xsl:value-of select="$i18n.from" />
			</xsl:when>
			<xsl:when test="$fieldName = 'weightType'">
				<xsl:value-of select="$i18n.weightType" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>
	
</xsl:stylesheet>