<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />

	<xsl:template match="Document">

		<div class="contentitem">

			<xsl:apply-templates select="UpdateSetAttributeFromWeightEvaluator" />
		</div>

	</xsl:template>

	<xsl:template match="UpdateSetAttributeFromWeightEvaluator">
		
		<h1>
			<xsl:value-of select="$i18n.UpdateEvaluatorDescriptor.title" />
			<xsl:text>&#x20;</xsl:text>
			<xsl:value-of select="SetAttributeFromWeightEvaluator/EvaluatorDescriptor/name" />
		</h1>

		<xsl:apply-templates select="validationException/validationError" />

		<form method="post" action="{/Document/requestinfo/uri}">

			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="SetAttributeFromWeightEvaluator" />
			</xsl:call-template>
		
			<div class="floatleft full bigmarginbottom">
	
				<label for="weightType" class="floatleft full">
					<xsl:value-of select="$i18n.weightType" />
					<span class="required">*</span>
				</label>
	
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'weightType'" />
						<xsl:with-param name="name" select="'weightType'" />
						<xsl:with-param name="element" select="SetAttributeFromWeightEvaluator" />
					</xsl:call-template>
				</div>
			</div>
				
			<label class="floatleft full">
				<xsl:value-of select="$i18n.weight.title" />
			</label>
			
			<div class="clearboth floatleft marginbottom">
				<xsl:value-of select="$i18n.weight.description" />
			</div>
			
			<div class="clearboth floatleft marginbottom twenty">
				<xsl:value-of select="$i18n.from" />
				<span class="required">*</span>
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'fromValue'" />
					<xsl:with-param name="name" select="'fromValue'" />
					<xsl:with-param name="element" select="SetAttributeFromWeightEvaluator" />
				</xsl:call-template>
			</div>
		
			<div class="clearboth floatleft marginbottom twenty">
				<xsl:value-of select="$i18n.to" />
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'toValue'" />
					<xsl:with-param name="name" select="'toValue'" />
					<xsl:with-param name="element" select="SetAttributeFromWeightEvaluator" />
				</xsl:call-template>
			</div>
			
			<label class="floatleft full">
				<xsl:value-of select="$i18n.attribute.title" />
			</label>
			
			<div class="clearboth floatleft marginbottom">
				<xsl:value-of select="$i18n.attribute.description" />
			</div>
			
			<div class="clearboth floatleft marginbottom thirty">
				<xsl:value-of select="$i18n.attributeName" />
				<span class="required">*</span>
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'attributeName'" />
					<xsl:with-param name="name" select="'attributeName'" />
					<xsl:with-param name="element" select="SetAttributeFromWeightEvaluator" />
				</xsl:call-template>
			</div>
		
			<div class="clearboth floatleft marginbottom thirty">
				<xsl:value-of select="$i18n.attributeValue" />
				<span class="required">*</span>
				<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'attributeValue'" />
					<xsl:with-param name="name" select="'attributeValue'" />
					<xsl:with-param name="element" select="SetAttributeFromWeightEvaluator" />
				</xsl:call-template>
			</div>
			
			<div class="floatright clearboth">
				<input type="submit" value="{$i18n.submit}" />
			</div>
			
		</form>
			
	</xsl:template>
	
	<xsl:template match="validationError[messageKey = 'FromValueBiggerThanToValue']">

		<p class="error">
			<xsl:value-of select="$i18n.FromValueBiggerThanToValue" />
		</p>
		
	</xsl:template>
	
	<xsl:template match="fieldName">

		<xsl:variable name="fieldName" select="." />

		<xsl:choose>
			<xsl:when test="$fieldName = 'weightType'">
				<xsl:value-of select="$i18n.weightType" />
			</xsl:when>
			<xsl:when test="$fieldName = 'toValue'">
				<xsl:value-of select="$i18n.to" />
			</xsl:when>
			<xsl:when test="$fieldName = 'fromValue'">
				<xsl:value-of select="$i18n.from" />
			</xsl:when>
			<xsl:when test="$fieldName = 'attributeName'">
				<xsl:value-of select="$i18n.attributeName" />
			</xsl:when>
			<xsl:when test="$fieldName = 'attributeValue'">
				<xsl:value-of select="$i18n.attributeValue" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>

</xsl:stylesheet>