<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1"/>
	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl"/>
	<xsl:variable name="globalscripts">
		/jquery/jquery.js?v=1
	</xsl:variable>
	<xsl:variable name="scripts">
		/js/setweightbyflowinstancestatus.js
	</xsl:variable>
	<xsl:template match="Document">
		<div class="contentitem">
			<xsl:apply-templates select="UpdateSetWeightByFlowInstanceStatusEvaluator"/>
		</div>
	</xsl:template>
	<xsl:template match="UpdateSetWeightByFlowInstanceStatusEvaluator">
		<xsl:variable name="evaluator" select="SetWeightByFlowInstanceStatusEvaluator"/>
		<h1>
			<xsl:value-of select="$i18n.UpdateEvaluatorDescriptor.title"/>
			<xsl:text>&#x20;</xsl:text>
			<xsl:value-of select="$evaluator/EvaluatorDescriptor/name"/>
		</h1>
		<xsl:apply-templates select="validationException/validationError"/>
		<form method="post" action="{/Document/requestinfo/uri}">
			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="$evaluator"/>
			</xsl:call-template>
			<div class="floatleft full bigmarginbottom">
				<label for="weightType" class="floatleft full">
					<xsl:value-of select="$i18n.weightType"/>
					<span class="required">*</span>
				</label>
				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'weightType'"/>
						<xsl:with-param name="name" select="'weightType'"/>
						<xsl:with-param name="element" select="SetWeightByFlowInstanceStatusEvaluator"/>
					</xsl:call-template>
				</div>
			</div>
			<table style="display: none;">
				<tbody id="weightflowinstancestatustemplate">
				
				<xsl:call-template name="addWeightStatus">
					<xsl:with-param name="statusID">Template</xsl:with-param>
					<xsl:with-param name="disabled">true</xsl:with-param>
					<xsl:with-param name="name">Template</xsl:with-param>
					<xsl:with-param name="value">Template</xsl:with-param>
				</xsl:call-template>
				
				</tbody>
			</table>
			<div id="fromToDiv" class="floatleft sixty bigmarginbottom">
				<label class="floatleft full">
					<xsl:value-of select="$i18n.weight.title"/>
					<span class="required">*</span>
				</label>
				<div class="clearboth full floatleft marginbottom">
					<xsl:value-of select="$i18n.weight.description"/>
				</div>
				<div id="weightflowinstancestatusdiv">
					<table id="weightflowinstancestatus" class="floatleft">
				
					<thead>
					
						<tr>
							<th width="0"/>
							<th class="padding"><xsl:value-of select="$i18n.alternative"/></th>
							<th class="padding bigmarginleft"><xsl:value-of select="$i18n.weight"/></th>
							
						</tr>
						
					</thead>
						<tbody>
							<xsl:for-each select="Statuses/Status">
								
								<xsl:choose>
									<xsl:when test="../../requestparameters">
										<xsl:variable name="statusID" select="statusID"/>
										<xsl:variable name="weightname" select="concat('weight',$statusID)"/>
										<xsl:variable name="weight" select='../../requestparameters/parameter/name[text()=$weightname]/../value'/>
										<script>addNewStatusRow(<xsl:value-of select="$statusID"/>,'<xsl:value-of select="name"/>','<xsl:value-of select="$weight"/>');</script>
									</xsl:when>
									<xsl:otherwise>
										<xsl:variable name="statusID" select="statusID"/>
										<xsl:variable name="weight" select="../../SetWeightByFlowInstanceStatusEvaluator/setWeightByFlowInstanceStatusEvaluatorValueList/SetWeightByFlowInstanceStatusEvaluatorValues/statusID[text()=$statusID]/../weight"/>
										<script>addNewStatusRow(<xsl:value-of select="$statusID"/>,'<xsl:value-of select="name"/>','<xsl:value-of select="$weight"/>');</script>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:for-each>
						</tbody>
					</table>
				</div>
			</div>
			<div class="floatright clearboth">
				<input type="submit" value="{$i18n.submit}"/>
			</div>
		</form>
	</xsl:template>
	<xsl:template name="addWeightStatus">
		<xsl:param name="statusID"/>
		<xsl:param name="name"/>
		<xsl:param name="value"/>
		<xsl:param name="disabled"/>
		<tr>
		<xsl:choose>
			<xsl:when test="not($disabled)">
				<td><input name="statusID{$statusID}" hidden="true" value="{$statusID}"/></td>
				<td><label name="statusName{$statusID}">
					<xsl:value-of select="$name"/>
				</label></td>
				<td><xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'value'"/>
					<xsl:with-param name="name">weight<xsl:value-of select="$statusID"/>
					</xsl:with-param>
					<xsl:with-param name="value">
						<xsl:value-of select="$value"/>
					</xsl:with-param>
					<xsl:with-param name="type" select="'number'"/>
					<xsl:with-param name="width" select="'80%'"/>
				</xsl:call-template>
				</td>
			</xsl:when>
			<xsl:otherwise>
				<td><input name="statusID{$statusID}" hidden="true" value="{$statusID}" disabled="true"/></td>
				<td><label name="statusName{$statusID}">
					<xsl:value-of select="$name"/>
				</label></td>
				<td>
					<xsl:call-template name="createTextField">
					<xsl:with-param name="id" select="'value'"/>
					<xsl:with-param name="name">weight<xsl:value-of select="$statusID"/>
					</xsl:with-param>
					<xsl:with-param name="value">
						<xsl:value-of select="$value"/>
					</xsl:with-param>
					<xsl:with-param name="type" select="'number'"/>
					<xsl:with-param name="disabled" select="'true'"/>
					<xsl:with-param name="width" select="'80%'"/>
				</xsl:call-template>
				</td>
			</xsl:otherwise>
		</xsl:choose>
		</tr>
	</xsl:template>
	<xsl:template match="validationError[messageKey = 'MissingStatusValues']">
		<p class="error">
			<xsl:value-of select="$i18n.MissingStatusValues"/>
		</p>
	</xsl:template>
	<xsl:template match="validationError[messageKey = 'WeightNameMissing']">
		<p class="error">
			<xsl:value-of select="$i18n.WeightNameMissing"/>
		</p>
	</xsl:template>
	<xsl:template match="fieldName">
		<xsl:variable name="fieldName" select="."/>
		<xsl:choose>
			<xsl:when test="$fieldName = 'queryState'">
				<xsl:value-of select="$i18n.queryState"/>
			</xsl:when>
			<xsl:when test="$fieldName = 'toValue'">
				<xsl:value-of select="$i18n.to"/>
			</xsl:when>
			<xsl:when test="$fieldName = 'fromValue'">
				<xsl:value-of select="$i18n.from"/>
			</xsl:when>
			<xsl:when test="$fieldName = 'weightType'">
				<xsl:value-of select="$i18n.weightType"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>