package com.nordicpeak.flowengine.evaluators.setweightbyflowinstancestatus;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import se.unlogic.standardutils.annotations.WebPopulate;
import se.unlogic.standardutils.collections.CollectionUtils;
import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLParser;
import se.unlogic.standardutils.xml.XMLParserPopulateable;

@Table(name = "set_weight_by_flow_instance_status_evaluators_values")
@XMLElement
public class SetWeightByFlowInstanceStatusEvaluatorValues extends GeneratedElementable implements XMLParserPopulateable, Serializable {

	private static final long serialVersionUID = 3417430939090738323L;

	@DAOManaged
	@Key
	@WebPopulate(required = true)
	@XMLElement
	private Integer statusID;

	@DAOManaged
	@WebPopulate
	@XMLElement
	private Integer weight;

	
	@DAOManaged(columnName = "evaluatorID")
	@ManyToOne
	private SetWeightByFlowInstanceStatusEvaluator weightQueryStateEvaluator;
	
	public Integer getWeight() {

		return weight;
	}

	public void setWeight(Integer weight) {

		this.weight = weight;
	}

	public Integer getStatusID() {

		return statusID;
	}

	public void setStatusID(Integer statusID) {

		this.statusID = statusID;
	}

	
	public SetWeightByFlowInstanceStatusEvaluator getWeightQueryStateEvaluator() {
	
		return weightQueryStateEvaluator;
	}

	
	public void setWeightQueryStateEvaluator(SetWeightByFlowInstanceStatusEvaluator weightQueryStateEvaluator) {
	
		this.weightQueryStateEvaluator = weightQueryStateEvaluator;
	}

	@Override
	public void populate(XMLParser xmlParser) throws ValidationException {

		List<ValidationError> validationErrors = new ArrayList<>();
		
		statusID = xmlParser.getInteger("statusID");

		weight = xmlParser.getInteger("weight");
		
		if(statusID == null) {
			validationErrors.add(new ValidationError("StatusIDNotSet"));
		}
		
		if(!CollectionUtils.isEmpty(validationErrors)) {
			throw new ValidationException(validationErrors);
		}

	}
}
