<?xml version="1.0" encoding="ISO-8859-1" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0" encoding="ISO-8859-1" />

	<xsl:include href="classpath://se/unlogic/hierarchy/core/utils/xsl/Common.xsl" />

	<xsl:template match="Document">

		<div class="contentitem">

			<xsl:apply-templates select="UpdateSetWeightByMunicipalityCodeEvaluator" />
		</div>

	</xsl:template>

	<xsl:template match="UpdateSetWeightByMunicipalityCodeEvaluator">

		<h1>
			<xsl:value-of select="$i18n.UpdateEvaluatorDescriptor.title" />
			<xsl:text>&#x20;</xsl:text>
			<xsl:value-of select="SetWeightByMunicipalityCodeEvaluator/EvaluatorDescriptor/name" />
		</h1>

		<xsl:apply-templates select="validationException/validationError" />

		<form method="post" action="{/Document/requestinfo/uri}">

			<xsl:call-template name="createCommonFieldsForm">
				<xsl:with-param name="element" select="SetWeightByMunicipalityCodeEvaluator" />
			</xsl:call-template>

			<div class="floatleft full bigmarginbottom">

				<label for="weightType" class="floatleft full">
					<xsl:value-of select="$i18n.weightType" />
					<span class="required">*</span>
				</label>

				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'weightType'" />
						<xsl:with-param name="name" select="'weightType'" />
						<xsl:with-param name="element" select="SetWeightByMunicipalityCodeEvaluator" />
					</xsl:call-template>
				</div>
			</div>

			<div class="floatleft full bigmarginbottom">

				<label for="weight" class="floatleft full">
					<xsl:value-of select="$i18n.weight" />
					<span class="required">*</span>
				</label>

				<div class="floatleft full">
					<xsl:call-template name="createTextField">
						<xsl:with-param name="id" select="'weight'" />
						<xsl:with-param name="name" select="'weight'" />
						<xsl:with-param name="element" select="SetWeightByMunicipalityCodeEvaluator" />
					</xsl:call-template>
				</div>
			</div>			

		<div class="floatleft full bigmarginbottom">

			<label for="weightType" class="floatleft full">
				<xsl:value-of select="$i18n.MunicipalityCodes" />
				<xsl:text> </xsl:text>
				<xsl:value-of select="$i18n.MunicipalityCode.format" />
				<span class="required">*</span>
			</label>

			<div class="floatleft full">
				<xsl:call-template name="createTextArea">
					<xsl:with-param name="id" select="'allowedMunicipalityCodes'" />
					<xsl:with-param name="name" select="'allowedMunicipalityCodes'" />
					<xsl:with-param name="element" select="SetWeightByMunicipalityCodeEvaluator/AllowedMunicipalityCodes/MunicipalityCode" />
					<xsl:with-param name="separateListValues" select="'true'"/>
				</xsl:call-template>
			</div>
		</div>
			
		<div class="floatleft full">
	
			<label>
				<xsl:value-of select="$i18n.Inclusive.title" />
			</label>
			
			<br/>
			
			<xsl:value-of select="$i18n.Inclusive.description" />
		</div>	
			
		<div class="floatleft full marginbottom">

			<div class="floatleft full">
				<xsl:call-template name="createRadio">
					<xsl:with-param name="id" select="'inclusive'" />
					<xsl:with-param name="name" select="'inclusive'" />
					<xsl:with-param name="value" select="'true'" />
					<xsl:with-param name="element" select="SetWeightByMunicipalityCodeEvaluator" />
				</xsl:call-template>

				<label for="inclusive">
					<xsl:value-of select="$i18n.Inclusive" />
				</label>
			</div>
		</div>

		<div class="floatleft full marginbottom">

			<div class="floatleft full">
				<xsl:call-template name="createRadio">
					<xsl:with-param name="id" select="'not-inclusive'" />
					<xsl:with-param name="name" select="'inclusive'" />
					<xsl:with-param name="value" select="'false'" />
					<xsl:with-param name="element" select="SetWeightByMunicipalityCodeEvaluator" />
				</xsl:call-template>

				<label for="not-inclusive">
					<xsl:value-of select="$i18n.NotInclusive" />
				</label>
			</div>
		</div>

			<div class="floatright clearboth">
				<input type="submit" value="{$i18n.submit}" />
			</div>

		</form>

	</xsl:template>

	<xsl:template match="fieldName">

		<xsl:variable name="fieldName" select="." />

		<xsl:choose>
			<xsl:when test="$fieldName = 'weightType'">
				<xsl:value-of select="$i18n.weightType" />
			</xsl:when>
			<xsl:when test="$fieldName = 'weight'">
				<xsl:value-of select="$i18n.weight" />
			</xsl:when>
			<xsl:when test="$fieldName = 'allowedMunicipalityCodes'">
				<xsl:value-of select="$i18n.MunicipalityCodes" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$fieldName" />
			</xsl:otherwise>
		</xsl:choose>

	</xsl:template>

</xsl:stylesheet>