package com.nordicpeak.flowengine.evaluators.setweightevaluator;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

import se.unlogic.standardutils.dao.annotations.DAOManaged;
import se.unlogic.standardutils.dao.annotations.Key;
import se.unlogic.standardutils.dao.annotations.ManyToOne;
import se.unlogic.standardutils.dao.annotations.Table;
import se.unlogic.standardutils.date.BigDecimalFlexibleTwoDecimalStringyfier;
import se.unlogic.standardutils.populators.LocaleIndependentBigDecimalPopulator;
import se.unlogic.standardutils.populators.NonNegativeStringIntegerPopulator;
import se.unlogic.standardutils.validation.ValidationError;
import se.unlogic.standardutils.validation.ValidationException;
import se.unlogic.standardutils.xml.GeneratedElementable;
import se.unlogic.standardutils.xml.XMLElement;
import se.unlogic.standardutils.xml.XMLParser;
import se.unlogic.standardutils.xml.XMLParserPopulateable;
import se.unlogic.standardutils.xml.XMLValidationUtils;

@Table(name = "set_weight_evaluator_alternative_weights")
@XMLElement
public class AlternativeWeight extends GeneratedElementable implements Serializable, XMLParserPopulateable {

	private static final long serialVersionUID = 6322279274170019554L;

	@DAOManaged(columnName = "evaluatorID")
	@ManyToOne
	@Key
	private SetWeightEvaluator evaluator;

	@DAOManaged
	@XMLElement
	@Key
	private Integer alternativeID;

	@DAOManaged
	@XMLElement(valueFormatter = BigDecimalFlexibleTwoDecimalStringyfier.class)
	private BigDecimal weight;

	public SetWeightEvaluator getEvaluator() {

		return evaluator;
	}

	public void setEvaluator(SetWeightEvaluator setWeightEvaluator) {

		this.evaluator = setWeightEvaluator;
	}

	public Integer getAlternativeID() {

		return alternativeID;
	}

	public void setAlternativeID(Integer alternativeID) {

		this.alternativeID = alternativeID;
	}

	public BigDecimal getWeight() {

		return weight;
	}

	public void setWeight(BigDecimal weight) {

		this.weight = weight;
	}

	@Override
	public void populate(XMLParser xmlParser) throws ValidationException {

		List<ValidationError> errors = new ArrayList<ValidationError>();
		
		alternativeID = XMLValidationUtils.validateParameter("alternativeID", xmlParser, true, NonNegativeStringIntegerPopulator.getPopulator(), errors);
		weight = XMLValidationUtils.validateParameter("weight", xmlParser, true, LocaleIndependentBigDecimalPopulator.getPopulator(), errors);

		if(!errors.isEmpty()){

			throw new ValidationException(errors);
		}
	}
}
