package com.nordicpeak.flowengine.evaluators.setweightevaluator;

import java.math.BigDecimal;

import se.unlogic.hierarchy.core.interfaces.attributes.MutableAttributeHandler;

public class SetWeightEvaluationEvent {

	private final Integer sourceID;

	private final String weightType;

	private final BigDecimal weight;

	private final MutableAttributeHandler attributeHandler;

	public SetWeightEvaluationEvent(Integer sourceID, String weightType, BigDecimal weight, MutableAttributeHandler attributeHandler) {

		super();
		this.sourceID = sourceID;
		this.weightType = weightType;
		this.weight = weight;
		this.attributeHandler = attributeHandler;
	}

	public Integer getSourceID() {

		return sourceID;
	}

	public String getWeightType() {

		return weightType;
	}

	public BigDecimal getWeight() {

		return weight;
	}

	public MutableAttributeHandler getAttributeHandler() {

		return attributeHandler;
	}

	@Override
	public String toString() {

		return "SetWeightEvaluationEvent [sourceID=" + sourceID + ", weightType=" + weightType + ", weight=" + weight + "]";
	}
}
